/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Event\\EventUtil.ts":
/*!***********************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\Event\EventUtil.ts ***!
  \***********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.parseEventString = exports.obtainStartAbility = exports.obtainLocalEvent = exports.PUBLISH_COMMON_EVENT = exports.START_ABILITY_EVENT = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
exports.START_ABILITY_EVENT = "startAbilityEvent";
exports.PUBLISH_COMMON_EVENT = "publishCommonEvent";
const TAG = "EventUtil";
const LOCAL_EVENT_TYPE = "local";
const START_ABILITY_TYPE = "ability";
function obtainLocalEvent(event, args) {
    return {
        target: LOCAL_EVENT_TYPE,
        data: {
            eventName: event,
            args,
        },
    };
}
exports.obtainLocalEvent = obtainLocalEvent;
function obtainStartAbility(bundleName, abilityName, args) {
    return {
        target: START_ABILITY_TYPE,
        data: {
            bundleName,
            abilityName,
            args
        },
    };
}
exports.obtainStartAbility = obtainStartAbility;
function parseEventString(eventString) {
    // string must be "local=eventName|args" or "ability=bundleName|abilityName"
    if (!eventString) {
        return;
    }
    let [eventType, eventData] = eventString.split("=");
    if (eventType == LOCAL_EVENT_TYPE && eventData) {
        let [localEventName, args] = eventData.split("|");
        if (localEventName) {
            Log_1.default.showDebug(TAG, `parseEventData name:${localEventName}, args: ${args}`);
            return obtainLocalEvent(localEventName, args);
        }
    }
    if (eventType == START_ABILITY_TYPE && eventData) {
        let [bundleName, abilityName] = eventData.split("|");
        if (bundleName && abilityName) {
            Log_1.default.showDebug(TAG, `parseEventData bundleName:${bundleName}, abilityName: ${abilityName}`);
            return obtainStartAbility(bundleName, abilityName);
        }
    }
    Log_1.default.showError(TAG, `Can't parse event data: ${eventString}`);
    return undefined;
}
exports.parseEventString = parseEventString;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts":
/*!***********************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\Log.ts ***!
  \***********************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.filterKey = void 0;
const TAG = "SystemUI_Default";
const FILTER_KEYS = [
    new RegExp('hide', "gi")
];
function filterKey(target, propKey, descriptor) {
    const original = descriptor.value;
    descriptor.value = function (...args) {
        let filterResult = args.map((str) => {
            let tempStr = str;
            FILTER_KEYS.forEach((filterKey) => tempStr = tempStr.replace(filterKey, "**"));
            return tempStr;
        });
        const result = original.call(this, ...filterResult);
        return result;
    };
}
exports.filterKey = filterKey;
/**
 * Basic log class
 */
class Log {
    /**
     * print info level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showInfo(tag, log) {
        console.info(`${TAG} tag: ${tag} --> ${log}`);
    }
    /**
     * print debug level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showDebug(tag, log) {
        console.debug(`${TAG} tag: ${tag} --> ${log}`);
    }
    /**
     * print error level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showError(tag, log) {
        console.error(`${TAG} tag: ${tag} --> ${log}`);
    }
}
exports["default"] = Log;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\log.ts":
/*!***********************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\log.ts ***!
  \***********************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.filterKey = void 0;
const TAG = "SystemUI_Default";
const FILTER_KEYS = [
    new RegExp('hide', "gi")
];
function filterKey(target, propKey, descriptor) {
    const original = descriptor.value;
    descriptor.value = function (...args) {
        let filterResult = args.map((str) => {
            let tempStr = str;
            FILTER_KEYS.forEach((filterKey) => tempStr = tempStr.replace(filterKey, "**"));
            return tempStr;
        });
        const result = original.call(this, ...filterResult);
        return result;
    };
}
exports.filterKey = filterKey;
/**
 * Basic log class
 */
class Log {
    /**
     * print info level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showInfo(tag, log) {
        console.info(`${TAG} tag: ${tag} --> ${log}`);
    }
    /**
     * print debug level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showDebug(tag, log) {
        console.debug(`${TAG} tag: ${tag} --> ${log}`);
    }
    /**
     * print error level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showError(tag, log) {
        console.error(`${TAG} tag: ${tag} --> ${log}`);
    }
}
exports["default"] = Log;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\BundleParseUtil.ts":
/*!***************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\common\BundleParseUtil.ts ***!
  \***************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.registerBundleListener = exports.filterAbilityInfo = exports.queryAbility = exports.BundleEventType = void 0;
var bundleManager = globalThis.requireNapi('bundle') || (isSystemplugin('bundle', 'ohos') ? globalThis.ohosplugin.bundle : isSystemplugin('bundle', 'system') ? globalThis.systemplugin.bundle : undefined);
__webpack_require__(/*! bundle/extensionAbilityInfo */ "../../api/bundle/extensionAbilityInfo.d.ts");
var commonEvent = globalThis.requireNapi('commonEvent') || (isSystemplugin('commonEvent', 'ohos') ? globalThis.ohosplugin.commonEvent : isSystemplugin('commonEvent', 'system') ? globalThis.systemplugin.commonEvent : undefined);
__webpack_require__(/*! bundle/abilityInfo */ "../../api/bundle/abilityInfo.d.ts");
const Log_1 = __importDefault(__webpack_require__(/*! ../../default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
var BundleEventType;
(function (BundleEventType) {
    BundleEventType[BundleEventType["BUNDLE_ADD"] = 0] = "BUNDLE_ADD";
    BundleEventType[BundleEventType["BUNDLE_CHANGE"] = 1] = "BUNDLE_CHANGE";
    BundleEventType[BundleEventType["BUNDLE_REMOVE"] = 2] = "BUNDLE_REMOVE";
    BundleEventType[BundleEventType["UNKNOWN_EVENT"] = 3] = "UNKNOWN_EVENT";
})(BundleEventType = exports.BundleEventType || (exports.BundleEventType = {}));
const TAG = "SourceLoader-BundleParseUtil";
const DEFAULT_BUNDLE_FLAG = bundleManager.BundleFlag.GET_ABILITY_INFO_WITH_METADATA | bundleManager.BundleFlag.GET_ABILITY_INFO_WITH_PERMISSION;
const BUNDLE_SUBSCRIBE_INFO = {
    events: [
        commonEvent.Support.COMMON_EVENT_PACKAGE_ADDED,
        commonEvent.Support.COMMON_EVENT_PACKAGE_REMOVED,
        commonEvent.Support.COMMON_EVENT_PACKAGE_CHANGED,
    ],
};
async function queryAbility(action, userId, bundleName) {
    Log_1.default.showInfo(TAG, `queryAbility, action: ${action} , userId: ${userId}`);
    if (bundleName) {
        Log_1.default.showInfo(TAG, `queryAbility, bundleName: ${bundleName}`);
        let abilitys = [];
        try {
            abilitys = await bundleManager.queryAbilityByWant({
                action: action,
                bundleName: bundleName,
            }, DEFAULT_BUNDLE_FLAG, userId);
        }
        catch (error) {
            Log_1.default.showInfo(TAG, `queryAbility, queryAbilityByWant error: ${JSON.stringify(error)}`);
        }
        let extensionAbilitys = [];
        try {
            extensionAbilitys = await bundleManager.queryExtensionAbilityInfosByWant({
                action: action,
                bundleName: bundleName,
            }, DEFAULT_BUNDLE_FLAG, userId);
        }
        catch (error) {
            Log_1.default.showInfo(TAG, `queryAbility, queryExtensionAbilityInfosByWant error: ${JSON.stringify(error)}`);
        }
        Log_1.default.showInfo(TAG, `queryAbility, end`);
        let rets = [...abilitys, ...extensionAbilitys];
        Log_1.default.showInfo(TAG, `queryAbility, rets: ${JSON.stringify(rets)}`);
        return rets;
    }
    let abilitys = [];
    try {
        abilitys = await bundleManager.queryAbilityByWant({ action: action }, DEFAULT_BUNDLE_FLAG, userId);
    }
    catch (error) {
        Log_1.default.showInfo(TAG, `queryAbility, queryAbilityByWant error: ${JSON.stringify(error)}`);
    }
    let extensionAbilitys = [];
    try {
        extensionAbilitys = await bundleManager.queryExtensionAbilityInfosByWant({ action: action }, DEFAULT_BUNDLE_FLAG, userId);
    }
    catch (error) {
        Log_1.default.showInfo(TAG, `queryAbility, queryExtensionAbilityInfosByWant error: ${JSON.stringify(error)}`);
    }
    Log_1.default.showInfo(TAG, `queryAbility, end`);
    let rets = [...abilitys, ...extensionAbilitys];
    Log_1.default.showInfo(TAG, `queryAbility, rets: ${JSON.stringify(rets)}`);
    return rets;
}
exports.queryAbility = queryAbility;
function filterAbilityInfo(info, filterKey) {
    Log_1.default.showInfo(TAG, `filterAbilityInfo, info: ${JSON.stringify(info)} filterKey: ${filterKey}`);
    let pluginDatas = [];
    if (info.metaData && info.metaData.length) {
        pluginDatas = info.metaData.filter((data) => data.name == filterKey);
    }
    else if (info.metadata && info.metadata.length) {
        pluginDatas = info.metadata.filter((data) => data.name == filterKey);
    }
    Log_1.default.showInfo(TAG, `filterAbilityInfo, pluginDatas: ${JSON.stringify(pluginDatas)}`);
    if (!pluginDatas.length) {
        Log_1.default.showDebug(TAG, `filterKey: ${filterKey}, metadata: ${JSON.stringify(info.metadata.values)}`);
        return undefined;
    }
    let pluginData;
    if (pluginDatas[0].value && pluginDatas[0].value.length > 0) {
        pluginData = JSON.parse("{" + pluginDatas[0].value + "}");
    }
    else if (pluginDatas[0].extra && pluginDatas[0].extra.length > 0) {
        pluginData = JSON.parse("{" + pluginDatas[0].extra + "}");
    }
    if (!pluginData) {
        Log_1.default.showError(TAG, `Can't parse pluginData: ${pluginDatas[0]}, filterKey: ${filterKey}`);
        return undefined;
    }
    Log_1.default.showInfo(TAG, `filterAbilityInfo, pluginData: ${JSON.stringify(pluginData)}`);
    return pluginData;
}
exports.filterAbilityInfo = filterAbilityInfo;
function registerBundleListener(listener, callback) {
    commonEvent.createSubscriber(BUNDLE_SUBSCRIBE_INFO, (err, handle) => {
        Log_1.default.showDebug(TAG, `registerBundleListener, err: ${JSON.stringify(err)}, handle: ${handle}`);
        if (err.code != 0) {
            Log_1.default.showError(TAG, `Can't regitser bundle subscribe, err: ${JSON.stringify(err)}`);
            return;
        }
        commonEvent.subscribe(handle, (err, data) => {
            var _a;
            Log_1.default.showDebug(TAG, `bundle change, err: ${JSON.stringify(err)} data: ${JSON.stringify(data)}`);
            if (err.code != 0) {
                Log_1.default.showError(TAG, `Can't handle bundle change, err: ${JSON.stringify(err)}`);
                return;
            }
            let event = BundleEventType.UNKNOWN_EVENT;
            switch (data.event) {
                case commonEvent.Support.COMMON_EVENT_PACKAGE_ADDED:
                    event = BundleEventType.BUNDLE_ADD;
                    break;
                case commonEvent.Support.COMMON_EVENT_PACKAGE_CHANGED:
                    event = BundleEventType.BUNDLE_CHANGE;
                    break;
                case commonEvent.Support.COMMON_EVENT_PACKAGE_REMOVED:
                    event = BundleEventType.BUNDLE_REMOVE;
                    break;
                default:
                    Log_1.default.showError(TAG, `unknow event: ${event}`);
            }
            listener.onBundleNotify((_a = data.bundleName) !== null && _a !== void 0 ? _a : "unkown", event);
        });
        callback({
            unRegister: () => {
                commonEvent.unsubscribe(handle, () => {
                    Log_1.default.showInfo(TAG, `unRegister bundle info listener, handle: ${handle}`);
                });
            },
        });
    });
}
exports.registerBundleListener = registerBundleListener;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts":
/*!*********************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\common\Constants.ts ***!
  \*********************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ActionData = exports.obtainMsg = exports.PluginType = void 0;
__webpack_require__(/*! ../../default/Event/EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Event\\EventUtil.ts");
class Constants {
}
exports["default"] = Constants;
Constants.INIT_CONFIG = "initConfig";
Constants.INIT_FINISH = "initFinish";
Constants.CLEAR_ALL = "clearAll";
Constants.ADD_ITEM = "addItem";
Constants.REMOVE_ITEM = "removeItem";
Constants.LOCAL_DEVICE = "local";
Constants.LOAD_DATA = "loadData";
var PluginType;
(function (PluginType) {
    PluginType[PluginType["META"] = 1] = "META";
    PluginType[PluginType["DATA_ABILITY"] = 2] = "DATA_ABILITY";
    PluginType[PluginType["PLUGIN_COMPONENT"] = 3] = "PLUGIN_COMPONENT";
})(PluginType = exports.PluginType || (exports.PluginType = {}));
function obtainMsg(action, data) {
    return { action: action, data: data };
}
exports.obtainMsg = obtainMsg;
class ActionData {
}
exports.ActionData = ActionData;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\constants.ts":
/*!*********************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\common\constants.ts ***!
  \*********************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ActionData = exports.obtainMsg = exports.PluginType = void 0;
__webpack_require__(/*! ../../default/Event/EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Event\\EventUtil.ts");
class Constants {
}
exports["default"] = Constants;
Constants.INIT_CONFIG = "initConfig";
Constants.INIT_FINISH = "initFinish";
Constants.CLEAR_ALL = "clearAll";
Constants.ADD_ITEM = "addItem";
Constants.REMOVE_ITEM = "removeItem";
Constants.LOCAL_DEVICE = "local";
Constants.LOAD_DATA = "loadData";
var PluginType;
(function (PluginType) {
    PluginType[PluginType["META"] = 1] = "META";
    PluginType[PluginType["DATA_ABILITY"] = 2] = "DATA_ABILITY";
    PluginType[PluginType["PLUGIN_COMPONENT"] = 3] = "PLUGIN_COMPONENT";
})(PluginType = exports.PluginType || (exports.PluginType = {}));
function obtainMsg(action, data) {
    return { action: action, data: data };
}
exports.obtainMsg = obtainMsg;
class ActionData {
}
exports.ActionData = ActionData;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\plugindatasourcemanager.ts":
/*!****************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\plugindatasourcemanager.ts ***!
  \****************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Log_1 = __importDefault(__webpack_require__(/*! ../default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const SourceLoaderFactory_1 = __importDefault(__webpack_require__(/*! ./sourceloader/SourceLoaderFactory */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\SourceLoaderFactory.ts"));
const SourceLoader_1 = __importDefault(__webpack_require__(/*! ./sourceloader/SourceLoader */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\SourceLoader.ts"));
__webpack_require__(/*! ./common/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts");
const BundleParseUtil_1 = __webpack_require__(/*! ./common/BundleParseUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\BundleParseUtil.ts");
__webpack_require__(/*! bundle/abilityInfo */ "../../api/bundle/abilityInfo.d.ts");
__webpack_require__(/*! bundle/extensionAbilityInfo */ "../../api/bundle/extensionAbilityInfo.d.ts");
const TAG = "PluginDataSourceManager";
const INVALID_USERID = -1;
class PluginDataSourceManager {
    constructor(listener) {
        this.mAction = "";
        this.mUserId = INVALID_USERID;
        this.mListenerHandle = undefined;
        this.mFilterDatas = new Map();
        this.mLoaders = new Map();
        this.mFactory = new SourceLoaderFactory_1.default({
            add: listener.onItemAdd,
            remove: listener.onItemRemove,
        });
    }
    initDataSource(configs) {
        Log_1.default.showInfo(TAG, `initDataSource, configs: ${JSON.stringify(configs)}`);
        this.mAction = configs.action;
        configs.filterDatas.forEach((data) => this.mFilterDatas.set(data.abilityName, data.id));
        for (let pluginType in configs.loaderConfig) {
            const sourceLoader = this.mFactory.getSourceLoader(pluginType, configs.loaderConfig[pluginType]);
            if (sourceLoader instanceof SourceLoader_1.default) {
                this.mLoaders.set(pluginType, sourceLoader);
                Log_1.default.showInfo(TAG, `getSourceLoader plugin: ${pluginType}, loader${this.mLoaders.get(pluginType)}`);
            }
        }
        Log_1.default.showInfo(TAG, `action:${this.mAction}, filterData: ${JSON.stringify(this.mFilterDatas)}`);
        BundleParseUtil_1.registerBundleListener(this, (handle) => {
            this.mListenerHandle = handle;
        });
    }
    async onBundleNotify(bundleName, event) {
        Log_1.default.showInfo(TAG, `onBundleNotify, bundleName: ${bundleName}, event: ${event}`);
        if (event == BundleParseUtil_1.BundleEventType.BUNDLE_CHANGE || event == BundleParseUtil_1.BundleEventType.BUNDLE_REMOVE) {
            this.mLoaders.forEach((loader) => loader.onBundleRemove(bundleName));
        }
        if (event == BundleParseUtil_1.BundleEventType.BUNDLE_CHANGE || event == BundleParseUtil_1.BundleEventType.BUNDLE_ADD) {
            let abilityInfos = await BundleParseUtil_1.queryAbility(this.mAction, this.mUserId, bundleName);
            Log_1.default.showInfo(TAG, `abilityInfos: ${JSON.stringify(abilityInfos)}`);
            abilityInfos.forEach((info) => this.notifyAbilityAdd(info));
        }
    }
    clearAll() {
        Log_1.default.showInfo(TAG, `clearAll`);
        this.unregisterListener();
        this.mLoaders.forEach((sourceLoader) => sourceLoader.clearData());
    }
    async loadData(userId) {
        Log_1.default.showInfo(TAG, `loadData, userId: ${userId}`);
        Log_1.default.showInfo(TAG, `loadData, this.mUserId: ${this.mUserId}`);
        if (this.mUserId != userId) {
            this.mUserId = userId;
            this.mLoaders.forEach((sourceLoader) => sourceLoader.clearData());
            let abilityInfos = await BundleParseUtil_1.queryAbility(this.mAction, this.mUserId);
            Log_1.default.showInfo(TAG, `loadData, abilityInfos: ${JSON.stringify(abilityInfos)}`);
            abilityInfos.forEach((info) => this.notifyAbilityAdd(info));
        }
        this.mLoaders.forEach((sourceLoader) => sourceLoader.reloadData(this.mUserId));
    }
    notifyAbilityAdd(info) {
        Log_1.default.showInfo(TAG, `notifyAbilityAdd, info: ${JSON.stringify(info)}`);
        let itemId = this.mFilterDatas.get(info.name);
        if (!itemId) {
            Log_1.default.showInfo(TAG, `notifyAbilityAdd, can't find itemId, ability:${info.name}`);
            return;
        }
        let abilityInfo = Object.assign(Object.assign({}, info), { itemId: itemId });
        if ((!abilityInfo.metaData || !abilityInfo.metaData.length) && (!abilityInfo.metadata || !abilityInfo.metadata.length)) {
            Log_1.default.showInfo(TAG, `Can't find metadata, abilityId: ${abilityInfo.name}`);
            return;
        }
        this.mLoaders.forEach((loader) => loader.onAbilityAdd(abilityInfo));
    }
    unregisterListener() {
        var _a;
        (_a = this.mListenerHandle) === null || _a === void 0 ? void 0 : _a.unRegister();
        this.mListenerHandle = undefined;
    }
}
exports["default"] = PluginDataSourceManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\DataAbilitySourceLoader.ts":
/*!*****************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\sourceloader\DataAbilitySourceLoader.ts ***!
  \*****************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Log_1 = __importDefault(__webpack_require__(/*! ../../default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../common/BundleParseUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\BundleParseUtil.ts");
__webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts");
const SourceLoader_1 = __importDefault(__webpack_require__(/*! ./SourceLoader */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\SourceLoader.ts"));
const TAG = "DataAbilitySourceLoader";
class DataAbilitySourceLoader extends SourceLoader_1.default {
    constructor(config) {
        super(config);
        Log_1.default.showInfo(TAG, `constructor`);
    }
    clearData() { }
    reloadData(userId) { }
    onAbilityAdd(abilityInfo) { }
    onBundleRemove(bundleName) { }
}
exports["default"] = DataAbilitySourceLoader;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\MetaSourceLoader.ts":
/*!**********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\sourceloader\MetaSourceLoader.ts ***!
  \**********************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Log_1 = __importDefault(__webpack_require__(/*! ../../default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const SourceLoader_1 = __importDefault(__webpack_require__(/*! ./SourceLoader */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\SourceLoader.ts"));
const Constants_1 = __importStar(__webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts"));
const BundleParseUtil_1 = __webpack_require__(/*! ../common/BundleParseUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\BundleParseUtil.ts");
const EventUtil_1 = __webpack_require__(/*! ../../default/Event/EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Event\\EventUtil.ts");
const TAG = "MetaSourceLoader";
class MetaSourceLoader extends SourceLoader_1.default {
    constructor(config) {
        super(config);
        this.mPluginFilter = "";
        this.mPermission = "";
        this.mItemDatas = [];
        this.mPluginFilter = config.action;
        this.mPermission = config.permission;
        Log_1.default.showInfo(TAG, `init loader, mPluginFilter: ${this.mPluginFilter}, mPermission: ${this.mPermission}`);
    }
    onAbilityAdd(abilityInfo) {
        let pluginData = BundleParseUtil_1.filterAbilityInfo(abilityInfo, this.mPluginFilter);
        if (pluginData) {
            let itemData = parseData(abilityInfo, pluginData);
            if (!itemData) {
                return;
            }
            this.mItemDatas.push(itemData);
            this.addItem(itemData);
            Log_1.default.showInfo(TAG, `item[${itemData.id}] add success, name: ${abilityInfo.name}`);
            return;
        }
        Log_1.default.showDebug(TAG, `Can't filter ${abilityInfo.name}.`);
    }
    onBundleRemove(bundleName) {
        for (let i = this.mItemDatas.length - 1; i >= 0; i--) {
            if (bundleName == this.mItemDatas[i].bundleName) {
                Log_1.default.showDebug(TAG, `remove item index: ${i}, abilityname: ${this.mItemDatas[i].abilityName}`);
                this.removeItem(this.mItemDatas[i]);
                this.mItemDatas.splice(i, 1);
            }
        }
    }
    clearData() {
        Log_1.default.showDebug(TAG, `clear all, size: ${this.mItemDatas.length}`);
        this.mItemDatas.forEach((data) => this.removeItem(data));
        this.mItemDatas.length = 0;
    }
    reloadData(userId) {
        Log_1.default.showDebug(TAG, `reloadData userId: ${userId}`);
    }
}
exports["default"] = MetaSourceLoader;
function parseData(info, data) {
    let { label, pluginType, icon, template, clickAction, longClickAction, launchType } = data, extra = __rest(data, ["label", "pluginType", "icon", "template", "clickAction", "longClickAction", "launchType"]);
    if (pluginType.toString() != Constants_1.PluginType.META.toString()) {
        return undefined;
    }
    let itemData = {
        id: info.itemId,
        pluginType: Constants_1.PluginType.META,
        deviceId: Constants_1.default.LOCAL_DEVICE,
        bundleName: info.bundleName,
        abilityName: info.name,
        abilityLabelId: info.labelId,
        abilityIconId: info.iconId,
        label: label,
        iconUrl: icon,
        template: template,
        actionData: {
            clickAction: EventUtil_1.parseEventString(clickAction),
            longClickAction: EventUtil_1.parseEventString(longClickAction),
            launchType: launchType,
            extra: extra,
        },
    };
    return itemData;
}


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\PluginSourceLoader.ts":
/*!************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\sourceloader\PluginSourceLoader.ts ***!
  \************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Log_1 = __importDefault(__webpack_require__(/*! ../../default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../common/BundleParseUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\BundleParseUtil.ts");
__webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts");
const SourceLoader_1 = __importDefault(__webpack_require__(/*! ./SourceLoader */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\SourceLoader.ts"));
const TAG = "PluginSourceLoader";
class PluginSourceLoader extends SourceLoader_1.default {
    constructor(config) {
        super(config);
        Log_1.default.showInfo(TAG, `constructor`);
    }
    clearData() { }
    reloadData(userId) { }
    onAbilityAdd(abilityInfo) { }
    onBundleRemove(bundleName) { }
}
exports["default"] = PluginSourceLoader;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\SourceLoader.ts":
/*!******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\sourceloader\SourceLoader.ts ***!
  \******************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Log_1 = __importDefault(__webpack_require__(/*! ../../default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts");
__webpack_require__(/*! ../common/BundleParseUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\BundleParseUtil.ts");
const TAG = "SourceLoader";
class SourceLoader {
    constructor(config) {
        Log_1.default.showInfo(TAG, `constructor`);
    }
    setChannel(channel) {
        this.mChannel = channel;
    }
    addItem(itemData) {
        var _a;
        (_a = this.mChannel) === null || _a === void 0 ? void 0 : _a.add(itemData);
    }
    removeItem(itemData) {
        var _a;
        (_a = this.mChannel) === null || _a === void 0 ? void 0 : _a.remove(itemData);
    }
}
exports["default"] = SourceLoader;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\SourceLoaderFactory.ts":
/*!*************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\sourceloader\SourceLoaderFactory.ts ***!
  \*************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Log_1 = __importDefault(__webpack_require__(/*! ../../default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ./SourceLoader */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\SourceLoader.ts");
const DataAbilitySourceLoader_1 = __importDefault(__webpack_require__(/*! ./DataAbilitySourceLoader */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\DataAbilitySourceLoader.ts"));
const MetaSourceLoader_1 = __importDefault(__webpack_require__(/*! ./MetaSourceLoader */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\MetaSourceLoader.ts"));
const PluginSourceLoader_1 = __importDefault(__webpack_require__(/*! ./PluginSourceLoader */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\sourceloader\\PluginSourceLoader.ts"));
__webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts");
const TAG = "SourceLoaderFactory";
const classMap = {
    MetaSource: MetaSourceLoader_1.default,
    PluginSourceLoader: PluginSourceLoader_1.default,
    DataAbilitySourceLoader: DataAbilitySourceLoader_1.default,
};
class SourceLoaderFactory {
    constructor(channel) {
        Log_1.default.showInfo(TAG, `constructor, channel: ${channel}`);
        this.mChannel = channel;
    }
    getSourceLoader(pluginType, config) {
        let clz = classMap[pluginType];
        if (!clz) {
            Log_1.default.showError(TAG, `Can't find pluginType: ${pluginType}`);
            return null;
        }
        let loader = new clz(config);
        loader.setChannel(this.mChannel);
        return loader;
    }
}
exports["default"] = SourceLoaderFactory;


/***/ }),

/***/ "../../api/bundle/abilityInfo.d.ts":
/*!*****************************************!*\
  !*** ../../api/bundle/abilityInfo.d.ts ***!
  \*****************************************/
/***/ (() => {



/***/ }),

/***/ "../../api/bundle/extensionAbilityInfo.d.ts":
/*!**************************************************!*\
  !*** ../../api/bundle/extensionAbilityInfo.d.ts ***!
  \**************************************************/
/***/ (() => {



/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		var commonCachedModule = globalThis["__common_module_cache__"] ? globalThis["__common_module_cache__"][moduleId]: null;
/******/ 		if (commonCachedModule) { return commonCachedModule.exports; }
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		if (globalThis["__common_module_cache__"] && moduleId.indexOf("?name=") < 0 && Object.keys(globalThis["__common_module_cache__"]).indexOf(moduleId) >= 0) {
/******/ 		  globalThis["__common_module_cache__"][moduleId] = module;
/******/ 		}
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";
/*!***********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\product\phone\statusbar\src\main\ets\workers\PluginDataSourceWorker.js ***!
  \***********************************************************************************************************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../../../../../../common/src/main/ets/default/log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\log.ts");
/* harmony import */ var _common_src_main_ets_plugindatasource_plugindatasourcemanager__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../../../../../../common/src/main/ets/plugindatasource/plugindatasourcemanager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\plugindatasourcemanager.ts");
/* harmony import */ var _common_src_main_ets_plugindatasource_plugindatasourcemanager__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_common_src_main_ets_plugindatasource_plugindatasourcemanager__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _common_src_main_ets_plugindatasource_common_constants__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../../../../../../common/src/main/ets/plugindatasource/common/constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\constants.ts");
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var worker = globalThis.requireNapi('worker') || (isSystemplugin('worker', 'ohos') ? globalThis.ohosplugin.worker : isSystemplugin('worker', 'system') ? globalThis.systemplugin.worker : undefined);




const parentPort = worker.parentPort;
const TAG = `${parentPort.name} Worker`;
_common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showInfo(TAG, `Start.`);

var sManager;

parentPort.onmessage = (msg) => {
    _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showInfo(TAG, `onMessage, msg = ${JSON.stringify(msg)}`);
    let data = msg.data;
    switch (data.action) {
        case _common_src_main_ets_plugindatasource_common_constants__WEBPACK_IMPORTED_MODULE_2__["default"].INIT_CONFIG:
            initConfig(data.data);
            break;
        case _common_src_main_ets_plugindatasource_common_constants__WEBPACK_IMPORTED_MODULE_2__["default"].CLEAR_ALL:
            clearAll();
            break;
        case _common_src_main_ets_plugindatasource_common_constants__WEBPACK_IMPORTED_MODULE_2__["default"].LOAD_DATA:
            loadData(data.data);
            break;
        default:
            _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showError(TAG, `onMessage, unknown action type.`);
    }
};

function initConfig(config) {
    _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showInfo(TAG, `initConfig, config = ${JSON.stringify(config)}`);
    sManager = new (_common_src_main_ets_plugindatasource_plugindatasourcemanager__WEBPACK_IMPORTED_MODULE_1___default())({
        onItemAdd: (itemData) => {
            _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showInfo(TAG, `sManager.onItemAdd, itemData = ${JSON.stringify(itemData)}`);
            itemData.label && (itemData.label = encodeURIComponent(itemData.label));
            parentPort.postMessage((0,_common_src_main_ets_plugindatasource_common_constants__WEBPACK_IMPORTED_MODULE_2__.obtainMsg)(_common_src_main_ets_plugindatasource_common_constants__WEBPACK_IMPORTED_MODULE_2__["default"].ADD_ITEM, itemData));
        },
        onItemRemove: (itemData) => {
            _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showInfo(TAG, `sManager.onItemRemove, itemData = ${JSON.stringify(itemData)}`);
            parentPort.postMessage((0,_common_src_main_ets_plugindatasource_common_constants__WEBPACK_IMPORTED_MODULE_2__.obtainMsg)(_common_src_main_ets_plugindatasource_common_constants__WEBPACK_IMPORTED_MODULE_2__["default"].REMOVE_ITEM, itemData));
        },
    });
    sManager.initDataSource(config);
    parentPort.postMessage((0,_common_src_main_ets_plugindatasource_common_constants__WEBPACK_IMPORTED_MODULE_2__.obtainMsg)(_common_src_main_ets_plugindatasource_common_constants__WEBPACK_IMPORTED_MODULE_2__["default"].INIT_FINISH, {}));
}

function clearAll() {
    _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showInfo(TAG, `clearAll `);
    sManager?.clearAll();
}

function loadData(userId) {
    _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showInfo(TAG, `loadData `);
    sManager?.loadData(userId);
}

parentPort.onclose = function () {
    _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showInfo(TAG, `onclose`);
};

parentPort.onmessageerror = function () {
    _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showInfo(TAG, `onmessageerror`);
};

parentPort.onerror = function (data) {
    _common_src_main_ets_default_log__WEBPACK_IMPORTED_MODULE_0__["default"].showInfo(
        TAG,
        `onerror, lineno = ${data.lineno}, msg = ${data.message}, filename = ${data.filename}, col = ${data.colno}`
    );
};
})();

/******/ })()
;
//# sourceMappingURL=PluginDataSourceWorker.js.map