/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\CheckEmptyUtils.ts":
/*!***********************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\CheckEmptyUtils.ts ***!
  \***********************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
class CheckEmptyUtils {
    /**
       * Check obj is empty.
       *
       * @param {Object} obj need checked object
       * @return {boolean} true(empty)
       */
    static isEmpty(obj) {
        return (typeof obj === 'undefined' || obj === null || obj === '' || Object.keys(obj).length === 0);
    }
    /**
       * Check str is empty.
       *
       * @param {string} str need checked string
       * @return {boolean} true(empty)
       */
    static checkStrIsEmpty(str) {
        return str.trim().length === 0;
    }
    /**
       * Check array is empty.
       *
       * @param {Array} arr need checked array
       * @return {boolean} true(empty)
       */
    static isEmptyArr(arr) {
        return arr.length === 0;
    }
}
exports["default"] = CheckEmptyUtils;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts":
/*!*****************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\Constants.ts ***!
  \*****************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.FASlotName = exports.WindowNameMap = void 0;
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
exports.WindowNameMap = {
    2112: 'navigation',
    2108: 'status',
    2111: 'volume'
};
;
class Constants {
}
exports["default"] = Constants;
Constants.URI_VAR = 'dataability:///com.ohos.settingsdata.DataAbility';
var FASlotName;
(function (FASlotName) {
    FASlotName["AUTO_ROTATE"] = "auto_rotate";
    FASlotName["AIR_PLANE"] = "air_plane";
    FASlotName["BATTERY"] = "battery";
    FASlotName["BLUETOOTH"] = "bluetooth";
    FASlotName["CAPSULE"] = "capsule";
    FASlotName["CLOCK"] = "clock";
    FASlotName["EMPTY"] = "empty";
    FASlotName["LOCATION"] = "location";
    FASlotName["NOTIFICATION"] = "notification";
    FASlotName["RING_MODE"] = "ring_mode";
    FASlotName["SIGNAL"] = "signal";
    FASlotName["WIFI"] = "wifi";
})(FASlotName = exports.FASlotName || (exports.FASlotName = {}));


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Decorators.ts":
/*!******************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\Decorators.ts ***!
  \******************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.throttle = exports.debounce = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ./Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const TAG = "Decorators";
function debounce(timeout) {
    return function inner(target, propKey, descriptor) {
        let curFunc = 0;
        const original = descriptor.value;
        descriptor.value = function (...args) {
            Log_1.default.showInfo(TAG, `debounce invoke ${propKey} curFunc: ${curFunc}`);
            curFunc && clearTimeout(curFunc);
            curFunc = setTimeout(() => original.call(this, ...args), timeout);
        };
    };
}
exports.debounce = debounce;
function throttle(waitTime) {
    return function inner(target, propKey, descriptor) {
        let lastTime = 0;
        const original = descriptor.value;
        descriptor.value = function (...args) {
            let curTime = Date.now();
            Log_1.default.showInfo(TAG, `throttle invoke ${propKey} timeInterval: ${curTime - lastTime}`);
            if (curTime - lastTime >= waitTime) {
                original.call(this, ...args);
                lastTime = curTime;
            }
        };
    };
}
exports.throttle = throttle;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Event\\EventUtil.ts":
/*!***********************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\Event\EventUtil.ts ***!
  \***********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.parseEventString = exports.obtainStartAbility = exports.obtainLocalEvent = exports.PUBLISH_COMMON_EVENT = exports.START_ABILITY_EVENT = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
exports.START_ABILITY_EVENT = "startAbilityEvent";
exports.PUBLISH_COMMON_EVENT = "publishCommonEvent";
const TAG = "EventUtil";
const LOCAL_EVENT_TYPE = "local";
const START_ABILITY_TYPE = "ability";
function obtainLocalEvent(event, args) {
    return {
        target: LOCAL_EVENT_TYPE,
        data: {
            eventName: event,
            args,
        },
    };
}
exports.obtainLocalEvent = obtainLocalEvent;
function obtainStartAbility(bundleName, abilityName, args) {
    return {
        target: START_ABILITY_TYPE,
        data: {
            bundleName,
            abilityName,
            args
        },
    };
}
exports.obtainStartAbility = obtainStartAbility;
function parseEventString(eventString) {
    // string must be "local=eventName|args" or "ability=bundleName|abilityName"
    if (!eventString) {
        return;
    }
    let [eventType, eventData] = eventString.split("=");
    if (eventType == LOCAL_EVENT_TYPE && eventData) {
        let [localEventName, args] = eventData.split("|");
        if (localEventName) {
            Log_1.default.showDebug(TAG, `parseEventData name:${localEventName}, args: ${args}`);
            return obtainLocalEvent(localEventName, args);
        }
    }
    if (eventType == START_ABILITY_TYPE && eventData) {
        let [bundleName, abilityName] = eventData.split("|");
        if (bundleName && abilityName) {
            Log_1.default.showDebug(TAG, `parseEventData bundleName:${bundleName}, abilityName: ${abilityName}`);
            return obtainStartAbility(bundleName, abilityName);
        }
    }
    Log_1.default.showError(TAG, `Can't parse event data: ${eventString}`);
    return undefined;
}
exports.parseEventString = parseEventString;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts":
/*!***********************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\Log.ts ***!
  \***********************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.filterKey = void 0;
const TAG = "SystemUI_Default";
const FILTER_KEYS = [
    new RegExp('hide', "gi")
];
function filterKey(target, propKey, descriptor) {
    const original = descriptor.value;
    descriptor.value = function (...args) {
        let filterResult = args.map((str) => {
            let tempStr = str;
            FILTER_KEYS.forEach((filterKey) => tempStr = tempStr.replace(filterKey, "**"));
            return tempStr;
        });
        const result = original.call(this, ...filterResult);
        return result;
    };
}
exports.filterKey = filterKey;
/**
 * Basic log class
 */
class Log {
    /**
     * print info level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showInfo(tag, log) {
        console.info(`${TAG} tag: ${tag} --> ${log}`);
    }
    /**
     * print debug level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showDebug(tag, log) {
        console.debug(`${TAG} tag: ${tag} --> ${log}`);
    }
    /**
     * print error level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showError(tag, log) {
        console.error(`${TAG} tag: ${tag} --> ${log}`);
    }
}
exports["default"] = Log;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\ResourceUtil.ts":
/*!********************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\ResourceUtil.ts ***!
  \********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ResourceUtil = void 0;
/**
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const abilityManager_1 = __importDefault(__webpack_require__(/*! ./abilitymanager/abilityManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\abilitymanager\\abilityManager.ts"));
/**
 * Resource util
 */
class ResourceUtil {
    /**
     * Initialize ResourceManager
     */
    async initResourceManager() {
        if (!this.resMgr) {
            let context = abilityManager_1.default.getContext();
            this.resMgr = await context.resourceManager;
        }
        return this.resMgr;
    }
    /**
     * Get string value from NormalResource instance
     *
     * @param resource - NormalResource instance
     */
    async getString(resource) {
        await this.initResourceManager();
        return await this.resMgr.getString(resource.id);
    }
    /**
     * Get direction value from NormalResource instance
     *
     * @param resource - NormalResource instance
     */
    async getConfiguration() {
        await this.initResourceManager();
        return await this.resMgr.getConfiguration();
    }
}
exports.ResourceUtil = ResourceUtil;
let resourceUtil = new ResourceUtil();
exports["default"] = resourceUtil;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\ScreenLockManager.ts":
/*!*************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\ScreenLockManager.ts ***!
  \*************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.SCREEN_CHANGE_EVENT = void 0;
var commonEvent = globalThis.requireNapi('commonEvent') || (isSystemplugin('commonEvent', 'ohos') ? globalThis.ohosplugin.commonEvent : isSystemplugin('commonEvent', 'system') ? globalThis.systemplugin.commonEvent : undefined);
__webpack_require__(/*! commonEvent/commonEventSubscriber */ "../../api/commonEvent/commonEventSubscriber.d.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ./SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const EventManager_1 = __importDefault(__webpack_require__(/*! ./event/EventManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventManager.ts"));
const Log_1 = __importDefault(__webpack_require__(/*! ./Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const EventUtil_1 = __webpack_require__(/*! ./event/EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventUtil.ts");
const Decorators_1 = __webpack_require__(/*! ./Decorators */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Decorators.ts");
exports.SCREEN_CHANGE_EVENT = "screenChangeEvent";
const TAG = "ScreenLockManager";
const SCREEN_COMMON_EVENT_INFO = {
    events: [commonEvent.Support.COMMON_EVENT_SCREEN_OFF, commonEvent.Support.COMMON_EVENT_SCREEN_ON],
};
const debounceTimeout = 500;
class ScreenLockManager {
    async init() {
        this.mSubscriber = await commonEvent.createSubscriber(SCREEN_COMMON_EVENT_INFO);
        commonEvent.subscribe(this.mSubscriber, (err, data) => {
            if (err.code != 0) {
                Log_1.default.showError(TAG, `Can't handle screen change, err: ${JSON.stringify(err)}`);
                return;
            }
            Log_1.default.showDebug(TAG, `screenChange, err: ${JSON.stringify(err)} data: ${JSON.stringify(data)}`);
            switch (data.event) {
                case commonEvent.Support.COMMON_EVENT_SCREEN_OFF:
                    this.notifyScreenEvent(false);
                    break;
                case commonEvent.Support.COMMON_EVENT_SCREEN_ON:
                    this.notifyScreenEvent(true);
                    break;
                default:
                    Log_1.default.showError(TAG, `unknow event`);
            }
        });
    }
    notifyScreenEvent(isScreenOn) {
        EventManager_1.default.publish(EventUtil_1.obtainLocalEvent(exports.SCREEN_CHANGE_EVENT, isScreenOn));
        Log_1.default.showDebug(TAG, `publish ${exports.SCREEN_CHANGE_EVENT} screenState: ${isScreenOn}`);
    }
}
__decorate([
    Decorators_1.debounce(debounceTimeout)
], ScreenLockManager.prototype, "notifyScreenEvent", null);
let sScreenLockManager = SingleInstanceHelper_1.default(ScreenLockManager, TAG);
exports["default"] = sScreenLockManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts":
/*!****************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\SingleInstanceHelper.ts ***!
  \****************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/**
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.getAudioManager = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ./Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
var audio = globalThis.requireNapi('multimedia.audio') || (isSystemplugin('multimedia.audio', 'ohos') ? globalThis.ohosplugin.multimedia.audio : isSystemplugin('multimedia.audio', 'system') ? globalThis.systemplugin.multimedia.audio : undefined);
const TAG = "SingleInstanceHelper";
const AUDIO_MANAGER_KEY = 'MultiMediaAudioManager';
function createOrGet(objectClass, storageKey) {
    if (!globalThis[storageKey]) {
        globalThis[storageKey] = new objectClass();
        Log_1.default.showInfo(TAG, `Create key of ${storageKey}`);
    }
    return globalThis[storageKey];
}
exports["default"] = createOrGet;
function getAudioManager() {
    if (!globalThis[AUDIO_MANAGER_KEY]) {
        globalThis[AUDIO_MANAGER_KEY] = audio.getAudioManager();
        Log_1.default.showInfo(TAG, `Create Audio Manager.`);
    }
    return globalThis[AUDIO_MANAGER_KEY];
}
exports.getAudioManager = getAudioManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts":
/*!**************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\StyleConfiguration.ts ***!
  \**************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const StyleManager_1 = __importDefault(__webpack_require__(/*! ./StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
const TAG = 'Common-StyleConfiguration';
class StyleConfiguration {
    static getCommonStyle() {
        const key = TAG + "-Common";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                statusBarFontSize: '16fp',
                statusBarIconWidth: '24vp',
                statusBarIconHeight: '24vp',
                statusBarMarginLeftRight: '5vp',
            };
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts":
/*!********************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\StyleManager.ts ***!
  \********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.StyleManager = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ./Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const TAG = 'Common-StyleManager';
class StyleManager {
    constructor() {
        this.mAbilityPageName = '';
    }
    setAbilityPageName(name) {
        Log_1.default.showInfo(TAG, `setAbilityPageName, name: ${name}`);
        this.mAbilityPageName = name;
    }
    getStyle(key, generateDefaultFunction) {
        let newKey = this.mAbilityPageName + '-' + key;
        if (!AppStorage.Has(newKey)) {
            let defaultStyle = generateDefaultFunction();
            AppStorage.SetOrCreate(newKey, defaultStyle);
            Log_1.default.showInfo(TAG, `Create storageKey of ${newKey}`);
        }
        return AppStorage.Get(newKey);
    }
}
exports.StyleManager = StyleManager;
let styleManager = new StyleManager();
exports["default"] = styleManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SwitchUserManager.ts":
/*!*************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\SwitchUserManager.ts ***!
  \*************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.UserInfo = exports.INVALID_USER_ID = void 0;
var AccountManager = globalThis.requireNapi('account.osAccount') || (isSystemplugin('account.osAccount', 'ohos') ? globalThis.ohosplugin.account.osAccount : isSystemplugin('account.osAccount', 'system') ? globalThis.systemplugin.account.osAccount : undefined);
const Log_1 = __importDefault(__webpack_require__(/*! ./Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ./SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const TAG = "SwitchUserManager";
const SUBSCRIBE_KEY = "SystemUiAccount";
const USER_CHANGE_EVENT = "activate";
const DELAY_TIME = 3 * 1000;
exports.INVALID_USER_ID = -1;
class UserInfo {
    constructor() {
        this.userId = exports.INVALID_USER_ID;
        this.userName = "";
        this.userIcon = "";
    }
}
exports.UserInfo = UserInfo;
async function getCurrentAccountInfo() {
    let accountInfos = await AccountManager.getAccountManager().queryAllCreatedOsAccounts();
    for (let accountInfo of accountInfos) {
        Log_1.default.showInfo(TAG, `accountInfo: ${accountInfo.localId}, isActive: ${accountInfo.isActived}`);
        if (accountInfo.isActived) {
            return accountInfo;
        }
    }
    return { localId: exports.INVALID_USER_ID, localName: "", photo: "" };
}
function parseAccountInfo(accountInfo) {
    return {
        userId: accountInfo.localId,
        userName: accountInfo.localName,
        userIcon: accountInfo.photo,
    };
}
class SwitchUserManager {
    constructor() {
        this.mUserInfo = new UserInfo();
        this.mListeners = new Set();
        this.mHasWait = false;
        Log_1.default.showInfo(TAG, `SwitchUserManager constructor`);
        AccountManager.getAccountManager().on(USER_CHANGE_EVENT, SUBSCRIBE_KEY, this.handleUserChange.bind(this));
    }
    static getInstance() {
        return SingleInstanceHelper_1.default(SwitchUserManager, TAG);
    }
    async getCurrentUserInfo() {
        if (this.mUserInfo.userId == exports.INVALID_USER_ID) {
            this.mUserInfo = parseAccountInfo(await getCurrentAccountInfo());
            while (!this.mHasWait && this.mUserInfo.userId == exports.INVALID_USER_ID) {
                await new Promise((resolve) => setTimeout(resolve, DELAY_TIME));
                this.mUserInfo = parseAccountInfo(await getCurrentAccountInfo());
            }
            this.mHasWait = true;
            this.mUserInfo = parseAccountInfo(await getCurrentAccountInfo());
        }
        Log_1.default.showInfo(TAG, `getCurrentUserInfo userId: ${this.mUserInfo.userId}`);
        return this.mUserInfo;
    }
    registerListener(listener) {
        this.mListeners.add(listener);
    }
    unregisterListener(listener) {
        this.mListeners.delete(listener);
    }
    handleUserChange(accountId) {
        AccountManager.getAccountManager()
            .queryOsAccountById(accountId)
            .then((accountInfo) => {
            Log_1.default.showInfo(TAG, `userChange, accountInfo: ${JSON.stringify(accountInfo)}`);
            this.mUserInfo = parseAccountInfo(accountInfo);
            this.notifyUserChange();
        })
            .catch((err) => Log_1.default.showError(TAG, `Can't query account by ${accountId}, err: ${err}`));
    }
    notifyUserChange() {
        this.mListeners.forEach((listener) => listener.userChange(this.mUserInfo));
    }
}
exports["default"] = SwitchUserManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TimeManager.ts":
/*!*******************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\TimeManager.ts ***!
  \*******************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/**
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.concatTime = exports.TIME_CHANGE_EVENT = void 0;
var settings = globalThis.requireNapi('settings') || (isSystemplugin('settings', 'ohos') ? globalThis.ohosplugin.settings : isSystemplugin('settings', 'system') ? globalThis.systemplugin.settings : undefined);
var commonEvent = globalThis.requireNapi('commonEvent') || (isSystemplugin('commonEvent', 'ohos') ? globalThis.ohosplugin.commonEvent : isSystemplugin('commonEvent', 'system') ? globalThis.systemplugin.commonEvent : undefined);
var featureAbility = globalThis.requireNapi('ability.featureAbility') || (isSystemplugin('ability.featureAbility', 'ohos') ? globalThis.ohosplugin.ability.featureAbility : isSystemplugin('ability.featureAbility', 'system') ? globalThis.systemplugin.ability.featureAbility : undefined);
__webpack_require__(/*! ability/dataAbilityHelper */ "../../api/ability/dataAbilityHelper.d.ts");
const Log_1 = __importDefault(__webpack_require__(/*! ./Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const EventManager_1 = __importDefault(__webpack_require__(/*! ./event/EventManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventManager.ts"));
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ./SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const EventUtil_1 = __webpack_require__(/*! ./event/EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventUtil.ts");
const CommonEventManager_1 = __webpack_require__(/*! ./commonEvent/CommonEventManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\commonEvent\\CommonEventManager.ts");
exports.TIME_CHANGE_EVENT = "Time_Change_Event";
const TAG = "TimeManager";
const URI_VAR = "dataability:///com.ohos.settingsdata.DataAbility";
const TIME_FORMAT_KEY = settings.date.TIME_FORMAT;
const TIME_SUBSCRIBE_INFO = {
    events: [
        commonEvent.Support.COMMON_EVENT_TIME_CHANGED,
        commonEvent.Support.COMMON_EVENT_TIMEZONE_CHANGED,
        commonEvent.Support.COMMON_EVENT_TIME_TICK,
    ],
};
function fill(value) {
    return (value > 9 ? "" : "0") + value;
}
function concatTime(h, m) {
    return `${fill(h)}:${fill(m)}`;
}
exports.concatTime = concatTime;
class TimeManager {
    constructor() {
        this.mUse24hFormat = false;
    }
    init(context) {
        this.mManager = CommonEventManager_1.getCommonEventManager(TAG, TIME_SUBSCRIBE_INFO, () => this.notifyTimeChange(), (isSubscribe) => isSubscribe && this.notifyTimeChange());
        this.mManager.subscriberCommonEvent();
        this.mManager.applyPolicy([CommonEventManager_1.POLICY.SCREEN_POLICY]);
        this.initTimeFormat(context);
    }
    release() {
        var _a, _b;
        (_a = this.mManager) === null || _a === void 0 ? void 0 : _a.release();
        this.mManager = undefined;
        (_b = this.mSettingsHelper) === null || _b === void 0 ? void 0 : _b.off("dataChange", settings.getUriSync(TIME_FORMAT_KEY));
    }
    formatTime(date) {
        return concatTime(date.getHours() % (this.mUse24hFormat ? 24 : 12), date.getMinutes());
    }
    initTimeFormat(context) {
        Log_1.default.showInfo(TAG, "initTimeFormat");
        this.mSettingsHelper = featureAbility.acquireDataAbilityHelper(context, URI_VAR);
        const handleTimeFormatChange = () => {
            if (!this.mSettingsHelper) {
                Log_1.default.showError(TAG, `Can't get dataAbility helper.`);
                return;
            }
            let timeString = settings.getValueSync(this.mSettingsHelper, TIME_FORMAT_KEY, "24");
            Log_1.default.showDebug(TAG, `timeFormat change: ${timeString}`);
            this.mUse24hFormat = timeString == "24";
            this.notifyTimeChange();
        };
        try {
            this.mSettingsHelper.on("dataChange", settings.getUriSync(TIME_FORMAT_KEY), (err) => {
                if (err.code !== 0) {
                    Log_1.default.showError(TAG, `failed to getAbilityWant, code: ${err.code}.`);
                    return;
                }
                handleTimeFormatChange();
            });
        }
        catch (e) {
            Log_1.default.showError(TAG, `Can't listen timeformate change.`);
        }
        handleTimeFormatChange();
    }
    notifyTimeChange() {
        Log_1.default.showInfo(TAG, "notifyTimeChange");
        let args = {
            date: new Date(),
            timeFormat: this.mUse24hFormat,
        };
        EventManager_1.default.publish(EventUtil_1.obtainLocalEvent(exports.TIME_CHANGE_EVENT, args));
    }
}
let sTimeManager = SingleInstanceHelper_1.default(TimeManager, TAG);
exports["default"] = sTimeManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts":
/*!************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\TintStateManager.ts ***!
  \************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.getOrCreateTintContentInfo = exports.TintContentInfo = void 0;
var Window = globalThis.requireNapi('window') || (isSystemplugin('window', 'ohos') ? globalThis.ohosplugin.window : isSystemplugin('window', 'system') ? globalThis.systemplugin.window : undefined);
var display = globalThis.requireNapi('display') || (isSystemplugin('display', 'ohos') ? globalThis.ohosplugin.display : isSystemplugin('display', 'system') ? globalThis.systemplugin.display : undefined);
const Log_1 = __importDefault(__webpack_require__(/*! ./Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const Constants_1 = __webpack_require__(/*! ./Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ./SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const TAG = "TintStateManager";
const LISTENER_SYSTEM_BAR_TINT_CHANGE = "systemBarTintChange";
class TintContentInfo {
    constructor() {
        this.contentColor = "#FFFFFFFF";
    }
}
exports.TintContentInfo = TintContentInfo;
function getOrCreateTintContentInfo(key) {
    let storageKey = 'SystemUI_TintContentInfo_' + key;
    if (!AppStorage.Has(storageKey)) {
        AppStorage.SetOrCreate(storageKey, new TintContentInfo());
        Log_1.default.showInfo(TAG, `getOrCreateTintContentInfo, Create storageKey of ${storageKey}`);
    }
    return AppStorage.Get(storageKey);
}
exports.getOrCreateTintContentInfo = getOrCreateTintContentInfo;
class TintStateManager {
    constructor() {
        this.mListeners = new Map();
        this.mStates = new Map();
        Log_1.default.showInfo(TAG, `init TintStateManager. ${LISTENER_SYSTEM_BAR_TINT_CHANGE}`);
        Window.on(LISTENER_SYSTEM_BAR_TINT_CHANGE, this.onSystemBarTintChange.bind(this));
    }
    static getInstance() {
        return SingleInstanceHelper_1.default(TintStateManager, TAG);
    }
    registerListener(windowType, listener) {
        let tintState = this.mStates.get(windowType);
        tintState && listener.onTintStateChange(tintState);
        let res = this.mListeners.set(windowType, listener);
        Log_1.default.showInfo(TAG, `registser listenerSize: ${res.size}`);
    }
    unregisterListener(windowType) {
        let res = this.mListeners.delete(windowType);
        Log_1.default.showInfo(TAG, `unregistser ${windowType}, res: ${res}`);
    }
    async onSystemBarTintChange(data) {
        Log_1.default.showInfo(TAG, `onSystemBarTintChange, data: ${JSON.stringify(data)}`);
        if (!Array.isArray(data.regionTint)) {
            Log_1.default.showInfo(TAG, `regionTint is not array.`);
            return;
        }
        let dis = await display.getDefaultDisplay();
        if (dis.id != data.displayId) {
            Log_1.default.showInfo(TAG, `Needn't change, displayId: ${data.displayId}`);
            return;
        }
        data.regionTint.forEach((regionTintData) => {
            var _a;
            Log_1.default.showInfo(TAG, `onSystemBarTintChange, type: ${Constants_1.WindowNameMap[regionTintData["type"]]}`);
            let windowType = Constants_1.WindowNameMap[regionTintData["type"]];
            if (!windowType) {
                return;
            }
            let tintState = {
                isEnable: regionTintData.isEnable,
                region: regionTintData.region,
                backgroundColor: regionTintData.backgroundColor,
                contentColor: regionTintData.contentColor,
            };
            Log_1.default.showInfo(TAG, `tintState: ${JSON.stringify(tintState)}`);
            this.mStates.set(windowType, tintState);
            (_a = this.mListeners.get(windowType)) === null || _a === void 0 ? void 0 : _a.onTintStateChange(tintState);
        });
    }
}
exports["default"] = TintStateManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\WindowManager.ts":
/*!*********************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\WindowManager.ts ***!
  \*********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.WINDOW_RESIZE_EVENT = exports.WINDOW_SHOW_HIDE_EVENT = exports.WindowType = void 0;
var Window = globalThis.requireNapi('window') || (isSystemplugin('window', 'ohos') ? globalThis.ohosplugin.window : isSystemplugin('window', 'system') ? globalThis.systemplugin.window : undefined);
const Log_1 = __importDefault(__webpack_require__(/*! ./Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const EventManager_1 = __importDefault(__webpack_require__(/*! ./event/EventManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventManager.ts"));
const EventUtil_1 = __webpack_require__(/*! ./event/EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventUtil.ts");
__webpack_require__(/*! ./Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ./SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
var WindowType;
(function (WindowType) {
    WindowType["STATUS_BAR"] = "SystemUi_StatusBar";
    WindowType["NAVIGATION_BAR"] = "SystemUi_NavigationBar";
    WindowType["DROPDOWN_PANEL"] = "SystemUi_DropdownPanel";
    WindowType["NOTIFICATION_PANEL"] = "SystemUi_NotificationPanel";
    WindowType["CONTROL_PANEL"] = "SystemUi_ControlPanel";
    WindowType["VOLUME_PANEL"] = "SystemUi_VolumePanel";
    WindowType["BANNER_NOTICE"] = "SystemUi_BannerNotice";
})(WindowType = exports.WindowType || (exports.WindowType = {}));
exports.WINDOW_SHOW_HIDE_EVENT = "WindowShowHideEvent";
exports.WINDOW_RESIZE_EVENT = "WindowResizeEvent";
const TAG = "WindowManager";
const SYSTEM_WINDOW_TYPE_MAP = {
    SystemUi_StatusBar: 2108,
    SystemUi_NavigationBar: 2112,
    SystemUi_DropdownPanel: 2109,
    SystemUi_NotificationPanel: 2111,
    SystemUi_ControlPanel: 2111,
    SystemUi_VolumePanel: 2111,
    SystemUi_BannerNotice: 2111,
};
const DEFAULT_WINDOW_INFO = {
    visibility: false,
    rect: { left: 0, top: 0, width: 0, height: 0 },
};
/**
 * Manage window size changes.
 */
class WindowManager {
    constructor() {
        this.mWindowInfos = new Map();
    }
    async createWindow(context, name, rect, loadContent) {
        Log_1.default.showInfo(TAG, `createWindow name: ${name}, rect: ${JSON.stringify(rect)}, url: ${loadContent}`);
        let winHandle = await Window.create(context, name, SYSTEM_WINDOW_TYPE_MAP[name]);
        await winHandle.moveTo(rect.left, rect.top);
        await winHandle.resetSize(rect.width, rect.height);
        await winHandle.loadContent(loadContent);
        this.mWindowInfos.set(name, { visibility: false, rect });
        Log_1.default.showInfo(TAG, `create window[${name}] success.`);
        return winHandle;
    }
    async resetSizeWindow(name, rect) {
        var _a;
        let window = await Window.find(name);
        await window.moveTo(rect.left, rect.top);
        await window.resetSize(rect.width, rect.height);
        this.mWindowInfos.set(name, Object.assign(Object.assign({}, ((_a = this.mWindowInfos.get(name)) !== null && _a !== void 0 ? _a : DEFAULT_WINDOW_INFO)), { rect }));
        EventManager_1.default.publish(EventUtil_1.obtainLocalEvent(exports.WINDOW_RESIZE_EVENT, {
            windowName: name,
            rect,
        }));
        Log_1.default.showInfo(TAG, `resize window[${name}] success, rect: ${JSON.stringify(rect)}.`);
    }
    async showWindow(name) {
        var _a;
        let window = await Window.find(name);
        await window.show();
        this.mWindowInfos.set(name, Object.assign(Object.assign({}, ((_a = this.mWindowInfos.get(name)) !== null && _a !== void 0 ? _a : DEFAULT_WINDOW_INFO)), { visibility: true }));
        EventManager_1.default.publish(EventUtil_1.obtainLocalEvent(exports.WINDOW_SHOW_HIDE_EVENT, {
            windowName: name,
            isShow: true,
        }));
        Log_1.default.showInfo(TAG, `show window[${name}] success.`);
    }
    async hideWindow(name) {
        var _a;
        let window = await Window.find(name);
        await window.hide();
        this.mWindowInfos.set(name, Object.assign(Object.assign({}, ((_a = this.mWindowInfos.get(name)) !== null && _a !== void 0 ? _a : DEFAULT_WINDOW_INFO)), { visibility: false }));
        EventManager_1.default.publish(EventUtil_1.obtainLocalEvent(exports.WINDOW_SHOW_HIDE_EVENT, {
            windowName: name,
            isShow: false,
        }));
        Log_1.default.showInfo(TAG, `hide window[${name}] success.`);
    }
    getWindowInfo(name) {
        return this.mWindowInfos.get(name);
    }
}
let sWindowManager = SingleInstanceHelper_1.default(WindowManager, TAG);
exports["default"] = sWindowManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\abilitymanager\\abilityManager.ts":
/*!*************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\abilitymanager\abilityManager.ts ***!
  \*************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Log_1 = __importDefault(__webpack_require__(/*! ../Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const TAG = 'AbilityManager';
class AbilityManager {
    static setContext(abilityName, context) {
        Log_1.default.showInfo(TAG, `setContext, abilityName: ${abilityName}`);
        globalThis[abilityName + '_Context'] = context;
    }
    static getContext(abilityName) {
        Log_1.default.showInfo(TAG, `getContext, abilityName: ${abilityName}`);
        if (!abilityName) {
            abilityName = AbilityManager.ABILITY_NAME_ENTRY;
        }
        return globalThis[abilityName + '_Context'];
    }
    static setAbilityData(abilityName, key, data) {
        Log_1.default.showInfo(TAG, `setAbilityData, abilityName: ${abilityName} key: ${key} data: ${JSON.stringify(data)}`);
        globalThis[abilityName + '_data_' + key] = data;
    }
    static getAbilityData(abilityName, key) {
        Log_1.default.showInfo(TAG, `getAbilityData, abilityName: ${abilityName} key: ${key} `);
        return globalThis[abilityName + '_data_' + key];
    }
    static startAbility(want, callback) {
        Log_1.default.showInfo(TAG, `startAbility, want: ${JSON.stringify(want)}`);
        let context = AbilityManager.getContext();
        context.startAbility(want).then(() => {
            Log_1.default.showInfo(TAG, `startAbility, then`);
            if (callback) {
                callback(null);
            }
        }).catch((error) => {
            Log_1.default.showInfo(TAG, `startAbility, error: ${JSON.stringify(error)}`);
            callback(error);
        });
    }
}
exports["default"] = AbilityManager;
AbilityManager.ABILITY_NAME_ENTRY = 'SystemUi_Entry';
AbilityManager.ABILITY_NAME_STATUS_BAR = 'SystemUi_StatusBar';
AbilityManager.ABILITY_NAME_NAVIGATION_BAR = 'SystemUi_NavigationBar';
AbilityManager.ABILITY_NAME_VOLUME_PANEL = 'SystemUi_VolumePanel';
AbilityManager.ABILITY_NAME_NOTIFICATION_MANAGEMENT = 'SystemUi_NotificationManagement';
AbilityManager.ABILITY_NAME_DROPDOWN_PANEL = 'SystemUi_DropdownPanel';
AbilityManager.ABILITY_NAME_NOTIFICATION_PANEL = 'SystemUi_NotificationPanel';
AbilityManager.ABILITY_NAME_CONTROL_PANEL = 'SystemUi_ControlPanel';
AbilityManager.ABILITY_NAME_BANNER_NOTICE = 'SystemUi_BannerNotice';
AbilityManager.ABILITY_NAME_APP_LIST = 'SystemUi_AppList';
AbilityManager.ABILITY_NAME_OWNER_WANT = 'Owner_Want';


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\abilitymanager\\abilitymanager.ts":
/*!*************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\abilitymanager\abilitymanager.ts ***!
  \*************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const Log_1 = __importDefault(__webpack_require__(/*! ../Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const TAG = 'AbilityManager';
class AbilityManager {
    static setContext(abilityName, context) {
        Log_1.default.showInfo(TAG, `setContext, abilityName: ${abilityName}`);
        globalThis[abilityName + '_Context'] = context;
    }
    static getContext(abilityName) {
        Log_1.default.showInfo(TAG, `getContext, abilityName: ${abilityName}`);
        if (!abilityName) {
            abilityName = AbilityManager.ABILITY_NAME_ENTRY;
        }
        return globalThis[abilityName + '_Context'];
    }
    static setAbilityData(abilityName, key, data) {
        Log_1.default.showInfo(TAG, `setAbilityData, abilityName: ${abilityName} key: ${key} data: ${JSON.stringify(data)}`);
        globalThis[abilityName + '_data_' + key] = data;
    }
    static getAbilityData(abilityName, key) {
        Log_1.default.showInfo(TAG, `getAbilityData, abilityName: ${abilityName} key: ${key} `);
        return globalThis[abilityName + '_data_' + key];
    }
    static startAbility(want, callback) {
        Log_1.default.showInfo(TAG, `startAbility, want: ${JSON.stringify(want)}`);
        let context = AbilityManager.getContext();
        context.startAbility(want).then(() => {
            Log_1.default.showInfo(TAG, `startAbility, then`);
            if (callback) {
                callback(null);
            }
        }).catch((error) => {
            Log_1.default.showInfo(TAG, `startAbility, error: ${JSON.stringify(error)}`);
            callback(error);
        });
    }
}
exports["default"] = AbilityManager;
AbilityManager.ABILITY_NAME_ENTRY = 'SystemUi_Entry';
AbilityManager.ABILITY_NAME_STATUS_BAR = 'SystemUi_StatusBar';
AbilityManager.ABILITY_NAME_NAVIGATION_BAR = 'SystemUi_NavigationBar';
AbilityManager.ABILITY_NAME_VOLUME_PANEL = 'SystemUi_VolumePanel';
AbilityManager.ABILITY_NAME_NOTIFICATION_MANAGEMENT = 'SystemUi_NotificationManagement';
AbilityManager.ABILITY_NAME_DROPDOWN_PANEL = 'SystemUi_DropdownPanel';
AbilityManager.ABILITY_NAME_NOTIFICATION_PANEL = 'SystemUi_NotificationPanel';
AbilityManager.ABILITY_NAME_CONTROL_PANEL = 'SystemUi_ControlPanel';
AbilityManager.ABILITY_NAME_BANNER_NOTICE = 'SystemUi_BannerNotice';
AbilityManager.ABILITY_NAME_APP_LIST = 'SystemUi_AppList';
AbilityManager.ABILITY_NAME_OWNER_WANT = 'Owner_Want';


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\abilitymanager\\bundleManager.ts":
/*!************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\abilitymanager\bundleManager.ts ***!
  \************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
var BundleMgr = globalThis.requireNapi('bundle') || (isSystemplugin('bundle', 'ohos') ? globalThis.ohosplugin.bundle : isSystemplugin('bundle', 'system') ? globalThis.systemplugin.bundle : undefined);
__webpack_require__(/*! application/ServiceExtensionContext */ "../../api/application/ServiceExtensionContext.d.ts");
const Log_1 = __importDefault(__webpack_require__(/*! ../Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const SwitchUserManager_1 = __importDefault(__webpack_require__(/*! ../SwitchUserManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SwitchUserManager.ts"));
const TAG = "BRManager";
class BundleManager {
    static async getResourceManager(tag, context, bundleName) {
        Log_1.default.showInfo(TAG, `getResourceManager from: ${tag}`);
        let bundleContext = await context.createBundleContext(bundleName);
        return await bundleContext.resourceManager;
    }
    static async getBundleInfo(tag, bundleName, getInfo, requestId) {
        let userInfo = {
            userId: requestId !== null && requestId !== void 0 ? requestId : (await SwitchUserManager_1.default.getInstance().getCurrentUserInfo()).userId,
        };
        Log_1.default.showInfo(TAG, `getBundleInfo from: ${tag}, userId: ${userInfo.userId}`);
        return await BundleMgr.getBundleInfo(bundleName, getInfo, userInfo);
    }
}
exports["default"] = BundleManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\commonEvent\\CommonEventManager.ts":
/*!**************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\commonEvent\CommonEventManager.ts ***!
  \**************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.getCommonEventManager = exports.POLICY = void 0;
var commonEvent = globalThis.requireNapi('commonEvent') || (isSystemplugin('commonEvent', 'ohos') ? globalThis.ohosplugin.commonEvent : isSystemplugin('commonEvent', 'system') ? globalThis.systemplugin.commonEvent : undefined);
__webpack_require__(/*! commonEvent/commonEventData */ "../../api/commonEvent/commonEventData.d.ts");
const EventManager_1 = __importDefault(__webpack_require__(/*! ../event/EventManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventManager.ts"));
const Log_1 = __importDefault(__webpack_require__(/*! ../Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const ScreenLockManager_1 = __webpack_require__(/*! ../ScreenLockManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\ScreenLockManager.ts");
var POLICY;
(function (POLICY) {
    POLICY["SCREEN_POLICY"] = "screenOnOffPolicy";
})(POLICY = exports.POLICY || (exports.POLICY = {}));
const policyMap = {
    screenOnOffPolicy: ScreenPolicy,
};
function getCommonEventManager(tag, subscribeInfos, commonEventCallback, subscribeStateChange) {
    const TAG = `CommonEvent_${tag}`;
    const SUBSCRIBE_INFOS = subscribeInfos;
    let unSubcribers = [];
    let policyClearCb = undefined;
    async function subscriberCommonEvent() {
        Log_1.default.showInfo(TAG, "registerSubscriber start");
        let subscriber = await commonEvent.createSubscriber(SUBSCRIBE_INFOS);
        commonEvent.subscribe(subscriber, (err, data) => {
            if (err.code != 0) {
                Log_1.default.showError(TAG, `Can't handle common event, err: ${JSON.stringify(err)}`);
                return;
            }
            Log_1.default.showInfo(TAG, `handle common event: ${data.event}`);
            commonEventCallback(data);
        });
        unSubcribers.push(() => commonEvent.unsubscribe(subscriber));
        subscribeStateChange && subscribeStateChange(true);
        Log_1.default.showInfo(TAG, `registerSubscriber success, size: ${unSubcribers.length}`);
    }
    function unSubscriberCommonEvent() {
        Log_1.default.showInfo(TAG, `UnSubcribers size: ${unSubcribers.length}`);
        unSubcribers.forEach((unsubscribe) => unsubscribe());
        unSubcribers.length = 0;
        subscribeStateChange && subscribeStateChange(false);
    }
    function applyPolicy(policys) {
        const innerManager = { subscriberCommonEvent, unSubscriberCommonEvent };
        policyClearCb = policyClearCb !== null && policyClearCb !== void 0 ? policyClearCb : new Map();
        policys.forEach((policy) => {
            if (policyClearCb) {
                !policyClearCb.has(policy) && policyClearCb.set(policy, policyMap[policy](innerManager));
                Log_1.default.showInfo(TAG, `apply policy: ${policy}`);
            }
        });
    }
    function release() {
        policyClearCb === null || policyClearCb === void 0 ? void 0 : policyClearCb.forEach((cb) => cb());
        policyClearCb === null || policyClearCb === void 0 ? void 0 : policyClearCb.clear();
        unSubscriberCommonEvent();
    }
    return { subscriberCommonEvent, unSubscriberCommonEvent, applyPolicy, release };
}
exports.getCommonEventManager = getCommonEventManager;
function ScreenPolicy(manager) {
    return EventManager_1.default.subscribe(ScreenLockManager_1.SCREEN_CHANGE_EVENT, (isScreenOn) => {
        isScreenOn ? manager.subscriberCommonEvent() : manager.unSubscriberCommonEvent();
    });
}


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\constants.ts":
/*!*****************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\constants.ts ***!
  \*****************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.FASlotName = exports.WindowNameMap = void 0;
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
exports.WindowNameMap = {
    2112: 'navigation',
    2108: 'status',
    2111: 'volume'
};
;
class Constants {
}
exports["default"] = Constants;
Constants.URI_VAR = 'dataability:///com.ohos.settingsdata.DataAbility';
var FASlotName;
(function (FASlotName) {
    FASlotName["AUTO_ROTATE"] = "auto_rotate";
    FASlotName["AIR_PLANE"] = "air_plane";
    FASlotName["BATTERY"] = "battery";
    FASlotName["BLUETOOTH"] = "bluetooth";
    FASlotName["CAPSULE"] = "capsule";
    FASlotName["CLOCK"] = "clock";
    FASlotName["EMPTY"] = "empty";
    FASlotName["LOCATION"] = "location";
    FASlotName["NOTIFICATION"] = "notification";
    FASlotName["RING_MODE"] = "ring_mode";
    FASlotName["SIGNAL"] = "signal";
    FASlotName["WIFI"] = "wifi";
})(FASlotName = exports.FASlotName || (exports.FASlotName = {}));


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventBus.ts":
/*!**********************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\event\EventBus.ts ***!
  \**********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.createEventBus = void 0;
/*
 * Copyright (c) 2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Log_1 = __importDefault(__webpack_require__(/*! ../Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const TAG = "EventBus";
function createEventBus() {
    let _cbs = {};
    function on(events, cb) {
        var _a;
        if (Array.isArray(events)) {
            events.forEach((e) => on(e, cb));
        }
        else {
            (_cbs[events] || (_cbs[events] = new Set())).add(cb);
            Log_1.default.showInfo(TAG, `add event[${events}] callback, size: ${(_a = _cbs[events]) === null || _a === void 0 ? void 0 : _a.size}`);
        }
        return () => off(events, cb);
    }
    function once(event, cb) {
        let newCallback = (args) => {
            cb(args);
            removeSelf();
        };
        function removeSelf() {
            off(event, newCallback);
        }
        return on(event, newCallback);
    }
    function off(event, cb) {
        var _a, _b;
        if (!event) {
            _cbs = {};
            Log_1.default.showInfo(TAG, `remove event[${event}] all callback`);
            return;
        }
        if (Array.isArray(event)) {
            event.forEach((e) => off(e, cb));
            return;
        }
        (_a = _cbs[event]) === null || _a === void 0 ? void 0 : _a.delete(cb);
        Log_1.default.showInfo(TAG, `remove event[${event}] callback, size: ${(_b = _cbs[event]) === null || _b === void 0 ? void 0 : _b.size}`);
    }
    function emit(event, args) {
        var _a;
        (_a = _cbs[event]) === null || _a === void 0 ? void 0 : _a.forEach((cb) => cb(args));
    }
    function stickyEmit(event, argument) { }
    return {
        on,
        once,
        off,
        emit,
    };
}
exports.createEventBus = createEventBus;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventManager.ts":
/*!**************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\event\EventManager.ts ***!
  \**************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
__webpack_require__(/*! application/ServiceExtensionContext */ "../../api/application/ServiceExtensionContext.d.ts");
const Log_1 = __importDefault(__webpack_require__(/*! ../Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const EventUtil_1 = __webpack_require__(/*! ./EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventUtil.ts");
const EventBus_1 = __webpack_require__(/*! ./EventBus */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventBus.ts");
const TAG = "EventManager";
class EventManager {
    constructor() {
        this.mEventBus = EventBus_1.createEventBus();
        this.eventParser = {
            local: this.publishLocalEvent,
            ability: this.startAbility,
            commonEvent: this.publishCommonEvent,
            remote: this.publishRemoteEvent,
        };
    }
    setContext(ctx) {
        this.mContext = ctx;
    }
    publish(event) {
        return this.eventParser[event.target].call(this, event.data);
    }
    subscribe(eventType, callback) {
        return this.mEventBus.on(eventType, callback);
    }
    subscribeOnce(eventType, callback) {
        return this.mEventBus.once(eventType, callback);
    }
    publishLocalEvent(data) {
        Log_1.default.showInfo(TAG, `publish localEvent type: ${data.eventName}`);
        if (data.eventName) {
            this.mEventBus.emit(data.eventName, data.args);
            return true;
        }
        return false;
    }
    startAbility(data) {
        var _a;
        Log_1.default.showInfo(TAG, `start Ability: ${data.abilityName}`);
        if (data.bundleName && data.abilityName && this.mContext) {
            this.mEventBus.emit(EventUtil_1.START_ABILITY_EVENT, { abilityName: data.abilityName });
            this.mContext.startAbility({
                bundleName: data.bundleName,
                abilityName: data.abilityName,
                parameters: (_a = data.args) !== null && _a !== void 0 ? _a : undefined
            });
            return true;
        }
        return false;
    }
    publishRemoteEvent(data) {
        // todo publish to remote device
        return false;
    }
    publishCommonEvent(data) {
        // todo publish commonEvent to other app
        return false;
    }
}
let sEventManager = SingleInstanceHelper_1.default(EventManager, TAG);
exports["default"] = sEventManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventUtil.ts":
/*!***********************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\event\EventUtil.ts ***!
  \***********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.parseEventString = exports.obtainStartAbility = exports.obtainLocalEvent = exports.PUBLISH_COMMON_EVENT = exports.START_ABILITY_EVENT = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
exports.START_ABILITY_EVENT = "startAbilityEvent";
exports.PUBLISH_COMMON_EVENT = "publishCommonEvent";
const TAG = "EventUtil";
const LOCAL_EVENT_TYPE = "local";
const START_ABILITY_TYPE = "ability";
function obtainLocalEvent(event, args) {
    return {
        target: LOCAL_EVENT_TYPE,
        data: {
            eventName: event,
            args,
        },
    };
}
exports.obtainLocalEvent = obtainLocalEvent;
function obtainStartAbility(bundleName, abilityName, args) {
    return {
        target: START_ABILITY_TYPE,
        data: {
            bundleName,
            abilityName,
            args
        },
    };
}
exports.obtainStartAbility = obtainStartAbility;
function parseEventString(eventString) {
    // string must be "local=eventName|args" or "ability=bundleName|abilityName"
    if (!eventString) {
        return;
    }
    let [eventType, eventData] = eventString.split("=");
    if (eventType == LOCAL_EVENT_TYPE && eventData) {
        let [localEventName, args] = eventData.split("|");
        if (localEventName) {
            Log_1.default.showDebug(TAG, `parseEventData name:${localEventName}, args: ${args}`);
            return obtainLocalEvent(localEventName, args);
        }
    }
    if (eventType == START_ABILITY_TYPE && eventData) {
        let [bundleName, abilityName] = eventData.split("|");
        if (bundleName && abilityName) {
            Log_1.default.showDebug(TAG, `parseEventData bundleName:${bundleName}, abilityName: ${abilityName}`);
            return obtainStartAbility(bundleName, abilityName);
        }
    }
    Log_1.default.showError(TAG, `Can't parse event data: ${eventString}`);
    return undefined;
}
exports.parseEventString = parseEventString;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\heightcofigUtils\\HeightConfigUtils.ts":
/*!******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\heightcofigUtils\HeightConfigUtils.ts ***!
  \******************************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
__webpack_require__(/*! ../Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts");
const STATUS_BAR_MIN_HEIGHT = 24;
const STATUS_BAR_COEFFICIENT = 1.0;
const NAV_BAR_MIN_HEIGHT = 32;
const NAV_BAR_COEFFICIENT = 1.0;
class HeightConfigUtils {
    getStatusMinH() {
        return STATUS_BAR_MIN_HEIGHT;
    }
    getminHeight() {
        return NAV_BAR_MIN_HEIGHT;
    }
    getStatusCoefficient() {
        return STATUS_BAR_COEFFICIENT;
    }
    getNavHCoefficient() {
        return NAV_BAR_COEFFICIENT;
    }
}
exports["default"] = HeightConfigUtils;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\log.ts":
/*!***********************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\log.ts ***!
  \***********************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.filterKey = void 0;
const TAG = "SystemUI_Default";
const FILTER_KEYS = [
    new RegExp('hide', "gi")
];
function filterKey(target, propKey, descriptor) {
    const original = descriptor.value;
    descriptor.value = function (...args) {
        let filterResult = args.map((str) => {
            let tempStr = str;
            FILTER_KEYS.forEach((filterKey) => tempStr = tempStr.replace(filterKey, "**"));
            return tempStr;
        });
        const result = original.call(this, ...filterResult);
        return result;
    };
}
exports.filterKey = filterKey;
/**
 * Basic log class
 */
class Log {
    /**
     * print info level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showInfo(tag, log) {
        console.info(`${TAG} tag: ${tag} --> ${log}`);
    }
    /**
     * print debug level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showDebug(tag, log) {
        console.debug(`${TAG} tag: ${tag} --> ${log}`);
    }
    /**
     * print error level log
     *
     * @param {string} tag - Page or class tag
     * @param {string} log - Log needs to be printed
     */
    static showError(tag, log) {
        console.error(`${TAG} tag: ${tag} --> ${log}`);
    }
}
exports["default"] = Log;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\stylemanager.ts":
/*!********************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\default\stylemanager.ts ***!
  \********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.StyleManager = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ./Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const TAG = 'Common-StyleManager';
class StyleManager {
    constructor() {
        this.mAbilityPageName = '';
    }
    setAbilityPageName(name) {
        Log_1.default.showInfo(TAG, `setAbilityPageName, name: ${name}`);
        this.mAbilityPageName = name;
    }
    getStyle(key, generateDefaultFunction) {
        let newKey = this.mAbilityPageName + '-' + key;
        if (!AppStorage.Has(newKey)) {
            let defaultStyle = generateDefaultFunction();
            AppStorage.SetOrCreate(newKey, defaultStyle);
            Log_1.default.showInfo(TAG, `Create storageKey of ${newKey}`);
        }
        return AppStorage.Get(newKey);
    }
}
exports.StyleManager = StyleManager;
let styleManager = new StyleManager();
exports["default"] = styleManager;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\PluginDataSourceAdapter.ts":
/*!****************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\PluginDataSourceAdapter.ts ***!
  \****************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
var worker = globalThis.requireNapi('worker') || (isSystemplugin('worker', 'ohos') ? globalThis.ohosplugin.worker : isSystemplugin('worker', 'system') ? globalThis.systemplugin.worker : undefined);
const Log_1 = __importDefault(__webpack_require__(/*! ../default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const bundleManager_1 = __importDefault(__webpack_require__(/*! ../default/abilitymanager/bundleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\abilitymanager\\bundleManager.ts"));
const Constants_1 = __importStar(__webpack_require__(/*! ./common/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts"));
__webpack_require__(/*! application/ServiceExtensionContext */ "../../api/application/ServiceExtensionContext.d.ts");
const TAG = "PluginDataSourceAdapter";
const WORKER_JS_URL = "workers/PluginDataSourceWorker.js";
class PluginDataSourceAdapter {
    constructor(name, context, listener) {
        Log_1.default.showInfo(TAG, `constructor, name: ${name}`);
        this.mName = name;
        this.mContext = context;
        this.mListener = listener;
        this.mWorker = new worker.Worker(WORKER_JS_URL, {
            type: "classic",
            name: this.mName,
        });
        this.mWorker.onmessage = this.onMessage.bind(this);
        this.mWorker.onmessageerror = this.onMessageError.bind(this);
        this.mWorker.onexit = this.onExit.bind(this);
        this.mWorker.onerror = this.onError.bind(this);
    }
    initDataSource(configs) {
        Log_1.default.showInfo(TAG, `initDataSource, configs: ${JSON.stringify(configs)}`);
        this.mWorker.postMessage(Constants_1.obtainMsg(Constants_1.default.INIT_CONFIG, configs));
    }
    loadData(userId) {
        Log_1.default.showInfo(TAG, `loadData`);
        this.mWorker.postMessage(Constants_1.obtainMsg(Constants_1.default.LOAD_DATA, userId));
    }
    clearAll() {
        Log_1.default.showInfo(TAG, `clearAll`);
        this.mWorker.postMessage(Constants_1.obtainMsg(Constants_1.default.CLEAR_ALL, {}));
    }
    onMessage(msg) {
        Log_1.default.showInfo(TAG, `onMessage, msg: ${JSON.stringify(msg)}`);
        let data = msg.data;
        switch (data.action) {
            case Constants_1.default.INIT_FINISH:
                this.onInitFinish();
                break;
            case Constants_1.default.ADD_ITEM:
                this.onItemAdd(data.data);
                break;
            case Constants_1.default.REMOVE_ITEM:
                this.onItemRemove(data.data);
                break;
            default:
                Log_1.default.showError(TAG, `unknown type: ${JSON.stringify(msg)}`);
        }
    }
    onInitFinish() {
        Log_1.default.showInfo(TAG, `onInitFinish`);
        this.mListener.initFinish();
    }
    async onItemAdd(itemData) {
        var _a, _b;
        Log_1.default.showInfo(TAG, `onItemAdd, itemData: ${JSON.stringify(itemData)}`);
        itemData.label && (itemData.label = decodeURIComponent(itemData.label));
        if (itemData.label && itemData.iconUrl) {
            this.mListener.onItemAdd(itemData);
            return;
        }
        let manager = await bundleManager_1.default.getResourceManager(TAG, this.mContext, itemData.bundleName);
        Log_1.default.showInfo(TAG, `${itemData.id} Can't find label or icon, fetch data from ${manager}`);
        if (manager) {
            Promise.all([
                (_a = itemData.iconUrl) !== null && _a !== void 0 ? _a : manager.getMediaBase64(itemData.abilityIconId),
                (_b = itemData.label) !== null && _b !== void 0 ? _b : manager.getString(itemData.abilityLabelId),
            ])
                .then(([iconValue, labelValue]) => {
                iconValue && (itemData.iconUrl = iconValue);
                labelValue && (itemData.label = labelValue);
                this.mListener.onItemAdd(itemData);
            })
                .catch((err) => Log_1.default.showError(TAG, `Can't get bundle info, err: ${JSON.stringify(err)}`));
        }
    }
    onItemRemove(itemData) {
        Log_1.default.showInfo(TAG, `onItemRemove, itemData: ${JSON.stringify(itemData)}`);
        this.mListener.onItemRemove(itemData);
    }
    onMessageError(event) {
        Log_1.default.showInfo(TAG, `mWorker.onmessageerror, event: ${event}`);
    }
    onExit(code) {
        Log_1.default.showInfo(TAG, `mWorker.onexit, code: ${code}`);
    }
    onError(err) {
        Log_1.default.showInfo(TAG, `mWorker.onerror, err: ${JSON.stringify(err)}`);
    }
}
exports["default"] = PluginDataSourceAdapter;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts":
/*!*********************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\common\src\main\ets\plugindatasource\common\Constants.ts ***!
  \*********************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ActionData = exports.obtainMsg = exports.PluginType = void 0;
__webpack_require__(/*! ../../default/Event/EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Event\\EventUtil.ts");
class Constants {
}
exports["default"] = Constants;
Constants.INIT_CONFIG = "initConfig";
Constants.INIT_FINISH = "initFinish";
Constants.CLEAR_ALL = "clearAll";
Constants.ADD_ITEM = "addItem";
Constants.REMOVE_ITEM = "removeItem";
Constants.LOCAL_DEVICE = "local";
Constants.LOAD_DATA = "loadData";
var PluginType;
(function (PluginType) {
    PluginType[PluginType["META"] = 1] = "META";
    PluginType[PluginType["DATA_ABILITY"] = 2] = "DATA_ABILITY";
    PluginType[PluginType["PLUGIN_COMPONENT"] = 3] = "PLUGIN_COMPONENT";
})(PluginType = exports.PluginType || (exports.PluginType = {}));
function obtainMsg(action, data) {
    return { action: action, data: data };
}
exports.obtainMsg = obtainMsg;
class ActionData {
}
exports.ActionData = ActionData;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\batteryModel.ts":
/*!***************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\batterycomponent\src\main\ets\default\batteryModel.ts ***!
  \***************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.BatteryModel = void 0;
var BatteryInfo = globalThis.requireNapi('batteryInfo') || (isSystemplugin('batteryInfo', 'ohos') ? globalThis.ohosplugin.batteryInfo : isSystemplugin('batteryInfo', 'system') ? globalThis.systemplugin.batteryInfo : undefined);
var commonEvent = globalThis.requireNapi('commonEvent') || (isSystemplugin('commonEvent', 'ohos') ? globalThis.ohosplugin.commonEvent : isSystemplugin('commonEvent', 'system') ? globalThis.systemplugin.commonEvent : undefined);
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const constants_1 = __importDefault(__webpack_require__(/*! ./common/constants */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\common\\constants.ts"));
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! commonEvent/commonEventData */ "../../api/commonEvent/commonEventData.d.ts");
const CommonEventManager_1 = __webpack_require__(/*! ../../../../../../common/src/main/ets/default/commonEvent/CommonEventManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\commonEvent\\CommonEventManager.ts");
const TAG = "BatteryComponent-batteryModel";
const DEFAULT_PROGRESS = 100;
const SUBSCRIBE_INFO = {
    events: [commonEvent.Support.COMMON_EVENT_BATTERY_CHANGED],
};
function getChargingStatus(state) {
    Log_1.default.showInfo(TAG, `charging status update: ${state}`);
    let batteryStatus = false;
    switch (state) {
        case BatteryInfo.BatteryChargeState.DISABLE:
        case BatteryInfo.BatteryChargeState.ENABLE:
        case BatteryInfo.BatteryChargeState.FULL:
            batteryStatus = true;
            break;
        default:
            batteryStatus = false;
            break;
    }
    return batteryStatus;
}
class BatteryModel {
    initBatteryModel() {
        if (this.mManager) {
            return;
        }
        this.mManager = CommonEventManager_1.getCommonEventManager(TAG, SUBSCRIBE_INFO, () => this.updateBatteryStatus(), (isSubscribe) => isSubscribe && this.updateBatteryStatus());
        Log_1.default.showInfo(TAG, "initBatteryModel");
        this.mBatterySoc = AppStorage.SetAndLink("batterySoc", 0);
        this.mBatteryCharging = AppStorage.SetAndLink("batteryCharging", false);
        this.mManager.subscriberCommonEvent();
        this.mManager.applyPolicy([CommonEventManager_1.POLICY.SCREEN_POLICY]);
    }
    unInitBatteryModel() {
        var _a;
        Log_1.default.showInfo(TAG, "unInitBatteryModel");
        (_a = this.mManager) === null || _a === void 0 ? void 0 : _a.release();
        this.mManager = undefined;
    }
    /**
     * Get battery status and remaining power
     */
    updateBatteryStatus() {
        var _a;
        Log_1.default.showInfo(TAG, "updateBatteryStatus");
        let batterySoc = (_a = BatteryInfo.batterySOC) !== null && _a !== void 0 ? _a : DEFAULT_PROGRESS;
        let batteryCharging = BatteryInfo.chargingStatus;
        if (batterySoc <= 0) {
            // If the result is a negative number, set it as positive number.
            batterySoc = Math.abs(batterySoc) * constants_1.default.PERCENT_NUMBER;
        }
        Log_1.default.showInfo(TAG, "batterySoc = " + batterySoc);
        // Set the battery status as charging when there is no battery hardware
        this.mBatterySoc.set(batterySoc);
        this.mBatteryCharging.set(getChargingStatus(batteryCharging));
    }
}
exports.BatteryModel = BatteryModel;
let mBatteryModel = SingleInstanceHelper_1.default(BatteryModel, TAG);
exports["default"] = mBatteryModel;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\common\\Constants.ts":
/*!*******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\batterycomponent\src\main\ets\default\common\Constants.ts ***!
  \*******************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
class Constants {
}
exports["default"] = Constants;
Constants.BATTERY_LEVEL_LOW = 20;
Constants.PERCENT_NUMBER = 100;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts":
/*!****************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\batterycomponent\src\main\ets\default\common\StyleConfiguration.ts ***!
  \****************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const StyleManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
__webpack_require__(/*! ./Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\common\\Constants.ts");
const TAG = 'battery-StyleConfiguration';
class StyleConfiguration {
    static getBatteryComponentStyle() {
        const key = TAG + "-BatteryComponent";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                componentGap: { "id": 201326614, "type": 10002, params: [] }
            };
        });
    }
    static getBatteryPicStyle() {
        const key = TAG + "-BatteryPicComponent";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                picGap: { "id": 201326620, "type": 10002, params: [] },
                picBodyWidth: { "id": 201326618, "type": 10002, params: [] },
                picBodyHeight: { "id": 201326616, "type": 10002, params: [] },
                picBodyPadding: { "id": 201326617, "type": 10002, params: [] },
                picBodyBorderWidth: { "id": 201326615, "type": 10002, params: [] },
                picBorderRadius: { "id": 201326619, "type": 10002, params: [] },
                picHeadBorderRadius: { "id": 201326622, "type": 10002, params: [] },
                picChargingColor: { "id": 201326607, "type": 10001, params: [] },
                picLevelLowColor: { "id": 201326608, "type": 10001, params: [] },
                picHeadWidth: { "id": 201326623, "type": 10002, params: [] },
                picHeadHeight: { "id": 201326621, "type": 10002, params: [] },
            };
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\common\\constants.ts":
/*!*******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\batterycomponent\src\main\ets\default\common\constants.ts ***!
  \*******************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
class Constants {
}
exports["default"] = Constants;
Constants.BATTERY_LEVEL_LOW = 20;
Constants.PERCENT_NUMBER = 100;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\pages\\batteryIcon.ets":
/*!*********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\batterycomponent\src\main\ets\default\pages\batteryIcon.ets ***!
  \*********************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const batteryModel_1 = __importDefault(__webpack_require__(/*! ../batteryModel */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\batteryModel.ts"));
const batteryPic_1 = __importDefault(__webpack_require__(/*! ./batteryPic */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\pages\\batteryPic.ets"));
const batterySoc_1 = __importDefault(__webpack_require__(/*! ./batterySoc */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\pages\\batterySoc.ets"));
__webpack_require__(/*! ../common/constants */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\common\\constants.ts");
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts"));
const TAG = 'BatteryComponent-batteryIcon';
class BatteryIcon extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__batterySoc = AppStorage.GetOrCreate().setAndLink("batterySoc", 100, this);
        this.__StatusCoefficient = AppStorage.GetOrCreate().setAndLink("StatusCoefficient", 1.0, this);
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getBatteryComponentStyle(), this, "style");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.style !== undefined) {
            this.style = params.style;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
    }
    aboutToBeDeleted() {
        this.__batterySoc.aboutToBeDeleted();
        this.__StatusCoefficient.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get batterySoc() {
        return this.__batterySoc.get();
    }
    set batterySoc(newValue) {
        this.__batterySoc.set(newValue);
    }
    get StatusCoefficient() {
        return this.__StatusCoefficient.get();
    }
    set StatusCoefficient(newValue) {
        this.__StatusCoefficient.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    aboutToAppear() {
        batteryModel_1.default.initBatteryModel();
        Log_1.default.showInfo(TAG, 'aboutToAppear');
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, 'aboutToDisappear');
    }
    render() {
        Row.create();
        Row.height('100%');
        Row.create();
        Row.width(this.styleCommon.statusBarMarginLeftRight);
        Row.height('100%');
        Row.pop();
        let earlierCreatedChild_1 = this.findChildById("1");
        if (earlierCreatedChild_1 == undefined) {
            View.create(new batterySoc_1.default("1", this, {}));
        }
        else {
            earlierCreatedChild_1.updateWithValueParams({});
            View.create(earlierCreatedChild_1);
        }
        Row.create();
        Row.width(this.style.componentGap);
        Row.height('100%');
        Row.pop();
        let earlierCreatedChild_2 = this.findChildById("2");
        if (earlierCreatedChild_2 == undefined) {
            View.create(new batteryPic_1.default("2", this, {}));
        }
        else {
            earlierCreatedChild_2.updateWithValueParams({});
            View.create(earlierCreatedChild_2);
        }
        Row.create();
        Row.width(this.styleCommon.statusBarMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Row.pop();
    }
}
exports["default"] = BatteryIcon;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\pages\\batteryPic.ets":
/*!********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\batterycomponent\src\main\ets\default\pages\batteryPic.ets ***!
  \********************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const constants_1 = __importDefault(__webpack_require__(/*! ../common/constants */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\common\\constants.ts"));
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts"));
const BatteryVM_1 = __importDefault(__webpack_require__(/*! ../viewmodel/BatteryVM */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\viewmodel\\BatteryVM.ts"));
const TAG = 'BatteryComponent-batteryPic';
class BatteryPic extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__batterySoc = AppStorage.GetOrCreate().setAndLink("batterySoc", 100, this);
        this.__batteryCharging = AppStorage.GetOrCreate().setAndLink("batteryCharging", false, this);
        this.__mTintContentInfo = new ObservedPropertyObject(BatteryVM_1.default.getTintContentInfo(), this, "mTintContentInfo");
        this.__style = new ObservedPropertyObject(StyleConfiguration_1.default.getBatteryPicStyle(), this, "style");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
    }
    aboutToBeDeleted() {
        this.__batterySoc.aboutToBeDeleted();
        this.__batteryCharging.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get batterySoc() {
        return this.__batterySoc.get();
    }
    set batterySoc(newValue) {
        this.__batterySoc.set(newValue);
    }
    get batteryCharging() {
        return this.__batteryCharging.get();
    }
    set batteryCharging(newValue) {
        this.__batteryCharging.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, 'aboutToAppear Start');
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, 'aboutToDisappear');
    }
    render() {
        Row.create();
        Row.create();
        Row.width(this.style.picBodyWidth);
        Row.height(this.style.picBodyHeight);
        Row.backgroundColor({ "id": 201326606, "type": 10001, params: [] });
        Row.border({ width: this.style.picBodyBorderWidth,
            color: this.mTintContentInfo.contentColor,
            radius: this.style.picBorderRadius,
            style: BorderStyle.Solid });
        Row.padding(this.style.picBodyPadding);
        Row.create();
        Row.height('100%');
        Row.width((this.batterySoc < 100 ? this.batterySoc : 100) + '%');
        Row.backgroundColor(this.getBatteryColor(this.batterySoc, this.batteryCharging));
        Row.pop();
        Row.pop();
        Row.create();
        Row.width(this.style.picGap);
        Row.height(1);
        Row.pop();
        Row.create();
        Row.width(this.style.picHeadWidth);
        Row.height(this.style.picHeadHeight);
        Row.backgroundColor(this.mTintContentInfo.contentColor);
        Row.borderRadius(this.style.picHeadBorderRadius);
        Row.pop();
        Row.pop();
    }
    getBatteryColor(val, charging) {
        Log_1.default.showInfo(TAG, `getBatteryColor, val: ${val}  charging: ${charging} `);
        if (charging) {
            return this.style.picChargingColor;
        }
        else if (val <= constants_1.default.BATTERY_LEVEL_LOW) {
            return this.style.picLevelLowColor;
        }
        else {
            return this.mTintContentInfo.contentColor;
        }
    }
}
exports["default"] = BatteryPic;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\pages\\batterySoc.ets":
/*!********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\batterycomponent\src\main\ets\default\pages\batterySoc.ets ***!
  \********************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const BatteryVM_1 = __importDefault(__webpack_require__(/*! ../viewmodel/BatteryVM */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\viewmodel\\BatteryVM.ts"));
const TAG = 'BatteryComponent-batterySoc';
class BatterySoc extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__batterySoc = AppStorage.GetOrCreate().setAndLink("batterySoc", 100, this);
        this.__mTintContentInfo = new ObservedPropertyObject(BatteryVM_1.default.getTintContentInfo(), this, "mTintContentInfo");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
    }
    aboutToBeDeleted() {
        this.__batterySoc.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get batterySoc() {
        return this.__batterySoc.get();
    }
    set batterySoc(newValue) {
        this.__batterySoc.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, 'aboutToAppear Start');
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, 'aboutToDisappear');
    }
    render() {
        Text.create(this.batterySoc + '%');
        Text.fontColor(this.mTintContentInfo.contentColor);
        Text.fontSize(this.styleCommon.statusBarFontSize);
        Text.pop();
    }
}
exports["default"] = BatterySoc;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\viewmodel\\BatteryVM.ts":
/*!**********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\batterycomponent\src\main\ets\default\viewmodel\BatteryVM.ts ***!
  \**********************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.BatteryVM = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const Constants_1 = __webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const TintStateManager_1 = __webpack_require__(/*! ../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const TAG = 'BatteryVM';
class BatteryVM {
    constructor() {
        this.mTintContentInfo = TintStateManager_1.getOrCreateTintContentInfo(Constants_1.FASlotName.BATTERY);
        Log_1.default.showInfo(TAG, `constructor`);
    }
    getTintContentInfo() {
        return this.mTintContentInfo;
    }
}
exports.BatteryVM = BatteryVM;
let sBatteryVM = SingleInstanceHelper_1.default(BatteryVM, TAG);
exports["default"] = sBatteryVM;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts":
/*!**********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\bluetoothcomponent\src\main\ets\com\ohos\common\Constants.ts ***!
  \**********************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
class Constants {
}
exports["default"] = Constants;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\common\\StyleConfiguration.ts":
/*!*******************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\bluetoothcomponent\src\main\ets\com\ohos\common\StyleConfiguration.ts ***!
  \*******************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const StyleManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
__webpack_require__(/*! ./Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const TAG = 'bluetooth-StyleConfiguration';
class StyleConfiguration {
    static getStatusBarBluetoothComponentStyle() {
        const key = TAG + "-StatusBarBluetoothComponent";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                staticBarBluetoothWidth: { "id": 201326633, "type": 10002, params: [] },
                staticBarBluetoothHeight: { "id": 201326632, "type": 10002, params: [] }
            };
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\model\\BluetoothService.ts":
/*!****************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\bluetoothcomponent\src\main\ets\com\ohos\model\BluetoothService.ts ***!
  \****************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.BluetoothService = void 0;
var bluetooth = globalThis.requireNapi('bluetooth') || (isSystemplugin('bluetooth', 'ohos') ? globalThis.ohosplugin.bluetooth : isSystemplugin('bluetooth', 'system') ? globalThis.systemplugin.bluetooth : undefined);
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const TAG = 'BluetoothModel';
function isBluetoothOpen(state) {
    Log_1.default.showInfo(TAG, `BluetoothState is: ${state}`);
    return state == bluetooth.BluetoothState.STATE_ON || state == bluetooth.BluetoothState.STATE_BLE_ON
        || state == bluetooth.BluetoothState.STATE_TURNING_ON || state == bluetooth.BluetoothState.STATE_BLE_TURNING_ON;
}
class BluetoothService {
    constructor() {
        this.mIsStart = false;
        this.mIsBluetoothOpen = false;
        Log_1.default.showInfo(TAG, `constructor`);
    }
    startService() {
        if (this.mIsStart) {
            return;
        }
        this.mIsStart = true;
        this.mIsBluetoothOpen = isBluetoothOpen(bluetooth.getState());
        bluetooth.on('stateChange', (state) => {
            var _a;
            let isOpen = isBluetoothOpen(state);
            if (this.mIsBluetoothOpen != isOpen) {
                Log_1.default.showInfo(TAG, `state change: ${isOpen}`);
                this.mIsBluetoothOpen = isOpen;
                (_a = this.mListener) === null || _a === void 0 ? void 0 : _a.updateState(this.mIsBluetoothOpen);
            }
        });
        Log_1.default.showInfo(TAG, `startService, mIsBluetoothOpen: ${this.mIsBluetoothOpen}`);
    }
    stopService() {
        if (!this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `stopService`);
        this.mIsStart = false;
        bluetooth.off('stateChange');
    }
    registerListener(listener) {
        Log_1.default.showInfo(TAG, `registerListener, listener: ${listener}`);
        this.mListener = listener;
        this.mListener.updateState(this.mIsBluetoothOpen);
    }
    getState() {
        return this.mIsBluetoothOpen;
    }
    enableBluetooth() {
        Log_1.default.showInfo(TAG, `enableBluetooth`);
        let result = bluetooth.enableBluetooth();
        Log_1.default.showInfo(TAG, `enableBluetooth, result: ${result}`);
        return result;
    }
    disableBluetooth() {
        Log_1.default.showInfo(TAG, `disableBluetooth`);
        let result = bluetooth.disableBluetooth();
        Log_1.default.showInfo(TAG, `disableBluetooth, result: ${result}`);
        return result;
    }
}
exports.BluetoothService = BluetoothService;
let sBluetoothService = SingleInstanceHelper_1.default(BluetoothService, TAG);
exports["default"] = sBluetoothService;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\pages\\StatusBarIconItemBluetoothComponent.ets":
/*!************************************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\bluetoothcomponent\src\main\ets\com\ohos\pages\StatusBarIconItemBluetoothComponent.ets ***!
  \************************************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\common\\StyleConfiguration.ts"));
__webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const BluetoothVM_1 = __importDefault(__webpack_require__(/*! ../viewmodel/BluetoothVM */ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\BluetoothVM.ts"));
const TAG = 'bluetooth-StatusBarIconItemBluetoothComponent';
class StatusBarIconItemBluetoothComponent extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__BluetoothOpenStatus = AppStorage.GetOrCreate().setAndLink("BluetoothOpenStatus", false, this);
        this.__mTintContentInfo = new ObservedPropertyObject(BluetoothVM_1.default.getTintContentInfo(), this, "mTintContentInfo");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getStatusBarBluetoothComponentStyle(), this, "style");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
    }
    aboutToBeDeleted() {
        this.__BluetoothOpenStatus.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get BluetoothOpenStatus() {
        return this.__BluetoothOpenStatus.get();
    }
    set BluetoothOpenStatus(newValue) {
        this.__BluetoothOpenStatus.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, 'aboutToAppear');
        BluetoothVM_1.default.initViewModel();
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, 'aboutToDisappear');
    }
    render() {
        Row.create();
        Row.height('100%');
        If.create();
        if (this.BluetoothOpenStatus) {
            If.branchId(0);
            Row.create();
            Row.width(this.styleCommon.statusBarMarginLeftRight);
            Row.height('100%');
            Row.pop();
            Image.create({ "id": 201326644, "type": 20000, params: [] });
            Image.objectFit(ImageFit.Contain);
            Image.width(this.style.staticBarBluetoothWidth);
            Image.height(this.style.staticBarBluetoothHeight);
            Image.fillColor(this.mTintContentInfo.contentColor);
            Row.create();
            Row.width(this.styleCommon.statusBarMarginLeftRight);
            Row.height('100%');
            Row.pop();
        }
        If.pop();
        Row.pop();
    }
}
exports["default"] = StatusBarIconItemBluetoothComponent;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\BluetoothVM.ts":
/*!***************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\bluetoothcomponent\src\main\ets\com\ohos\viewmodel\BluetoothVM.ts ***!
  \***************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.BluetoothVM = exports.BluetoothOpenStatusKey = void 0;
var bluetooth = globalThis.requireNapi('bluetooth') || (isSystemplugin('bluetooth', 'ohos') ? globalThis.ohosplugin.bluetooth : isSystemplugin('bluetooth', 'system') ? globalThis.systemplugin.bluetooth : undefined);
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const Constants_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const TintStateManager_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const BluetoothService_1 = __importDefault(__webpack_require__(/*! ../model/BluetoothService */ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\model\\BluetoothService.ts"));
exports.BluetoothOpenStatusKey = "BluetoothOpenStatus";
const TAG = 'BluetoothVM';
class BluetoothVM {
    constructor() {
        this.mIsStart = false;
        this.mTintContentInfo = TintStateManager_1.getOrCreateTintContentInfo(Constants_1.FASlotName.BLUETOOTH);
        Log_1.default.showInfo(TAG, `constructor`);
    }
    initViewModel() {
        if (this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `initViewModel `);
        this.mIsStart = true;
        this.mBluetoothOpenStatus = AppStorage.SetAndLink(exports.BluetoothOpenStatusKey, false);
        BluetoothService_1.default.startService();
        BluetoothService_1.default.registerListener(this);
    }
    updateState(state) {
        Log_1.default.showInfo(TAG, `updateState, state: ${state} this.mBluetoothOpenStatus ${this.mBluetoothOpenStatus}`);
        this.mBluetoothOpenStatus.set(state);
    }
    enableBluetooth() {
        return BluetoothService_1.default.enableBluetooth();
    }
    disableBluetooth() {
        return BluetoothService_1.default.disableBluetooth();
    }
    getTintContentInfo() {
        return this.mTintContentInfo;
    }
}
exports.BluetoothVM = BluetoothVM;
let sBluetoothVM = SingleInstanceHelper_1.default(BluetoothVM, TAG);
exports["default"] = sBluetoothVM;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\common\\Constants.ts":
/*!*******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\capsulecomponent\src\main\ets\default\common\Constants.ts ***!
  \*******************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
class Constants {
}
exports["default"] = Constants;
Constants.TOUCH_TYPE_DOWN = 0;
Constants.TOUCH_TYPE_UP = 1;
Constants.TOUCH_TYPE_MOVE = 2;
Constants.DEFAULT_MAX_LINES = 1;
Constants.CAPSULE_HEIGHT_MULTIPLE = 2;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts":
/*!****************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\capsulecomponent\src\main\ets\default\common\StyleConfiguration.ts ***!
  \****************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const StyleManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
const Constants_1 = __importDefault(__webpack_require__(/*! ./Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\common\\Constants.ts"));
const TAG = 'capsule-StyleConfiguration';
class StyleConfiguration {
    static getCapsuleComponentStyle() {
        const key = TAG + "-CapsuleComponent";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                greenCapsulePhoneWidth: { "id": 201326626, "type": 10002, params: [] },
                greenCapsulePhoneHeight: { "id": 201326625, "type": 10002, params: [] },
                greenCapsuleHeight: { "id": 201326624, "type": 10002, params: [] },
                greenCapsuleTextColor: { "id": 201326613, "type": 10001, params: [] },
                greenCapsuleTextMarginLeftRight: { "id": 201326628, "type": 10002, params: [] },
                greenCapsuleRadius: { "id": 201326627, "type": 10002, params: [] },
                greenCapsuleBackgroundColor: { "id": 201326609, "type": 10001, params: [] },
                maxLines: Constants_1.default.DEFAULT_MAX_LINES
            };
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\common\\constants.ts":
/*!*******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\capsulecomponent\src\main\ets\default\common\constants.ts ***!
  \*******************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
class Constants {
}
exports["default"] = Constants;
Constants.TOUCH_TYPE_DOWN = 0;
Constants.TOUCH_TYPE_UP = 1;
Constants.TOUCH_TYPE_MOVE = 2;
Constants.DEFAULT_MAX_LINES = 1;
Constants.CAPSULE_HEIGHT_MULTIPLE = 2;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\model\\CapsuleModel.ts":
/*!*********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\capsulecomponent\src\main\ets\default\model\CapsuleModel.ts ***!
  \*********************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.CapsuleModel = void 0;
var commonEvent = globalThis.requireNapi('commonEvent') || (isSystemplugin('commonEvent', 'ohos') ? globalThis.ohosplugin.commonEvent : isSystemplugin('commonEvent', 'system') ? globalThis.systemplugin.commonEvent : undefined);
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const TAG = 'CapsuleModel';
let commonEventSubscribeInfo = {
    events: ['CAPSULE_EVENT_CALL_UI']
};
let commonEventSubscriber = null;
class CapsuleModel {
    registerCallback(callback) {
        Log_1.default.showInfo(TAG, 'registerCallback');
        this.mCallback = callback;
        if (commonEventSubscriber == null) {
            commonEvent.createSubscriber(commonEventSubscribeInfo, this.createCapsuleSubscriberCallBack.bind(this));
        }
    }
    createCapsuleSubscriberCallBack(err, data) {
        commonEventSubscriber = data;
        commonEvent.subscribe(commonEventSubscriber, (err, data) => {
            Log_1.default.showInfo(TAG, `createCapsuleSubscriberCallBack err: ${JSON.stringify(err)} data: ${JSON.stringify(data)}`);
            if (err.code == 0) {
                const processingData = JSON.parse(data.data);
                if (processingData) {
                    Log_1.default.showInfo(TAG, `createCapsuleSubscriberCallBack processingData: ${JSON.stringify(processingData)} `);
                    this.mCallback.onStateChange(processingData);
                }
            }
            else {
                Log_1.default.showError(TAG, 'date is err');
            }
        });
    }
    unregisterCallback() {
        if (commonEventSubscriber != null) {
            commonEvent.unsubscribe(commonEventSubscriber, () => {
                Log_1.default.showInfo(TAG, 'Subscriberregister unregister Capsule Status Listener ===============');
            });
        }
    }
}
exports.CapsuleModel = CapsuleModel;
let mCapsuleModel = new CapsuleModel();
exports["default"] = mCapsuleModel;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\pages\\CapsuleIcon.ets":
/*!*********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\capsulecomponent\src\main\ets\default\pages\CapsuleIcon.ets ***!
  \*********************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const constants_1 = __importDefault(__webpack_require__(/*! ../common/constants */ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\common\\constants.ts"));
const CapsuleViewModel_1 = __importStar(__webpack_require__(/*! ../viewmodel/CapsuleViewModel */ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\viewmodel\\CapsuleViewModel.ts"));
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts"));
const TAG = "CapsuleIcon";
class CapsuleIcon extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__mCapsuleViewModel = AppStorage.GetOrCreate().setAndLink("VIEW_MODEL_ID", CapsuleViewModel_1.default.getInstance(), this);
        this.startX = 0;
        this.startY = 0;
        this.moveX = 0;
        this.moveY = 0;
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getCapsuleComponentStyle(), this, "style");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.startX !== undefined) {
            this.startX = params.startX;
        }
        if (params.startY !== undefined) {
            this.startY = params.startY;
        }
        if (params.moveX !== undefined) {
            this.moveX = params.moveX;
        }
        if (params.moveY !== undefined) {
            this.moveY = params.moveY;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
    }
    aboutToBeDeleted() {
        this.__mCapsuleViewModel.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get mCapsuleViewModel() {
        return this.__mCapsuleViewModel.get();
    }
    set mCapsuleViewModel(newValue) {
        this.__mCapsuleViewModel.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    aboutToAppear() {
        this.mCapsuleViewModel.initViewModel();
        Log_1.default.showInfo(TAG, 'aboutToAppear, text: ' + this.mCapsuleViewModel.mText);
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, 'aboutToDisappear');
    }
    render() {
        Row.create();
        Row.visibility(this.mCapsuleViewModel.mIsBackground ? Visibility.Visible : Visibility.None);
        Row.create();
        Row.width(this.styleCommon.statusBarMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Row.create();
        Row.alignItems(VerticalAlign.Center);
        Row.height(this.style.greenCapsuleHeight);
        Row.backgroundColor(this.style.greenCapsuleBackgroundColor);
        Row.borderRadius(this.style.greenCapsuleRadius);
        Row.onTouch(this.touchEvent.bind(this));
        Row.create();
        Row.width(this.style.greenCapsuleTextMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Image.create({ "id": 201326646, "type": 20000, params: [] });
        Image.width(this.style.greenCapsulePhoneWidth);
        Image.height(this.style.greenCapsulePhoneHeight);
        Image.objectFit(ImageFit.Contain);
        Row.create();
        Row.width(this.style.greenCapsuleTextMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Text.create(this.mCapsuleViewModel.mText);
        Text.fontSize(this.styleCommon.statusBarFontSize);
        Text.fontWeight(FontWeight.Regular);
        Text.fontColor(this.style.greenCapsuleTextColor);
        Text.maxLines(this.style.maxLines);
        Text.textOverflow({ overflow: TextOverflow.Ellipsis });
        Text.pop();
        Row.create();
        Row.width(this.style.greenCapsuleTextMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Row.pop();
        Row.create();
        Row.width(this.styleCommon.statusBarMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Row.pop();
    }
    touchEvent(event) {
        Log_1.default.showInfo(TAG, `touchEventtouchEventtouchEvent`);
        if (event.type == constants_1.default.TOUCH_TYPE_DOWN) {
            this.startX = event.touches[0].screenX;
            this.startY = event.touches[0].screenY;
            this.moveX = 0;
            this.moveY = 0;
            Log_1.default.showInfo(TAG, `touchStart2=======startX: ${this.startX}, startY: ${this.startY}`);
        }
        else if (event.type == constants_1.default.TOUCH_TYPE_MOVE) {
            this.moveX = event.touches[0].screenX - this.startX;
            this.moveY = event.touches[0].screenY - this.startY;
        }
        else if (event.type == constants_1.default.TOUCH_TYPE_UP) {
            Log_1.default.showInfo(TAG, `touchEnd2, moveX: ${this.moveX}, moveY: ${this.moveY}`);
            if (this.moveX < 5 && this.moveX > -5 && this.moveY < 5 && this.moveY > -5) {
                event.stopPropagation();
                this.mCapsuleViewModel.onClickEvent();
                this.mCapsuleViewModel.mIsBackground = false;
            }
        }
    }
}
exports["default"] = CapsuleIcon;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\viewmodel\\CapsuleViewModel.ts":
/*!*****************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\capsulecomponent\src\main\ets\default\viewmodel\CapsuleViewModel.ts ***!
  \*****************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.CallState = exports.VIEW_MODEL_ID = void 0;
const CapsuleModel_1 = __importDefault(__webpack_require__(/*! ../model/CapsuleModel */ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\model\\CapsuleModel.ts"));
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const abilityManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/abilitymanager/abilityManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\abilitymanager\\abilityManager.ts"));
const ResourceUtil_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/ResourceUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\ResourceUtil.ts"));
let sCapsuleViewModel;
const SEC_VAL = 1000;
const MIN_VAL = 60 * SEC_VAL;
const TAG = "CapsuleViewModel";
function fixInteger(num) {
    return (num >= 10) ? String(num) : '0' + num;
}
function parseTime(num) {
    return fixInteger(Math.floor(num / MIN_VAL)) + ":" + fixInteger(Math.floor((num % MIN_VAL) / SEC_VAL));
}
exports.VIEW_MODEL_ID = "CapsuleViewModelVm";
var CallState;
(function (CallState) {
    CallState[CallState["CALL_ACTIVE"] = 0] = "CALL_ACTIVE";
    CallState[CallState["CALL_HOLDING"] = 1] = "CALL_HOLDING";
    CallState[CallState["CALL_DIALING"] = 2] = "CALL_DIALING";
    CallState[CallState["CALL_ALERTING"] = 3] = "CALL_ALERTING";
    CallState[CallState["CALL_INCOMING"] = 4] = "CALL_INCOMING";
    CallState[CallState["CALL_WAITING"] = 5] = "CALL_WAITING";
    CallState[CallState["CALL_DISCONNECTED"] = 6] = "CALL_DISCONNECTED";
    CallState[CallState["CALL_DISCONNECTING"] = 7] = "CALL_DISCONNECTING";
    CallState[CallState["CALL_IDLE"] = 8] = "CALL_IDLE"; //空闲
})(CallState = exports.CallState || (exports.CallState = {}));
class CapsuleViewModel {
    constructor() {
        this.mText = "00:00";
        this.mStartTime = 0;
        this.mCallState = CallState.CALL_DISCONNECTED;
        this.mIsBackground = false;
        this.mWantBundleName = "";
        this.mWantAbilityName = "";
    }
    async initViewModel() {
        this.mCallback = {
            "onStateChange": this.onStateChange.bind(this)
        };
        CapsuleModel_1.default.registerCallback(this.mCallback);
    }
    async onStateChange(data) {
        Log_1.default.showInfo(TAG, `onStateChange, data: ${JSON.stringify(data)}`);
        this.mIsBackground = data.isBackground;
        this.mWantBundleName = data.wantBundleName;
        this.mWantAbilityName = data.wantAbilityName;
        if (data.callState == CallState.CALL_INCOMING || data.callState == CallState.CALL_WAITING) {
            this.mStartTime = 0;
            this.mText = await ResourceUtil_1.default.getString($r("app.string.incoming_call"));
        }
        else if (data.callState == CallState.CALL_ACTIVE) {
            clearTimeout(this.mTimeMeter);
            if (this.mCallState != CallState.CALL_ACTIVE) {
                this.mStartTime = new Date().valueOf();
            }
            this.mCallState = data.callState;
            let startTime;
            let commonTimeDiff = new Date().valueOf() - data.startTime;
            let localTimeDiff = new Date().valueOf() - this.mStartTime;
            if (commonTimeDiff < 0) {
                if (localTimeDiff < 0) {
                    startTime = new Date().valueOf();
                }
                else {
                    startTime = this.mStartTime;
                }
            }
            else {
                startTime = data.startTime;
            }
            this.startUpdateTime(startTime);
        }
        else if (data.callState == CallState.CALL_DISCONNECTED) {
            clearTimeout(this.mTimeMeter);
            this.mStartTime = 0;
            this.mIsBackground = false;
            this.mText = "";
            Log_1.default.showInfo(TAG, `cannot show`);
        }
        else {
            this.mStartTime = 0;
            this.mText = await ResourceUtil_1.default.getString($r("app.string.communicate_by_phone"));
        }
        this.mCallState = data.callState;
    }
    startUpdateTime(startTime) {
        if (!this.mIsBackground || this.mCallState != CallState.CALL_ACTIVE) {
            return;
        }
        let val = new Date().valueOf() - startTime.valueOf();
        if (val < 0) {
            val = 0;
        }
        this.mText = parseTime(val);
        this.mTimeMeter = setTimeout(() => {
            this.startUpdateTime(startTime);
        }, 1000 - val % 1000);
    }
    onClickEvent() {
        if (this.mIsBackground) {
            this.mIsBackground = false;
        }
        Log_1.default.showInfo(TAG, `onClickEvent `);
        Log_1.default.showInfo(TAG, `startAbility`);
        abilityManager_1.default.startAbility({
            bundleName: this.mWantBundleName,
            abilityName: this.mWantAbilityName
        });
    }
    static getInstance() {
        if (sCapsuleViewModel == null) {
            sCapsuleViewModel = new CapsuleViewModel();
            AppStorage.SetAndLink(exports.VIEW_MODEL_ID, sCapsuleViewModel);
        }
        return sCapsuleViewModel;
    }
}
exports["default"] = CapsuleViewModel;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\clockcomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts":
/*!**************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\clockcomponent\src\main\ets\default\common\StyleConfiguration.ts ***!
  \**************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const StyleManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
const TAG = 'clock-StyleConfiguration';
class StyleConfiguration {
    static getClockComponentStyle() {
        const key = TAG + "-ClockComponent";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                statusBarClockMaxWidth: { "id": 201326634, "type": 10002, params: [] }
            };
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\clockcomponent\\src\\main\\ets\\default\\pages\\clockIcon.ets":
/*!*****************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\clockcomponent\src\main\ets\default\pages\clockIcon.ets ***!
  \*****************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\clockcomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const ClockVM_1 = __importDefault(__webpack_require__(/*! ../viewmodel/ClockVM */ "D:\\code\\release\\my\\applications_systemui\\features\\clockcomponent\\src\\main\\ets\\default\\viewmodel\\ClockVM.ts"));
const TimeManager_1 = __importStar(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/TimeManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TimeManager.ts"));
const EventManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/event/EventManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventManager.ts"));
const TAG = 'ClockComponent-clockIcon';
class ClockIcon extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__mTime = new ObservedPropertySimple('16:01', this, "mTime");
        this.__mTintContentInfo = new ObservedPropertyObject(ClockVM_1.default.getTintContentInfo(), this, "mTintContentInfo");
        this.__style = new ObservedPropertyObject(StyleConfiguration_1.default.getClockComponentStyle(), this, "style");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_2.default.getCommonStyle(), this, "styleCommon");
        this.unSubscriber = undefined;
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mTime !== undefined) {
            this.mTime = params.mTime;
        }
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
        if (params.unSubscriber !== undefined) {
            this.unSubscriber = params.unSubscriber;
        }
    }
    aboutToBeDeleted() {
        this.__mTime.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get mTime() {
        return this.__mTime.get();
    }
    set mTime(newValue) {
        this.__mTime.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, 'aboutToAppear');
        this.unSubscriber = EventManager_1.default.subscribe(TimeManager_1.TIME_CHANGE_EVENT, (args) => {
            this.mTime = TimeManager_1.default.formatTime(args.date);
        });
        this.mTime = TimeManager_1.default.formatTime(new Date());
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, 'aboutToDisappear');
        this.unSubscriber && this.unSubscriber();
        this.unSubscriber = undefined;
    }
    render() {
        Row.create();
        Row.create();
        Row.width(this.styleCommon.statusBarMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Text.create(this.mTime);
        Text.fontColor(this.mTintContentInfo.contentColor);
        Text.fontSize(this.styleCommon.statusBarFontSize);
        Text.width(this.style.statusBarClockMaxWidth);
        Text.textAlign(TextAlign.Center);
        Text.pop();
        Row.create();
        Row.width(this.styleCommon.statusBarMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Row.pop();
    }
}
exports["default"] = ClockIcon;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\clockcomponent\\src\\main\\ets\\default\\viewmodel\\ClockVM.ts":
/*!******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\clockcomponent\src\main\ets\default\viewmodel\ClockVM.ts ***!
  \******************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ClockVM = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const Constants_1 = __webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const TintStateManager_1 = __webpack_require__(/*! ../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const TAG = 'ClockVM';
class ClockVM {
    constructor() {
        this.mTintContentInfo = TintStateManager_1.getOrCreateTintContentInfo(Constants_1.FASlotName.CLOCK);
        Log_1.default.showInfo(TAG, `constructor`);
    }
    getTintContentInfo() {
        return this.mTintContentInfo;
    }
}
exports.ClockVM = ClockVM;
let sClockVM = SingleInstanceHelper_1.default(ClockVM, TAG);
exports["default"] = sClockVM;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts":
/*!*********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\locationcomponent\src\main\ets\com\ohos\common\Constants.ts ***!
  \*********************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.LocationData = void 0;
class Constants {
}
exports["default"] = Constants;
class LocationData {
}
exports.LocationData = LocationData;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\common\\StyleConfiguration.ts":
/*!******************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\locationcomponent\src\main\ets\com\ohos\common\StyleConfiguration.ts ***!
  \******************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const StyleManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
__webpack_require__(/*! ./Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const TAG = 'location-StyleConfiguration';
class StyleConfiguration {
    static getStartsBarLocationComponentStyle() {
        const key = TAG + "-startsBarLocation";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                statusBarLocationWidth: { "id": 201326636, "type": 10002, params: [] },
                statusBarLocationHeight: { "id": 201326635, "type": 10002, params: [] },
            };
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\model\\LocationService.ts":
/*!**************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\locationcomponent\src\main\ets\com\ohos\model\LocationService.ts ***!
  \**************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.LocationService = void 0;
var geolocation = globalThis.requireNapi('geolocation') || (isSystemplugin('geolocation', 'ohos') ? globalThis.ohosplugin.geolocation : isSystemplugin('geolocation', 'system') ? globalThis.systemplugin.geolocation : undefined);
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const TAG = 'LocationModel';
class LocationService {
    constructor() {
        this.mIsStart = false;
    }
    startService() {
        if (this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `startService`);
        this.mIsStart = true;
        this.getServiceState();
        geolocation.on('locationServiceState', (state) => {
            Log_1.default.showInfo(TAG, `startService locationChange, state: ${JSON.stringify(state)}`);
            this.getServiceState();
        });
    }
    stopService() {
        if (!this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `stopService`);
        this.mIsStart = false;
        geolocation.off('locationServiceState', (state) => {
            Log_1.default.showInfo(TAG, `stopService locationChange, state: ${JSON.stringify(state)}`);
        });
    }
    registerListener(listener) {
        Log_1.default.showInfo(TAG, `registerListener, listener: ${listener}`);
        this.mListener = listener;
    }
    getServiceState() {
        Log_1.default.showInfo(TAG, `getServiceState`);
        geolocation.isLocationEnabled().then((data) => {
            var _a;
            Log_1.default.showInfo(TAG, `getServiceState isLocationEnabled, data: ${JSON.stringify(data)}`);
            (_a = this.mListener) === null || _a === void 0 ? void 0 : _a.updateServiceState(data);
        });
    }
    enableLocation() {
        Log_1.default.showInfo(TAG, `enableLocation`);
        geolocation.enableLocation()
            .then((res) => Log_1.default.showInfo(TAG, `enableLocation, result: ${JSON.stringify(res)}`));
    }
    disableLocation() {
        Log_1.default.showInfo(TAG, `disableLocation`);
        geolocation.disableLocation()
            .then((res) => Log_1.default.showInfo(TAG, `disableLocation, result: ${JSON.stringify(res)}`));
    }
}
exports.LocationService = LocationService;
let sLocationService = SingleInstanceHelper_1.default(LocationService, TAG);
exports["default"] = sLocationService;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\pages\\StatusBarIconItemLocationComponent.ets":
/*!**********************************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\locationcomponent\src\main\ets\com\ohos\pages\StatusBarIconItemLocationComponent.ets ***!
  \**********************************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\common\\StyleConfiguration.ts"));
__webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const LocationVM_1 = __importDefault(__webpack_require__(/*! ../viewmodel/LocationVM */ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\LocationVM.ts"));
const TAG = 'location-StatusBarIconItemLocationComponent';
class StatusBarIconItemLocationComponent extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__LocationServiceUseStatus = AppStorage.GetOrCreate().setAndLink("LocationServiceUseStatus", false, this);
        this.__mTintContentInfo = new ObservedPropertyObject(LocationVM_1.default.getTintContentInfo(), this, "mTintContentInfo");
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getStartsBarLocationComponentStyle(), this, "style");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
    }
    aboutToBeDeleted() {
        this.__LocationServiceUseStatus.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get LocationServiceUseStatus() {
        return this.__LocationServiceUseStatus.get();
    }
    set LocationServiceUseStatus(newValue) {
        this.__LocationServiceUseStatus.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, 'aboutToAppear');
        LocationVM_1.default.initViewModel();
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, 'aboutToDisappear');
    }
    render() {
        Row.create();
        Row.height('100%');
        If.create();
        if (this.LocationServiceUseStatus) {
            If.branchId(0);
            Row.create();
            Row.width(this.styleCommon.statusBarMarginLeftRight);
            Row.height('100%');
            Row.pop();
            Image.create({ "id": 201326645, "type": 20000, params: [] });
            Image.objectFit(ImageFit.Contain);
            Image.width(this.style.statusBarLocationWidth);
            Image.height(this.style.statusBarLocationHeight);
            Image.fillColor(this.mTintContentInfo.contentColor);
            Row.create();
            Row.width(this.styleCommon.statusBarMarginLeftRight);
            Row.height('100%');
            Row.pop();
        }
        If.pop();
        Row.pop();
    }
}
exports["default"] = StatusBarIconItemLocationComponent;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\LocationVM.ts":
/*!*************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\locationcomponent\src\main\ets\com\ohos\viewmodel\LocationVM.ts ***!
  \*************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.LocationVM = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const Constants_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const TintStateManager_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const Constants_2 = __webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const LocationService_1 = __importDefault(__webpack_require__(/*! ../model/LocationService */ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\model\\LocationService.ts"));
const TAG = 'LocationVM';
class LocationVM {
    constructor() {
        this.mIsStart = false;
        this.mLocationData = Object.assign({}, new Constants_2.LocationData());
        this.mTintContentInfo = TintStateManager_1.getOrCreateTintContentInfo(Constants_1.FASlotName.LOCATION);
        Log_1.default.showInfo(TAG, `constructor`);
    }
    initViewModel() {
        if (this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `initViewModel `);
        this.mIsStart = true;
        this.mLocationData = AppStorage.SetAndLink(TAG + '_LocationData', this.mLocationData).get();
        LocationService_1.default.registerListener(this);
        LocationService_1.default.startService();
    }
    getLocationData() {
        Log_1.default.showInfo(TAG, `getLocationData`);
        return this.mLocationData;
    }
    updateServiceState(state) {
        Log_1.default.showInfo(TAG, `updateServiceState, state: ${state} `);
        this.mLocationData.isEnabled = state;
    }
    enableLocation() {
        Log_1.default.showInfo(TAG, `enableLocation`);
        LocationService_1.default.enableLocation();
    }
    disableLocation() {
        Log_1.default.showInfo(TAG, `disableLocation`);
        LocationService_1.default.disableLocation();
    }
    getTintContentInfo() {
        return this.mTintContentInfo;
    }
}
exports.LocationVM = LocationVM;
let sLocationVM = SingleInstanceHelper_1.default(LocationVM, TAG);
exports["default"] = sLocationVM;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts":
/*!*********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\ringmodecomponent\src\main\ets\com\ohos\common\Constants.ts ***!
  \*********************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AudioRingMode = void 0;
var audio = globalThis.requireNapi('multimedia.audio') || (isSystemplugin('multimedia.audio', 'ohos') ? globalThis.ohosplugin.multimedia.audio : isSystemplugin('multimedia.audio', 'system') ? globalThis.systemplugin.multimedia.audio : undefined);
class Constants {
}
exports["default"] = Constants;
var AudioRingMode;
(function (AudioRingMode) {
    AudioRingMode[AudioRingMode["RINGER_MODE_SILENT"] = audio.AudioRingMode.RINGER_MODE_SILENT] = "RINGER_MODE_SILENT";
    AudioRingMode[AudioRingMode["RINGER_MODE_VIBRATE"] = audio.AudioRingMode.RINGER_MODE_VIBRATE] = "RINGER_MODE_VIBRATE";
    AudioRingMode[AudioRingMode["RINGER_MODE_NORMAL"] = audio.AudioRingMode.RINGER_MODE_NORMAL] = "RINGER_MODE_NORMAL";
})(AudioRingMode = exports.AudioRingMode || (exports.AudioRingMode = {}));


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\common\\StyleConfiguration.ts":
/*!******************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\ringmodecomponent\src\main\ets\com\ohos\common\StyleConfiguration.ts ***!
  \******************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const StyleManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
__webpack_require__(/*! ./Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const TAG = 'capsule-StyleConfiguration';
class StyleConfiguration {
    static getStatusRingModeComponentStyle() {
        const key = TAG + "-StatusRingMode";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                statusBarRingModeWidth: { "id": 201326638, "type": 10002, params: [] },
                statusBarRingModeHeight: { "id": 201326637, "type": 10002, params: [] }
            };
        });
    }
    static getControlCenterRingModeComponentStyle() {
        const key = TAG + "-ControlCenterRingMode";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                onBgColor: { "id": 201326610, "type": 10001, params: [] }
            };
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\model\\RingModeService.ts":
/*!**************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\ringmodecomponent\src\main\ets\com\ohos\model\RingModeService.ts ***!
  \**************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.RingModeService = void 0;
var audio = globalThis.requireNapi('multimedia.audio') || (isSystemplugin('multimedia.audio', 'ohos') ? globalThis.ohosplugin.multimedia.audio : isSystemplugin('multimedia.audio', 'system') ? globalThis.systemplugin.multimedia.audio : undefined);
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const SingleInstanceHelper_2 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts");
const TAG = 'RingModeModel';
class RingModeService {
    constructor() {
        this.mIsStart = false;
    }
    startService() {
        if (this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `startService`);
        this.mIsStart = true;
        this.mAudioManager = SingleInstanceHelper_2.getAudioManager();
        this.getRingerMode();
        this.mAudioManager.on('ringerModeChange', (data) => {
            var _a;
            Log_1.default.showInfo(TAG, `startService->ringerModeChange, data: ${JSON.stringify(data)}`);
            (_a = this.mListener) === null || _a === void 0 ? void 0 : _a.updateRingerMode(data);
        });
    }
    stopService() {
        if (!this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `stopService`);
        this.mIsStart = false;
        this.mAudioManager = null;
    }
    registerListener(listener) {
        Log_1.default.showInfo(TAG, `registerListener, listener: ${listener}`);
        this.mListener = listener;
    }
    getRingerMode() {
        Log_1.default.showInfo(TAG, `getRingerMode`);
        this.mAudioManager.getRingerMode((error, action) => {
            var _a;
            Log_1.default.showInfo(TAG, `getRingerMode, error: ${JSON.stringify(error)} action: ${JSON.stringify(action)}`);
            if (error) {
                return;
            }
            (_a = this.mListener) === null || _a === void 0 ? void 0 : _a.updateRingerMode(action);
        });
    }
    setRingerMode(mode) {
        Log_1.default.showInfo(TAG, `setRingerMode, mode: ${JSON.stringify(mode)}`);
        this.mAudioManager.setRingerMode(mode, (err, data) => {
            Log_1.default.showInfo(TAG, `mAudioManager.setRingerMode, mode: ${JSON.stringify(mode)}`);
        });
    }
}
exports.RingModeService = RingModeService;
let sRingModeService = SingleInstanceHelper_1.default(RingModeService, TAG);
exports["default"] = sRingModeService;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\pages\\StatusBarIconItemRingModeComponent.ets":
/*!**********************************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\ringmodecomponent\src\main\ets\com\ohos\pages\StatusBarIconItemRingModeComponent.ets ***!
  \**********************************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\common\\StyleConfiguration.ts"));
const Constants_1 = __webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const RingModeVM_1 = __importDefault(__webpack_require__(/*! ../viewmodel/RingModeVM */ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\RingModeVM.ts"));
const TAG = 'ringmode-StatusBarIconItemRingModeComponent';
class StatusBarIconItemRingModeComponent extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__RingModeComponentMode = AppStorage.GetOrCreate().setAndLink("RingModeComponentMode", Constants_1.AudioRingMode.RINGER_MODE_NORMAL, this);
        this.__mTintContentInfo = new ObservedPropertyObject(RingModeVM_1.default.getTintContentInfo(), this, "mTintContentInfo");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getStatusRingModeComponentStyle(), this, "style");
        this.ringModeIcons = undefined;
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
        if (params.ringModeIcons !== undefined) {
            this.ringModeIcons = params.ringModeIcons;
        }
    }
    aboutToBeDeleted() {
        this.__RingModeComponentMode.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get RingModeComponentMode() {
        return this.__RingModeComponentMode.get();
    }
    set RingModeComponentMode(newValue) {
        this.__RingModeComponentMode.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, 'aboutToAppear');
        this.ringModeIcons = {};
        this.ringModeIcons[Constants_1.AudioRingMode.RINGER_MODE_SILENT.toString()] = { "id": 201326647, "type": 20000, params: [] };
        this.ringModeIcons[Constants_1.AudioRingMode.RINGER_MODE_VIBRATE.toString()] = { "id": 201326656, "type": 20000, params: [] };
        RingModeVM_1.default.initViewModel();
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, 'aboutToDisappear');
    }
    render() {
        Row.create();
        Row.height('100%');
        If.create();
        if (this.RingModeComponentMode != Constants_1.AudioRingMode.RINGER_MODE_NORMAL) {
            If.branchId(0);
            Row.create();
            Row.width(this.styleCommon.statusBarMarginLeftRight);
            Row.height('100%');
            Row.pop();
            Image.create(this.ringModeIcons[this.RingModeComponentMode.toString()]);
            Image.objectFit(ImageFit.Contain);
            Image.width(this.style.statusBarRingModeWidth);
            Image.height(this.style.statusBarRingModeHeight);
            Image.fillColor(this.mTintContentInfo.contentColor);
            Row.create();
            Row.width(this.styleCommon.statusBarMarginLeftRight);
            Row.height('100%');
            Row.pop();
        }
        If.pop();
        Row.pop();
    }
}
exports["default"] = StatusBarIconItemRingModeComponent;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\RingModeVM.ts":
/*!*************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\ringmodecomponent\src\main\ets\com\ohos\viewmodel\RingModeVM.ts ***!
  \*************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.RingModeVM = exports.RingModeComponentModeKey = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const Constants_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const TintStateManager_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const Constants_2 = __webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const RingModeService_1 = __importDefault(__webpack_require__(/*! ../model/RingModeService */ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\model\\RingModeService.ts"));
exports.RingModeComponentModeKey = "RingModeComponentMode";
const TAG = 'RingModeVM';
class RingModeVM {
    constructor() {
        this.mIsStart = false;
        this.mTintContentInfo = TintStateManager_1.getOrCreateTintContentInfo(Constants_1.FASlotName.RING_MODE);
        Log_1.default.showInfo(TAG, `constructor`);
    }
    initViewModel() {
        if (this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `initViewModel `);
        this.mIsStart = true;
        this.mRingModeComponentMode = AppStorage.SetAndLink(exports.RingModeComponentModeKey, Constants_2.AudioRingMode.RINGER_MODE_NORMAL);
        RingModeService_1.default.registerListener({
            'updateRingerMode': this.updateRingerMode.bind(this)
        });
        RingModeService_1.default.startService();
    }
    updateRingerMode(mode) {
        Log_1.default.showInfo(TAG, `updateRingerMode, mode: ${JSON.stringify(mode)} `);
        this.mRingModeComponentMode.set(mode);
    }
    setRingerMode(mode) {
        Log_1.default.showInfo(TAG, `setRingerMode, mode: ${JSON.stringify(mode)} `);
        RingModeService_1.default.setRingerMode(mode);
    }
    getTintContentInfo() {
        return this.mTintContentInfo;
    }
}
exports.RingModeVM = RingModeVM;
let sRingModeVM = SingleInstanceHelper_1.default(RingModeVM, TAG);
exports["default"] = sRingModeVM;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\SignalModel.ts":
/*!*************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\signalcomponent\src\main\ets\default\SignalModel.ts ***!
  \*************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.SignalModel = void 0;
var Radio = globalThis.requireNapi('telephony.radio') || (isSystemplugin('telephony.radio', 'ohos') ? globalThis.ohosplugin.telephony.radio : isSystemplugin('telephony.radio', 'system') ? globalThis.systemplugin.telephony.radio : undefined);
var Sim = globalThis.requireNapi('telephony.sim') || (isSystemplugin('telephony.sim', 'ohos') ? globalThis.ohosplugin.telephony.sim : isSystemplugin('telephony.sim', 'system') ? globalThis.systemplugin.telephony.sim : undefined);
var Observer = globalThis.requireNapi('telephony.observer') || (isSystemplugin('telephony.observer', 'ohos') ? globalThis.ohosplugin.telephony.observer : isSystemplugin('telephony.observer', 'system') ? globalThis.systemplugin.telephony.observer : undefined);
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../../../../../../common/src/main/ets/default/CheckEmptyUtils */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\CheckEmptyUtils.ts");
const constants_1 = __importDefault(__webpack_require__(/*! ./common/constants */ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\common\\constants.ts"));
const TAG = 'SignalStatus-SignalModel';
const EMPTY_LEVEL = 0;
let mSignalCallback;
let signalValue = {
    cellularLevel: '',
    cellularType: '',
    networkState: ''
};
let isInitObserver = false;
var mLevelLink;
var mTypeLink;
var mStateLink;
class SignalModel {
    initSignalModel() {
        Log_1.default.showInfo(TAG, 'initSignalModel');
        mLevelLink = AppStorage.SetAndLink("cellularLevel", constants_1.default.CELLULAR_NO_SIM_CARD);
        mTypeLink = AppStorage.SetAndLink("cellularType", constants_1.default.NETWORK_TYPE_UNKNOWN);
        mStateLink = AppStorage.SetAndLink("networkState", constants_1.default.NET_NULL);
        this.checkCellularStatus();
    }
    uninitSignalModel() {
        Log_1.default.showInfo(TAG, 'uninitSignalModel');
        this.unInitObserver();
    }
    /**
       * Check the connection type and signal level of cellular network
       */
    checkCellularStatus() {
        let cellularStatus;
        let slotId = 0;
        Log_1.default.showInfo(TAG, 'enter checkCellularStatus ============');
        Sim.hasSimCard(slotId, (err, value) => {
            if (value === true) {
                //The interface of getting the cellular signal status is unavailable temporarily
                Radio.getSignalInformation(slotId, (err, value) => {
                    if (err) {
                        // Failed to call the interface，error is not null
                        Log_1.default.showError(TAG, `failed to getSimState because ${err.message}`);
                        // When failed to call the interface, set the result as no signal
                        mLevelLink.set(constants_1.default.CELLULAR_NO_SIM_CARD);
                        mTypeLink.set(constants_1.default.NETWORK_TYPE_UNKNOWN);
                    }
                    else {
                        // Call interface succeed，error is null
                        Log_1.default.showInfo(TAG, `success to getSignalInformation: ${JSON.stringify(value)}`);
                        // Since the value might be empty, set it as no signal by hand
                        if (!value || !value.length) {
                            Log_1.default.showError(TAG, 'value from api is empty, set 0');
                            mLevelLink.set(constants_1.default.CELLULAR_NO_SIM_CARD);
                            mTypeLink.set(constants_1.default.NETWORK_TYPE_UNKNOWN);
                        }
                        else {
                            Log_1.default.showInfo(TAG, 'get signal level by value.');
                            mLevelLink.set(value[0].signalLevel);
                            mTypeLink.set(value[0].signalType);
                        }
                    }
                    Log_1.default.showInfo(TAG, 'enter checknetworkState ============');
                    //The interface of getting the cellular signal status is unavailable temporarily
                    Radio.getNetworkState((err, value) => {
                        if (err) {
                            // Failed to call the interface，error is not null
                            Log_1.default.showError(TAG, `failed to getnetworkState because ${err.message}`);
                            // When failed to call the interface, set the result as no signal
                            mStateLink.set(constants_1.default.NET_NULL);
                        }
                        else {
                            // Call interface succeed，error is null
                            Log_1.default.showInfo(TAG, `success to getnetworkState: ${JSON.stringify(value)}`);
                            // Since the value might be empty, set it as no signal by hand
                            if (!value) {
                                Log_1.default.showError(TAG, 'value from api is empty, set 0');
                                mStateLink.set(constants_1.default.NET_NULL);
                            }
                            else {
                                mStateLink.set(value.longOperatorName);
                            }
                        }
                    });
                });
                if (!isInitObserver) {
                    this.initObserver();
                }
            }
            else {
                Log_1.default.showError(TAG, `hasSimCard failed to hasSimCard because`);
                mLevelLink.set(constants_1.default.CELLULAR_NO_SIM_CARD);
                mTypeLink.set(constants_1.default.NETWORK_TYPE_UNKNOWN);
                mStateLink.set(constants_1.default.NET_NULL);
                if (!isInitObserver) {
                    this.initObserver();
                }
            }
        });
    }
    /**
       * init the observer of the cellular and signal
       */
    initObserver() {
        Log_1.default.showInfo(TAG, 'initObserver');
        isInitObserver = true;
        Observer.on('signalInfoChange', (signalInfoChange) => {
            Log_1.default.showInfo(TAG, `signalInfoChange ${JSON.stringify(signalInfoChange)}`);
            this.checkCellularStatus();
        });
        Observer.on('networkStateChange', (networkState) => {
            Log_1.default.showInfo(TAG, `networkStateChange ${JSON.stringify(networkState)}`);
            this.checkCellularStatus();
        });
        Observer.on('simStateChange', (simStateInfo) => {
            Log_1.default.showInfo(TAG, `simStateChange ${JSON.stringify(simStateInfo)}`);
            this.checkCellularStatus();
        });
    }
    /**
       * Uninit the observer of the cellular and signal
       */
    unInitObserver() {
        Log_1.default.showInfo(TAG, 'unInitObserver');
        Observer.off('signalInfoChange');
        Observer.off('networkStateChange');
        Observer.off('simStateChange');
        isInitObserver = false;
    }
}
exports.SignalModel = SignalModel;
let mSignalModel = new SignalModel();
exports["default"] = mSignalModel;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\common\\Constants.ts":
/*!******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\signalcomponent\src\main\ets\default\common\Constants.ts ***!
  \******************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
class Constants {
}
exports["default"] = Constants;
Constants.NETWORK_TYPE_UNKNOWN = 0;
Constants.NETWORK_TYPE_GSM = 1;
Constants.NETWORK_TYPE_CDMA = 2;
Constants.NETWORK_TYPE_W_CDMA = 3;
Constants.NETWORK_TYPE_TDS_CDMA = 4;
Constants.NETWORK_TYPE_LTE = 5;
Constants.NETWORK_TYPE_NR = 6;
Constants.CELLULAR_SIGNAL_NO = 0;
Constants.CELLULAR_SIGNAL_MIN = 1;
Constants.CELLULAR_SIGNAL_LOW = 2;
Constants.CELLULAR_SIGNAL_HALF = 3;
Constants.CELLULAR_SIGNAL_HIGH = 4;
Constants.CELLULAR_SIGNAL_FULL = 5;
Constants.CELLULAR_NO_SIM_CARD = -1;
Constants.NET_NULL = 'NULL';


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts":
/*!***************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\signalcomponent\src\main\ets\default\common\StyleConfiguration.ts ***!
  \***************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const StyleManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
__webpack_require__(/*! ./Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\common\\Constants.ts");
const TAG = 'signal-StyleConfiguration';
class StyleConfiguration {
    static getSignalComponentStyle() {
        const key = TAG + "-SignalComponent";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                cellularImageWidth: { "id": 201326630, "type": 10002, params: [] },
                cellularImageHeight: { "id": 201326629, "type": 10002, params: [] },
                statusBarSignalTypeFontSize: { "id": 201326640, "type": 10002, params: [] },
                statusBarSignalUnknownFontSize: { "id": 201326641, "type": 10002, params: [] },
                signalTextMaxWeight: { "id": 201326631, "type": 10002, params: [] },
                netSignalTextMaxWidth: { "id": 201326639, "type": 10002, params: [] },
            };
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\common\\constants.ts":
/*!******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\signalcomponent\src\main\ets\default\common\constants.ts ***!
  \******************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
class Constants {
}
exports["default"] = Constants;
Constants.NETWORK_TYPE_UNKNOWN = 0;
Constants.NETWORK_TYPE_GSM = 1;
Constants.NETWORK_TYPE_CDMA = 2;
Constants.NETWORK_TYPE_W_CDMA = 3;
Constants.NETWORK_TYPE_TDS_CDMA = 4;
Constants.NETWORK_TYPE_LTE = 5;
Constants.NETWORK_TYPE_NR = 6;
Constants.CELLULAR_SIGNAL_NO = 0;
Constants.CELLULAR_SIGNAL_MIN = 1;
Constants.CELLULAR_SIGNAL_LOW = 2;
Constants.CELLULAR_SIGNAL_HALF = 3;
Constants.CELLULAR_SIGNAL_HIGH = 4;
Constants.CELLULAR_SIGNAL_FULL = 5;
Constants.CELLULAR_NO_SIM_CARD = -1;
Constants.NET_NULL = 'NULL';


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\pages\\signalIcon.ets":
/*!*******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\signalcomponent\src\main\ets\default\pages\signalIcon.ets ***!
  \*******************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const constants_1 = __importDefault(__webpack_require__(/*! ../common/constants */ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\common\\constants.ts"));
const SignalModel_1 = __importDefault(__webpack_require__(/*! ../SignalModel */ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\SignalModel.ts"));
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts"));
const SignalVM_1 = __importDefault(__webpack_require__(/*! ../viewmodel/SignalVM */ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\viewmodel\\SignalVM.ts"));
const TAG = 'SignalComponent-SignalIcon';
class SignalIcon extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__cellularLevel = AppStorage.GetOrCreate().setAndLink("cellularLevel", constants_1.default.CELLULAR_NO_SIM_CARD, this);
        this.__cellularType = AppStorage.GetOrCreate().setAndLink("cellularType", constants_1.default.NETWORK_TYPE_UNKNOWN, this);
        this.__networkState = AppStorage.GetOrCreate().setAndLink("networkState", constants_1.default.NET_NULL, this);
        this.__signalObserved = AppStorage.GetOrCreate().setAndLink("signalObserved", false, this);
        this.__mTintContentInfo = new ObservedPropertyObject(SignalVM_1.default.getTintContentInfo(), this, "mTintContentInfo");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getSignalComponentStyle(), this, "style");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
    }
    aboutToBeDeleted() {
        this.__cellularLevel.aboutToBeDeleted();
        this.__cellularType.aboutToBeDeleted();
        this.__networkState.aboutToBeDeleted();
        this.__signalObserved.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get cellularLevel() {
        return this.__cellularLevel.get();
    }
    set cellularLevel(newValue) {
        this.__cellularLevel.set(newValue);
    }
    get cellularType() {
        return this.__cellularType.get();
    }
    set cellularType(newValue) {
        this.__cellularType.set(newValue);
    }
    get networkState() {
        return this.__networkState.get();
    }
    set networkState(newValue) {
        this.__networkState.set(newValue);
    }
    get signalObserved() {
        return this.__signalObserved.get();
    }
    set signalObserved(newValue) {
        this.__signalObserved.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, 'aboutToAppear');
        if (!this.signalObserved) {
            SignalModel_1.default.initSignalModel();
            this.signalObserved = true;
        }
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, 'aboutToDisappear');
    }
    render() {
        Row.create();
        Row.height('100%');
        Row.create();
        Row.width(this.styleCommon.statusBarMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Text.create(this.updateNetworkState(this.networkState));
        Text.fontSize(this.styleCommon.statusBarFontSize);
        Text.fontColor(this.mTintContentInfo.contentColor);
        Text.textOverflow({ overflow: TextOverflow.Ellipsis });
        Text.constraintSize({ maxWidth: this.style.signalTextMaxWeight });
        Text.flexShrink(0);
        Text.maxLines(1);
        Text.textAlign(TextAlign.Center);
        Text.pop();
        Row.create();
        Row.width(this.styleCommon.statusBarMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Stack.create({ alignContent: Alignment.TopStart });
        Stack.flexShrink(1);
        Text.create(this.updateCellularType(this.cellularType));
        Text.fontSize(this.cellularType == constants_1.default.NETWORK_TYPE_UNKNOWN ? this.style.statusBarSignalUnknownFontSize : this.style.statusBarSignalTypeFontSize);
        Text.fontColor(this.mTintContentInfo.contentColor);
        Text.width(this.style.netSignalTextMaxWidth);
        Text.fontWeight(FontWeight.Bold);
        Text.textAlign(TextAlign.Center);
        Text.pop();
        Image.create(this.updateCellularImage(this.cellularLevel));
        Image.objectFit(ImageFit.Contain);
        Image.width(this.style.cellularImageWidth);
        Image.height(this.style.cellularImageHeight);
        Image.fillColor(this.mTintContentInfo.contentColor);
        Stack.pop();
        Row.create();
        Row.width(this.styleCommon.statusBarMarginLeftRight);
        Row.height('100%');
        Row.pop();
        Row.pop();
    }
    /**
         * Get the string of cellular type
         *
         * @param {number} type - number of cellular type
         * @return {string} typeString type of cellular type
         */
    updateCellularType(signalType) {
        Log_1.default.showInfo(TAG, `updateCellularType, signalType: ${signalType}`);
        let typeString;
        switch (signalType) {
            case constants_1.default.NETWORK_TYPE_UNKNOWN:
                typeString = { "id": 201326600, "type": 10003, params: [] };
                break;
            case constants_1.default.NETWORK_TYPE_GSM:
            case constants_1.default.NETWORK_TYPE_CDMA:
                typeString = { "id": 201326594, "type": 10003, params: [] };
                break;
            case constants_1.default.NETWORK_TYPE_W_CDMA:
            case constants_1.default.NETWORK_TYPE_TDS_CDMA:
                typeString = { "id": 201326595, "type": 10003, params: [] };
                break;
            case constants_1.default.NETWORK_TYPE_LTE:
                typeString = { "id": 201326596, "type": 10003, params: [] };
                break;
            case constants_1.default.NETWORK_TYPE_NR:
            default:
                typeString = { "id": 201326597, "type": 10003, params: [] };
                break;
        }
        return typeString;
    }
    /**
         * Get the cellular signal image
         *
         * @param {number} level - signal level from signalModel
         * @return {string} cellularImage image of cellular signal
         */
    updateCellularImage(level) {
        Log_1.default.showInfo(TAG, `updateCellularImage, level: ${level}`);
        let cellularImage;
        switch (level) {
            case constants_1.default.CELLULAR_SIGNAL_NO:
                cellularImage = { "id": 201326653, "type": 20000, params: [] };
                break;
            case constants_1.default.CELLULAR_SIGNAL_MIN:
                cellularImage = { "id": 201326648, "type": 20000, params: [] };
                break;
            case constants_1.default.CELLULAR_SIGNAL_LOW:
                cellularImage = { "id": 201326649, "type": 20000, params: [] };
                break;
            case constants_1.default.CELLULAR_SIGNAL_HALF:
                cellularImage = { "id": 201326650, "type": 20000, params: [] };
                break;
            case constants_1.default.CELLULAR_SIGNAL_HIGH:
                cellularImage = { "id": 201326651, "type": 20000, params: [] };
                break;
            case constants_1.default.CELLULAR_SIGNAL_FULL:
                cellularImage = { "id": 201326652, "type": 20000, params: [] };
                break;
            case constants_1.default.CELLULAR_NO_SIM_CARD:
            default:
                cellularImage = { "id": 201326653, "type": 20000, params: [] };
                break;
        }
        console.info('systemui updateCellularImage = ' + cellularImage);
        return cellularImage;
    }
    /**
         * Get the NetworkState signal name
         *
         * @param {string} netWorkState - network state from signal model
         * @return {string} vendor's name or signal state
         */
    updateNetworkState(netWorkState) {
        Log_1.default.showInfo(TAG, `updateNetworkState, netWorkState: ${netWorkState}`);
        let networkStateName;
        if (netWorkState == constants_1.default.NET_NULL) {
            networkStateName = { "id": 201326599, "type": 10003, params: [] };
        }
        else {
            networkStateName = netWorkState;
        }
        return networkStateName;
    }
}
exports["default"] = SignalIcon;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\viewmodel\\SignalVM.ts":
/*!********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\signalcomponent\src\main\ets\default\viewmodel\SignalVM.ts ***!
  \********************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.SignalVM = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const Constants_1 = __webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const TintStateManager_1 = __webpack_require__(/*! ../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const TAG = 'SignalVM';
class SignalVM {
    constructor() {
        this.mTintContentInfo = TintStateManager_1.getOrCreateTintContentInfo(Constants_1.FASlotName.SIGNAL);
        Log_1.default.showInfo(TAG, `constructor`);
    }
    getTintContentInfo() {
        return this.mTintContentInfo;
    }
}
exports.SignalVM = SignalVM;
let sSignalVM = SingleInstanceHelper_1.default(SignalVM, TAG);
exports["default"] = sSignalVM;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts":
/*!**********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\statusbarcomponent\src\main\ets\com\ohos\common\Constants.ts ***!
  \**********************************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.StatusBarComponentGroupContentData = exports.StatusBarBackgroundData = exports.StatusBarData = void 0;
__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/event/EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventUtil.ts");
__webpack_require__(/*! ../../../../../../../../common/src/main/ets/plugindatasource/common/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts");
class Constants {
}
exports["default"] = Constants;
Constants.EMPTY_AREA_POSITION_LEFT = 'left';
Constants.EMPTY_AREA_POSITION_CENTER = 'center';
Constants.EMPTY_AREA_POSITION_RIGHT = 'right';
Constants.GROUP_ID_LEFT = 1;
Constants.GROUP_ID_CENTER = 2;
Constants.GROUP_ID_RIGHT = 3;
Constants.VERTICAL_COMPONENT_HEIGHT_VP = 58;
class StatusBarData {
}
exports.StatusBarData = StatusBarData;
class StatusBarBackgroundData {
    constructor() {
        this.backgroundColor = "#FFFF0000";
        this.width = 0;
    }
}
exports.StatusBarBackgroundData = StatusBarBackgroundData;
class StatusBarComponentGroupContentData {
    constructor() {
        this.contentColor = "#FFFFFFFF";
        this.width = 0;
    }
}
exports.StatusBarComponentGroupContentData = StatusBarComponentGroupContentData;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\common\\StyleConfiguration.ts":
/*!*******************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\statusbarcomponent\src\main\ets\com\ohos\common\StyleConfiguration.ts ***!
  \*******************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const StyleManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
const Constants_1 = __importDefault(__webpack_require__(/*! ./Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts"));
const TAG = 'statusBar-StyleConfiguration';
class StyleConfiguration {
    static getVerticalStatusBarItemLoadComponentStyle() {
        const key = TAG + "-VerticalStatusBarItemLoadComponent";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                statusBarVerticalComponentHeight: vp2px(Constants_1.default.VERTICAL_COMPONENT_HEIGHT_VP),
            };
        });
    }
    static getStatusBarNotificationIconStyle() {
        const key = TAG + "-StatusBarNotificationIcon";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                iconWidth: { "id": 201326677, "type": 10002, params: [] },
                iconHeight: { "id": 201326675, "type": 10002, params: [] },
                iconSpace: { "id": 201326676, "type": 10002, params: [] },
            };
        });
    }
    static getIconItemComponentStyle() {
        const key = TAG + "-IconItemComponent";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                stackHeight: { "id": 201326673, "type": 10002, params: [] },
                stackPadding: { "id": 201326674, "type": 10002, params: [] },
                stackBorderRadius: { "id": 201326672, "type": 10002, params: [] },
                stackBgColorSelected: { "id": 201326665, "type": 10001, params: [] },
                stackBgColorUnSelected: { "id": 201326666, "type": 10001, params: [] },
                componentSpace: { "id": 201326667, "type": 10002, params: [] },
                iconWidth: { "id": 201326669, "type": 10002, params: [] },
                iconHeight: { "id": 201326668, "type": 10002, params: [] },
                marginLeft: { "id": 201326670, "type": 10002, params: [] },
                marginRight: { "id": 201326671, "type": 10002, params: [] },
            };
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\model\\StatusBarService.ts":
/*!****************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\statusbarcomponent\src\main\ets\com\ohos\model\StatusBarService.ts ***!
  \****************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.StatusBarService = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const Constants_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const SwitchUserManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/SwitchUserManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SwitchUserManager.ts"));
__webpack_require__(/*! ../../../../../../../../common/src/main/ets/plugindatasource/common/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts");
const PluginDataSourceAdapter_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/plugindatasource/PluginDataSourceAdapter */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\PluginDataSourceAdapter.ts"));
const abilityManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/abilitymanager/abilityManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\abilitymanager\\abilityManager.ts"));
const Constants_2 = __importDefault(__webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts"));
const EventUtil_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Event/EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Event\\EventUtil.ts");
const TAG = "StatusBarModel";
const STATUSBAR_SOURCE_CONFIG = {
    action: "com.ohos.systemui.action.BAR_ICON",
    filterDatas: [],
    loaderConfig: {
        MetaSource: {
            action: "com.ohos.systemui.action.BAR_ICON",
            permission: null,
        },
    },
};
function parseItemData(itemData) {
    var _a;
    let _b = (_a = itemData.actionData) === null || _a === void 0 ? void 0 : _a.extra, { isShowLabel, isShowIcon, selectedClickAction, relationWindowId } = _b, other = __rest(_b, ["isShowLabel", "isShowIcon", "selectedClickAction", "relationWindowId"]);
    let selectAction = EventUtil_1.parseEventString(selectedClickAction);
    let statusBarItemData = Object.assign(Object.assign({}, itemData), { isShowLabel: isShowLabel ? isShowLabel !== false : false, isShowIcon: isShowIcon ? isShowIcon !== false : true, canSelect: selectAction ? true : false, relationWindowId: relationWindowId, actionData: Object.assign(Object.assign({}, itemData.actionData), { selectedClickAction: selectAction, extra: undefined }) });
    return statusBarItemData;
}
class StatusBarService {
    constructor() {
        this.mIsStart = false;
        this.mAdapter = new PluginDataSourceAdapter_1.default(TAG, abilityManager_1.default.getContext(), this);
        this.mStatusBarLayoutGroupTemplate = [];
        Log_1.default.showInfo(TAG, `constructor`);
    }
    setStatusBarData(data) {
        Log_1.default.showInfo(TAG, `setStatusBarData`);
        this.mStatusBarData = data;
    }
    startService(config) {
        if (this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `start StatusBarService.`);
        this.mIsStart = true;
        this.parseConfig(config);
        SwitchUserManager_1.default.getInstance().registerListener(this);
        STATUSBAR_SOURCE_CONFIG.filterDatas = config.MetaSlots;
        this.mAdapter.initDataSource(STATUSBAR_SOURCE_CONFIG);
        Log_1.default.showInfo(TAG, `start StatusBarService finish.`);
    }
    stopService() {
        if (!this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `stop StatusBarService.`);
        this.mIsStart = false;
        this.mAdapter.clearAll();
        Log_1.default.showInfo(TAG, `stop StatusBarService finish.`);
    }
    parseConfig(config) {
        Log_1.default.showInfo(TAG, `parseConfig, config: ${JSON.stringify(config)}`);
        this.mConfig = config;
        const groupIds = [Constants_2.default.GROUP_ID_LEFT, Constants_2.default.GROUP_ID_CENTER, Constants_2.default.GROUP_ID_RIGHT];
        groupIds.forEach((groupId) => {
            for (const groupInfo of config.LayoutGroups) {
                if (groupId == groupInfo.id) {
                    this.mStatusBarLayoutGroupTemplate.push([...groupInfo.Components]);
                    break;
                }
            }
        });
        Log_1.default.showInfo(TAG, `parseConfig, statusBarLayoutGroupTemplate: ${JSON.stringify(this.mStatusBarLayoutGroupTemplate)}`);
        this.mStatusBarAllLayout = [...config.LocalSlots];
        this.onDisplayRotate(0);
    }
    calcStatusBarLayout() {
        var _a;
        Log_1.default.showInfo(TAG, `calcStatusBarLayout`);
        let statusBarLayout = [];
        for (let i = 0; i < this.mStatusBarLayoutGroupTemplate.length; i++) {
            let componentsTemplate = this.mStatusBarLayoutGroupTemplate[i];
            let components = [];
            for (let componentTemplate of componentsTemplate) {
                if (this.mStatusBarAllLayout.indexOf(componentTemplate) >= 0) {
                    components.push(componentTemplate);
                }
            }
            statusBarLayout.push(components);
        }
        Log_1.default.showInfo(TAG, `calcStatusBarLayout, statusBarLayout: ${JSON.stringify(statusBarLayout)}`);
        (_a = this.mListener) === null || _a === void 0 ? void 0 : _a.setStatusBarLayout(statusBarLayout);
    }
    userChange(userInfo) {
        Log_1.default.showInfo(TAG, `userChange userInfo ` + userInfo);
        this.mAdapter.loadData(userInfo.userId);
    }
    initFinish() {
        Log_1.default.showInfo(TAG, `initFinish`);
        SwitchUserManager_1.default.getInstance()
            .getCurrentUserInfo()
            .then((userInfo) => {
            this.mAdapter.loadData(userInfo.userId);
        });
    }
    registerListener(listener) {
        Log_1.default.showInfo(TAG, `registerListener, listener: ${listener}`);
        this.mListener = listener;
    }
    onItemAdd(itemData) {
        var _a;
        Log_1.default.showInfo(TAG, `onItemAdd, itemData: ${JSON.stringify(itemData)}`);
        let statusBarData = parseItemData(itemData);
        let id = itemData.id;
        (_a = this.mListener) === null || _a === void 0 ? void 0 : _a.setItemData(id, statusBarData);
        if (this.mStatusBarAllLayout.indexOf(id) < 0) {
            this.mStatusBarAllLayout.push(id);
            Log_1.default.showInfo(TAG, `onItemAdd, mStatusBarAllLayout: ${JSON.stringify(this.mStatusBarAllLayout)}`);
            this.calcStatusBarLayout();
        }
    }
    onItemRemove(itemData) {
        var _a;
        Log_1.default.showInfo(TAG, `onItemRemove, itemData: ${JSON.stringify(itemData)}`);
        let id = itemData.id;
        if (this.mStatusBarAllLayout.indexOf(id) >= 0) {
            this.mStatusBarAllLayout.splice(this.mStatusBarAllLayout.indexOf(id), 1);
            Log_1.default.showInfo(TAG, `onItemRemove, mStatusBarAllLayout: ${JSON.stringify(this.mStatusBarAllLayout)}`);
            this.calcStatusBarLayout();
        }
        (_a = this.mListener) === null || _a === void 0 ? void 0 : _a.setItemData(id, undefined);
    }
    onDisplayRotate(rotation) {
        Log_1.default.showInfo(TAG, `onDisplayRotate, rotation: ${rotation}`);
        let position = this.calcEmptyAreaPosition(rotation);
        this.onEmptyAreaChange(position, rotation);
    }
    calcEmptyAreaPosition(rotation) {
        Log_1.default.showInfo(TAG, `calcEmptyAreaPosition, rotation: ${rotation}`);
        let configEmptyPosition = this.mConfig.emptyPosition;
        if (!configEmptyPosition || configEmptyPosition.x1 == configEmptyPosition.x2 || configEmptyPosition.y1 == configEmptyPosition.y2) {
            return null;
        }
        let statusBarLeft;
        let statusBarRight;
        if (this.mStatusBarData.showHorizontal) {
            statusBarLeft = {
                x1: this.mStatusBarData.left,
                y1: this.mStatusBarData.top,
                x2: this.mStatusBarData.left + this.mStatusBarData.realWidth / 2,
                y2: this.mStatusBarData.top + this.mStatusBarData.realHeight
            };
            statusBarRight = {
                x1: statusBarLeft.x2,
                y1: statusBarLeft.y1,
                x2: this.mStatusBarData.left + this.mStatusBarData.realWidth,
                y2: statusBarLeft.y2
            };
        }
        else {
            statusBarLeft = {
                x1: this.mStatusBarData.left,
                y1: this.mStatusBarData.top,
                x2: this.mStatusBarData.left + this.mStatusBarData.realWidth,
                y2: this.mStatusBarData.top + this.mStatusBarData.realHeight / 2
            };
            statusBarRight = {
                x1: statusBarLeft.x1,
                y1: statusBarLeft.y2,
                x2: statusBarLeft.x2,
                y2: this.mStatusBarData.top + this.mStatusBarData.realHeight
            };
        }
        Log_1.default.showInfo(TAG, `calcEmptyAreaPosition, statusBarLeft: ${JSON.stringify(statusBarLeft)}`);
        Log_1.default.showInfo(TAG, `calcEmptyAreaPosition, statusBarRight: ${JSON.stringify(statusBarRight)}`);
        let emptyPosition;
        if (rotation == 0) {
            emptyPosition = Object.assign({}, configEmptyPosition);
        }
        else if (rotation == 90) {
            emptyPosition = {
                x1: this.mStatusBarData.displayWidth - configEmptyPosition.y2,
                y1: configEmptyPosition.x1,
                x2: this.mStatusBarData.displayWidth - configEmptyPosition.y1,
                y2: configEmptyPosition.x2
            };
        }
        else if (rotation == 180) {
            emptyPosition = {
                x1: this.mStatusBarData.displayWidth - configEmptyPosition.x2,
                y1: this.mStatusBarData.displayHeight - configEmptyPosition.y2,
                x2: this.mStatusBarData.displayWidth - configEmptyPosition.x1,
                y2: this.mStatusBarData.displayHeight - configEmptyPosition.y1,
            };
        }
        else {
            emptyPosition = {
                x1: configEmptyPosition.y1,
                y1: this.mStatusBarData.displayHeight - configEmptyPosition.x2,
                x2: configEmptyPosition.y2,
                y2: this.mStatusBarData.displayHeight - configEmptyPosition.x1
            };
        }
        let isGlandLeft = this.isEmptyAreaGlandStatusBar(emptyPosition, statusBarLeft);
        let isGlandRight = this.isEmptyAreaGlandStatusBar(emptyPosition, statusBarRight);
        Log_1.default.showInfo(TAG, `calcEmptyAreaPosition, gland: ${isGlandLeft} ${isGlandRight}`);
        if (isGlandLeft && isGlandRight) {
            return Constants_2.default.EMPTY_AREA_POSITION_CENTER;
        }
        else if (isGlandLeft) {
            return Constants_2.default.EMPTY_AREA_POSITION_LEFT;
        }
        else if (isGlandRight) {
            return Constants_2.default.EMPTY_AREA_POSITION_RIGHT;
        }
        else {
            return null;
        }
    }
    isEmptyAreaGlandStatusBar(emptyPosition, statusBarArea) {
        Log_1.default.showInfo(TAG, `isEmptyAreaGlandStatusBar, emptyPosition: ${JSON.stringify(emptyPosition)}`);
        Log_1.default.showInfo(TAG, `isEmptyAreaGlandStatusBar, statusBarArea: ${JSON.stringify(statusBarArea)}`);
        let ex1 = emptyPosition.x1;
        let ey1 = emptyPosition.y1;
        let ex2 = emptyPosition.x2;
        let ey2 = emptyPosition.y2;
        let x1 = statusBarArea.x1;
        let y1 = statusBarArea.y1;
        let x2 = statusBarArea.x2;
        let y2 = statusBarArea.y2;
        if (ex1 >= x1 && ex1 <= x2 && ey1 >= y1 && ey1 <= y2) {
            return true;
        }
        else if (ex2 >= x1 && ex2 <= x2 && ey1 >= y1 && ey1 <= y2) {
            return true;
        }
        else if (ex1 >= x1 && ex1 <= x2 && ey2 >= y1 && ey2 <= y2) {
            return true;
        }
        else if (ex2 >= x1 && ex2 <= x2 && ey2 >= y1 && ey2 <= y2) {
            return true;
        }
        return false;
    }
    onEmptyAreaChange(position, rotation) {
        Log_1.default.showInfo(TAG, `onEmptyAreaChange, position: ${position} rotation: ${rotation}`);
        this.calcEmptyWidth(rotation);
        this.setEmptyAreaToLayoutTemplate(position);
        let id = Constants_1.FASlotName.EMPTY;
        if (this.mStatusBarAllLayout.indexOf(id) >= 0) {
            this.mStatusBarAllLayout.splice(this.mStatusBarAllLayout.indexOf(id), 1);
        }
        if (position) {
            this.mStatusBarAllLayout.push(id);
        }
        Log_1.default.showInfo(TAG, `onEmptyAreaChange, mStatusBarAllLayout: ${JSON.stringify(this.mStatusBarAllLayout)}`);
        this.calcStatusBarLayout();
    }
    setEmptyAreaToLayoutTemplate(position) {
        Log_1.default.showInfo(TAG, `setEmptyAreaToLayoutTemplate, position: ${position}`);
        for (let i = 0; i < this.mStatusBarLayoutGroupTemplate.length; i++) {
            let componentsTemplate = this.mStatusBarLayoutGroupTemplate[i];
            let index = componentsTemplate.indexOf(Constants_1.FASlotName.EMPTY);
            if (index >= 0) {
                componentsTemplate.splice(index, 1);
                break;
            }
        }
        if (position == Constants_2.default.EMPTY_AREA_POSITION_LEFT) {
            this.mStatusBarLayoutGroupTemplate[0].splice(0, 0, Constants_1.FASlotName.EMPTY);
        }
        else if (position == Constants_2.default.EMPTY_AREA_POSITION_CENTER) {
            this.mStatusBarLayoutGroupTemplate[1].splice(0, 0, Constants_1.FASlotName.EMPTY);
        }
        else if (position == Constants_2.default.EMPTY_AREA_POSITION_RIGHT) {
            this.mStatusBarLayoutGroupTemplate[2].push(Constants_1.FASlotName.EMPTY);
        }
        Log_1.default.showInfo(TAG, `setEmptyAreaToLayoutTemplate, template: ${JSON.stringify(this.mStatusBarLayoutGroupTemplate)}`);
    }
    calcEmptyWidth(rotation) {
        var _a;
        Log_1.default.showInfo(TAG, `calcEmptyWidth, rotation: ${rotation}`);
        let width = 0;
        if (this.mConfig.emptyPosition) {
            if (rotation == 0 || rotation == 180) {
                width = this.mConfig.emptyPosition.x2 - this.mConfig.emptyPosition.x1;
            }
            else {
                width = this.mConfig.emptyPosition.y2 - this.mConfig.emptyPosition.y1;
            }
        }
        Log_1.default.showInfo(TAG, `calcEmptyWidth, width: ${width}`);
        (_a = this.mListener) === null || _a === void 0 ? void 0 : _a.setStatusBarEmptyWidth(width);
    }
}
exports.StatusBarService = StatusBarService;
let sStatusBarService = SingleInstanceHelper_1.default(StatusBarService, TAG);
exports["default"] = sStatusBarService;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\pages\\IconItemComponent.ets":
/*!******************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\statusbarcomponent\src\main\ets\com\ohos\pages\IconItemComponent.ets ***!
  \******************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const EventManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/event/EventManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventManager.ts"));
__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/CheckEmptyUtils */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\CheckEmptyUtils.ts");
const WindowManager_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/WindowManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\WindowManager.ts");
const Constants_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/plugindatasource/common/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\plugindatasource\\common\\Constants.ts");
__webpack_require__(/*! ../viewmodel/StatusBarVM */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\StatusBarVM.ts");
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\common\\StyleConfiguration.ts"));
const MetaIconItemComponent_1 = __importDefault(__webpack_require__(/*! ./MetaIconItemComponent */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\pages\\MetaIconItemComponent.ets"));
const TAG = 'IconItemComponent';
class IconItemComponent extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.keyId = undefined;
        this.__mItemData = new ObservedPropertyObject({}, this, "mItemData");
        this.__mItemStatus = new ObservedPropertyObject({
            selected: false
        }, this, "mItemStatus");
        this.mClearCallback = undefined;
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getIconItemComponentStyle(), this, "style");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.keyId !== undefined) {
            this.keyId = params.keyId;
        }
        if (params.mItemData !== undefined) {
            this.mItemData = params.mItemData;
        }
        if (params.mItemStatus !== undefined) {
            this.mItemStatus = params.mItemStatus;
        }
        if (params.mClearCallback !== undefined) {
            this.mClearCallback = params.mClearCallback;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
    }
    aboutToBeDeleted() {
        this.__mItemData.aboutToBeDeleted();
        this.__mItemStatus.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get mItemData() {
        return this.__mItemData.get();
    }
    set mItemData(newValue) {
        this.__mItemData.set(newValue);
    }
    get mItemStatus() {
        return this.__mItemStatus.get();
    }
    set mItemStatus(newValue) {
        this.__mItemStatus.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    aboutToAppear() {
        var _a;
        Log_1.default.showInfo(TAG, `aboutToAppear Start, keyId: ${this.keyId} `);
        this.linkItemData();
        if ((_a = this.mItemData.get()) === null || _a === void 0 ? void 0 : _a.relationWindowId) {
            this.mClearCallback = EventManager_1.default.subscribe(WindowManager_1.WINDOW_SHOW_HIDE_EVENT, (args) => this.onWindowChange(args));
        }
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, `aboutToDisappear`);
        this.mClearCallback && this.mClearCallback();
        this.mClearCallback = undefined;
    }
    linkItemData() {
        Log_1.default.showInfo(TAG, `linkItemData, keyId: ${this.keyId}`);
        this.mItemData = AppStorage.Link('StatusBar_' + this.keyId);
        Log_1.default.showInfo(TAG, `linkItemData, mItemData: ${this.keyId} ${this.mItemData.get().label} ${this.mItemData.get()
            .iconUrl}`);
        this.mItemStatus = AppStorage.SetAndLink('StatusBar_Status_' + this.keyId, { selected: false }).get();
    }
    render() {
        Row.create();
        Row.height('100%');
        Row.create();
        Row.width(this.style.marginLeft);
        Row.height('100%');
        Row.pop();
        Row.create();
        Row.height(this.style.stackHeight);
        Row.borderRadius(this.style.stackBorderRadius);
        Row.backgroundColor(this.mItemStatus.selected ? this.style.stackBgColorSelected : this.style.stackBgColorUnSelected);
        Row.onClick(this.onIconItemClick.bind(this));
        Gesture.create(GesturePriority.Low);
        LongPressGesture.create({ repeat: false });
        LongPressGesture.onAction(this.onIconItemLongPressGesture.bind(this));
        LongPressGesture.pop();
        Gesture.pop();
        Row.onTouch(this.onIconItemTouch.bind(this));
        Row.create();
        Row.width(this.style.stackPadding);
        Row.height('100%');
        Row.pop();
        If.create();
        if (this.mItemData.get().pluginType == Constants_1.PluginType.META) {
            If.branchId(0);
            let earlierCreatedChild_1 = this.findChildById("1");
            if (earlierCreatedChild_1 == undefined) {
                View.create(new MetaIconItemComponent_1.default("1", this, {
                    keyId: this.keyId
                }));
            }
            else {
                earlierCreatedChild_1.updateWithValueParams({
                    keyId: this.keyId
                });
                View.create(earlierCreatedChild_1);
            }
        }
        else if (this.mItemData.get().pluginType == Constants_1.PluginType.DATA_ABILITY) {
            If.branchId(1);
        }
        else if (this.mItemData.get().pluginType == Constants_1.PluginType.PLUGIN_COMPONENT) {
            If.branchId(2);
        }
        If.pop();
        Row.create();
        Row.width(this.style.stackPadding);
        Row.height('100%');
        Row.pop();
        Row.pop();
        Row.create();
        Row.width(this.style.marginRight);
        Row.height('100%');
        Row.pop();
        Row.pop();
    }
    onWindowChange(args) {
        if (this.mItemData.get().canSelect && (args === null || args === void 0 ? void 0 : args.windowName) == this.mItemData.get().relationWindowId) {
            this.mItemStatus.selected = args === null || args === void 0 ? void 0 : args.isShow;
        }
    }
    onIconItemClick(event) {
        Log_1.default.showInfo(TAG, `onIconItemClick`);
        if (!this.mItemStatus.selected) {
            this.execClickAction();
        }
        else {
            this.execSelectedClickAction();
        }
    }
    execClickAction() {
        var _a, _b;
        Log_1.default.showInfo(TAG, `execClickAction`);
        if ((_b = (_a = this.mItemData.get()) === null || _a === void 0 ? void 0 : _a.actionData) === null || _b === void 0 ? void 0 : _b.clickAction) {
            EventManager_1.default.publish(this.mItemData.get().actionData.clickAction);
        }
    }
    execSelectedClickAction() {
        var _a, _b, _c, _d;
        Log_1.default.showInfo(TAG, `execSelectedClickAction ${(_b = (_a = this.mItemData.get()) === null || _a === void 0 ? void 0 : _a.actionData) === null || _b === void 0 ? void 0 : _b.selectedClickAction}`);
        if ((_d = (_c = this.mItemData.get()) === null || _c === void 0 ? void 0 : _c.actionData) === null || _d === void 0 ? void 0 : _d.selectedClickAction) {
            EventManager_1.default.publish(this.mItemData.get().actionData.selectedClickAction);
        }
    }
    onIconItemLongPressGesture(event) {
        Log_1.default.showInfo(TAG, `onIconItemLongPressGesture, event: ${JSON.stringify(event)}`);
        let longClickEvent = this.mItemData.get().actionData.longClickAction;
        longClickEvent && EventManager_1.default.publish(longClickEvent);
    }
    onIconItemTouch(event) {
        var _a, _b, _c, _d;
        Log_1.default.showInfo(TAG, `onIconItemTouch, event: ${JSON.stringify(event)}`);
        if (((_b = (_a = this.mItemData.get()) === null || _a === void 0 ? void 0 : _a.actionData) === null || _b === void 0 ? void 0 : _b.clickAction) || ((_d = (_c = this.mItemData.get()) === null || _c === void 0 ? void 0 : _c.actionData) === null || _d === void 0 ? void 0 : _d.longClickAction)) {
            event.stopPropagation();
        }
    }
}
exports["default"] = IconItemComponent;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\pages\\MetaIconItemComponent.ets":
/*!**********************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\statusbarcomponent\src\main\ets\com\ohos\pages\MetaIconItemComponent.ets ***!
  \**********************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const TintStateManager_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const CheckEmptyUtils_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/CheckEmptyUtils */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\CheckEmptyUtils.ts"));
const StatusBarVM_1 = __importDefault(__webpack_require__(/*! ../viewmodel/StatusBarVM */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\StatusBarVM.ts"));
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\common\\StyleConfiguration.ts"));
const TAG = 'MetaIconItemComponent';
class MetaIconItemComponent extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.keyId = undefined;
        this.__mItemData = new ObservedPropertyObject({}, this, "mItemData");
        this.__mTintContentInfo = new ObservedPropertyObject(new TintStateManager_1.TintContentInfo(), this, "mTintContentInfo");
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getIconItemComponentStyle(), this, "style");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.keyId !== undefined) {
            this.keyId = params.keyId;
        }
        if (params.mItemData !== undefined) {
            this.mItemData = params.mItemData;
        }
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
    }
    aboutToBeDeleted() {
        this.__mItemData.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get mItemData() {
        return this.__mItemData.get();
    }
    set mItemData(newValue) {
        this.__mItemData.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, `aboutToAppear Start, keyId: ${this.keyId}`);
        this.linkItemData();
        this.mTintContentInfo = StatusBarVM_1.default.getPluginTintContentInfo(this.keyId);
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, `aboutToDisappear`);
    }
    linkItemData() {
        Log_1.default.showInfo(TAG, `linkItemData, keyId: ${this.keyId}`);
        this.mItemData = AppStorage.Link('StatusBar_' + this.keyId);
        Log_1.default.showInfo(TAG, `linkItemData, mItemData: ${this.keyId} ${this.mItemData.get().label} ${this.mItemData.get()
            .iconUrl}`);
    }
    render() {
        Row.create();
        Row.height('100%');
        If.create();
        if (this.mItemData.get().isShowLabel && !CheckEmptyUtils_1.default.isEmpty(this.mItemData.get().label)) {
            If.branchId(0);
            Text.create(this.mItemData.get()
                .label);
            Text.fontColor(this.mTintContentInfo.contentColor);
            Text.fontSize(this.styleCommon.statusBarFontSize);
            Text.textAlign(TextAlign.End);
            Text.pop();
        }
        If.pop();
        If.create();
        if (this.mItemData.get().isShowLabel && !CheckEmptyUtils_1.default.isEmpty(this.mItemData.get().label)) {
            If.branchId(0);
            If.create();
            if (this.mItemData.get().isShowIcon && !CheckEmptyUtils_1.default.isEmpty(this.mItemData.get().iconUrl)) {
                If.branchId(0);
                Row.create();
                Row.height(1);
                Row.width(this.style.componentSpace);
                Row.pop();
            }
            If.pop();
        }
        If.pop();
        If.create();
        if (this.mItemData.get().isShowIcon && !CheckEmptyUtils_1.default.isEmpty(this.mItemData.get().iconUrl)) {
            If.branchId(0);
            Image.create(this.mItemData.get()
                .iconUrl);
            Image.width(this.style.iconWidth);
            Image.height(this.style.iconHeight);
            Image.fillColor(this.mTintContentInfo.contentColor);
            Image.objectFit(ImageFit.Contain);
        }
        If.pop();
        Row.pop();
    }
}
exports["default"] = MetaIconItemComponent;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\pages\\StatusBarComponent.ets":
/*!*******************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\statusbarcomponent\src\main\ets\com\ohos\pages\StatusBarComponent.ets ***!
  \*******************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const Constants_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\common\\StyleConfiguration.ts"));
const StatusBarVM_1 = __importDefault(__webpack_require__(/*! ../viewmodel/StatusBarVM */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\StatusBarVM.ts"));
const IconItemComponent_1 = __importDefault(__webpack_require__(/*! ./IconItemComponent */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\pages\\IconItemComponent.ets"));
const batteryIcon_1 = __importDefault(__webpack_require__(/*! ../../../../../../../batterycomponent/src/main/ets/default/pages/batteryIcon */ "D:\\code\\release\\my\\applications_systemui\\features\\batterycomponent\\src\\main\\ets\\default\\pages\\batteryIcon.ets"));
const clockIcon_1 = __importDefault(__webpack_require__(/*! ../../../../../../../clockcomponent/src/main/ets/default/pages/clockIcon */ "D:\\code\\release\\my\\applications_systemui\\features\\clockcomponent\\src\\main\\ets\\default\\pages\\clockIcon.ets"));
const wifiIcon_1 = __importDefault(__webpack_require__(/*! ../../../../../../../wificomponent/src/main/ets/default/pages/wifiIcon */ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\pages\\wifiIcon.ets"));
const StatusBarIconItemBluetoothComponent_1 = __importDefault(__webpack_require__(/*! ../../../../../../../bluetoothcomponent/src/main/ets/com/ohos/pages/StatusBarIconItemBluetoothComponent */ "D:\\code\\release\\my\\applications_systemui\\features\\bluetoothcomponent\\src\\main\\ets\\com\\ohos\\pages\\StatusBarIconItemBluetoothComponent.ets"));
const signalIcon_1 = __importDefault(__webpack_require__(/*! ../../../../../../../signalcomponent/src/main/ets/default/pages/signalIcon */ "D:\\code\\release\\my\\applications_systemui\\features\\signalcomponent\\src\\main\\ets\\default\\pages\\signalIcon.ets"));
const CapsuleIcon_1 = __importDefault(__webpack_require__(/*! ../../../../../../../capsulecomponent/src/main/ets/default/pages/CapsuleIcon */ "D:\\code\\release\\my\\applications_systemui\\features\\capsulecomponent\\src\\main\\ets\\default\\pages\\CapsuleIcon.ets"));
const StatusBarIconItemLocationComponent_1 = __importDefault(__webpack_require__(/*! ../../../../../../../locationcomponent/src/main/ets/com/ohos/pages/StatusBarIconItemLocationComponent */ "D:\\code\\release\\my\\applications_systemui\\features\\locationcomponent\\src\\main\\ets\\com\\ohos\\pages\\StatusBarIconItemLocationComponent.ets"));
const StatusBarIconItemRingModeComponent_1 = __importDefault(__webpack_require__(/*! ../../../../../../../ringmodecomponent/src/main/ets/com/ohos/pages/StatusBarIconItemRingModeComponent */ "D:\\code\\release\\my\\applications_systemui\\features\\ringmodecomponent\\src\\main\\ets\\com\\ohos\\pages\\StatusBarIconItemRingModeComponent.ets"));
const TAG = 'StatusBarComponent';
const TAG_StatusBarGroup = 'StatusBarGroup';
const TAG_VerticalStatusBarItemLoadComponent = 'VerticalStatusBarItemLoadComponent';
const TAG_StatusBarItemLoadComponent = 'StatusBarItemLoadComponent';
const TAG_StatusBarEmptyIcon = 'StatusBarEmptyIcon';
const TAG_StatusBarNotificationIcon = 'StatusBarNotificationIcon';
const TAG_StatusBarBackground = 'StatusBarBackground';
class StatusBarComponent extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.mStatusBarComponentConfig = {};
        this.__mStatusBarLayout = AppStorage.GetOrCreate().setAndLink("StatusBarLayout", [[], [], []], this);
        this.__mStatusBarData = new ObservedPropertyObject(StatusBarVM_1.default.getStatusBarData(), this, "mStatusBarData");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mStatusBarComponentConfig !== undefined) {
            this.mStatusBarComponentConfig = params.mStatusBarComponentConfig;
        }
        if (params.mStatusBarData !== undefined) {
            this.mStatusBarData = params.mStatusBarData;
        }
    }
    aboutToBeDeleted() {
        this.__mStatusBarLayout.aboutToBeDeleted();
        this.__mStatusBarData.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get mStatusBarLayout() {
        return this.__mStatusBarLayout.get();
    }
    set mStatusBarLayout(newValue) {
        this.__mStatusBarLayout.set(newValue);
    }
    get mStatusBarData() {
        return this.__mStatusBarData.get();
    }
    set mStatusBarData(newValue) {
        this.__mStatusBarData.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, `aboutToAppear Start, mStatusBarComponentConfig: ${JSON.stringify(this.mStatusBarComponentConfig)}`);
        this.initViewModel();
        Log_1.default.showInfo(TAG, `aboutToAppear End`);
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, `aboutToDisappear`);
    }
    initViewModel() {
        Log_1.default.showInfo(TAG, `initViewModel`);
        StatusBarVM_1.default.initViewModel(this.mStatusBarComponentConfig);
    }
    render() {
        Stack.create();
        Stack.width('100%');
        Stack.height('100%');
        let earlierCreatedChild_1 = this.findChildById("1");
        if (earlierCreatedChild_1 == undefined) {
            View.create(new StatusBarBackground("1", this, {}));
        }
        else {
            earlierCreatedChild_1.updateWithValueParams({});
            View.create(earlierCreatedChild_1);
        }
        If.create();
        if (this.mStatusBarData.showHorizontal) {
            If.branchId(0);
            Row.create();
            Row.width('100%');
            Row.height('100%');
            let earlierCreatedChild_2 = this.findChildById("2");
            if (earlierCreatedChild_2 == undefined) {
                View.create(new StatusBarGroup("2", this, {
                    mComponents: this.mStatusBarLayout[0],
                    mLayoutWeight: 1,
                    mAlignItems: HorizontalAlign.Start
                }));
            }
            else {
                earlierCreatedChild_2.updateWithValueParams({
                    mComponents: this.mStatusBarLayout[0],
                    mLayoutWeight: 1,
                    mAlignItems: HorizontalAlign.Start
                });
                View.create(earlierCreatedChild_2);
            }
            let earlierCreatedChild_3 = this.findChildById("3");
            if (earlierCreatedChild_3 == undefined) {
                View.create(new StatusBarGroup("3", this, {
                    mComponents: this.mStatusBarLayout[1],
                    mLayoutWeight: 0,
                    mAlignItems: HorizontalAlign.Center
                }));
            }
            else {
                earlierCreatedChild_3.updateWithValueParams({
                    mComponents: this.mStatusBarLayout[1],
                    mLayoutWeight: 0,
                    mAlignItems: HorizontalAlign.Center
                });
                View.create(earlierCreatedChild_3);
            }
            let earlierCreatedChild_4 = this.findChildById("4");
            if (earlierCreatedChild_4 == undefined) {
                View.create(new StatusBarGroup("4", this, {
                    mComponents: this.mStatusBarLayout[2],
                    mLayoutWeight: 1,
                    mAlignItems: HorizontalAlign.End
                }));
            }
            else {
                earlierCreatedChild_4.updateWithValueParams({
                    mComponents: this.mStatusBarLayout[2],
                    mLayoutWeight: 1,
                    mAlignItems: HorizontalAlign.End
                });
                View.create(earlierCreatedChild_4);
            }
            Row.pop();
        }
        else {
            If.branchId(1);
            Column.create();
            Column.width('100%');
            Column.height('100%');
            let earlierCreatedChild_5 = this.findChildById("5");
            if (earlierCreatedChild_5 == undefined) {
                View.create(new StatusBarGroup("5", this, {
                    mComponents: this.mStatusBarLayout[0],
                    mLayoutWeight: 1,
                    mAlignItems: VerticalAlign.Center
                }));
            }
            else {
                earlierCreatedChild_5.updateWithValueParams({
                    mComponents: this.mStatusBarLayout[0],
                    mLayoutWeight: 1,
                    mAlignItems: VerticalAlign.Center
                });
                View.create(earlierCreatedChild_5);
            }
            let earlierCreatedChild_6 = this.findChildById("6");
            if (earlierCreatedChild_6 == undefined) {
                View.create(new StatusBarGroup("6", this, {
                    mComponents: this.mStatusBarLayout[1],
                    mLayoutWeight: 0,
                    mAlignItems: VerticalAlign.Center
                }));
            }
            else {
                earlierCreatedChild_6.updateWithValueParams({
                    mComponents: this.mStatusBarLayout[1],
                    mLayoutWeight: 0,
                    mAlignItems: VerticalAlign.Center
                });
                View.create(earlierCreatedChild_6);
            }
            let earlierCreatedChild_7 = this.findChildById("7");
            if (earlierCreatedChild_7 == undefined) {
                View.create(new StatusBarGroup("7", this, {
                    mComponents: this.mStatusBarLayout[2],
                    mLayoutWeight: 1,
                    mAlignItems: VerticalAlign.Center
                }));
            }
            else {
                earlierCreatedChild_7.updateWithValueParams({
                    mComponents: this.mStatusBarLayout[2],
                    mLayoutWeight: 1,
                    mAlignItems: VerticalAlign.Center
                });
                View.create(earlierCreatedChild_7);
            }
            Column.pop();
        }
        If.pop();
        Stack.pop();
    }
}
exports["default"] = StatusBarComponent;
class StatusBarBackground extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__mStatusBarData = new ObservedPropertyObject(StatusBarVM_1.default.getStatusBarData(), this, "mStatusBarData");
        this.__mBackgroundDatas = new ObservedPropertyObject(StatusBarVM_1.default.getBackgroundDatas(), this, "mBackgroundDatas");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mStatusBarData !== undefined) {
            this.mStatusBarData = params.mStatusBarData;
        }
        if (params.mBackgroundDatas !== undefined) {
            this.mBackgroundDatas = params.mBackgroundDatas;
        }
    }
    aboutToBeDeleted() {
        this.__mStatusBarData.aboutToBeDeleted();
        this.__mBackgroundDatas.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get mStatusBarData() {
        return this.__mStatusBarData.get();
    }
    set mStatusBarData(newValue) {
        this.__mStatusBarData.set(newValue);
    }
    get mBackgroundDatas() {
        return this.__mBackgroundDatas.get();
    }
    set mBackgroundDatas(newValue) {
        this.__mBackgroundDatas.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG_StatusBarBackground, `aboutToAppear Start`);
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG_StatusBarBackground, `aboutToDisAppear`);
    }
    render() {
        If.create();
        if (this.mStatusBarData.showHorizontal) {
            If.branchId(0);
            Row.create();
            Row.width('100%');
            Row.height('100%');
            ForEach.create("8", this, ObservedObject.GetRawObject(this.mBackgroundDatas), (data) => {
                If.create();
                if (data.width > 0) {
                    If.branchId(0);
                    Column.create();
                    Column.width(data.width + 'px');
                    Column.height('100%');
                    Column.backgroundColor(data.backgroundColor);
                    Column.pop();
                }
                If.pop();
            });
            ForEach.pop();
            Row.pop();
        }
        else {
            If.branchId(1);
            Column.create();
            Column.width('100%');
            Column.height('100%');
            ForEach.create("9", this, ObservedObject.GetRawObject(this.mBackgroundDatas), (data) => {
                If.create();
                if (data.width > 0) {
                    If.branchId(0);
                    Column.create();
                    Column.width('100%');
                    Column.height(data.width + 'px');
                    Column.backgroundColor(data.backgroundColor);
                    Column.pop();
                }
                If.pop();
            });
            ForEach.pop();
            Column.pop();
        }
        If.pop();
    }
}
class StatusBarGroup extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__mComponents = new ObservedPropertyObject([], this, "mComponents");
        this.mLayoutWeight = 1;
        this.mAlignItems = HorizontalAlign.Center;
        this.__mStatusBarData = new ObservedPropertyObject(StatusBarVM_1.default.getStatusBarData(), this, "mStatusBarData");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mComponents !== undefined) {
            this.mComponents = params.mComponents;
        }
        if (params.mLayoutWeight !== undefined) {
            this.mLayoutWeight = params.mLayoutWeight;
        }
        if (params.mAlignItems !== undefined) {
            this.mAlignItems = params.mAlignItems;
        }
        if (params.mStatusBarData !== undefined) {
            this.mStatusBarData = params.mStatusBarData;
        }
    }
    aboutToBeDeleted() {
        this.__mComponents.aboutToBeDeleted();
        this.__mStatusBarData.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get mComponents() {
        return this.__mComponents.get();
    }
    set mComponents(newValue) {
        this.__mComponents.set(newValue);
    }
    get mStatusBarData() {
        return this.__mStatusBarData.get();
    }
    set mStatusBarData(newValue) {
        this.__mStatusBarData.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG_StatusBarGroup, `aboutToAppear Start`);
        Log_1.default.showInfo(TAG_StatusBarGroup, `aboutToAppear, mLayoutWeight: ${this.mLayoutWeight} mAlignItems: ${this.mAlignItems} `);
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG_StatusBarGroup, `aboutToDisAppear`);
    }
    render() {
        If.create();
        if (this.mStatusBarData.showHorizontal) {
            If.branchId(0);
            Column.create();
            Column.alignItems(this.mAlignItems);
            Column.layoutWeight(this.mLayoutWeight);
            Column.height('100%');
            Row.create();
            Row.height('100%');
            ForEach.create("11", this, ObservedObject.GetRawObject(this.mComponents), (componentName) => {
                let earlierCreatedChild_10 = this.findChildById("10");
                if (earlierCreatedChild_10 == undefined) {
                    View.create(new StatusBarItemLoadComponent("10", this, {
                        mComponentName: componentName
                    }));
                }
                else {
                    earlierCreatedChild_10.updateWithValueParams({
                        mComponentName: componentName
                    });
                    if (!earlierCreatedChild_10.needsUpdate()) {
                        earlierCreatedChild_10.markStatic();
                    }
                    View.create(earlierCreatedChild_10);
                }
            }, (componentName) => componentName);
            ForEach.pop();
            Row.pop();
            Column.pop();
        }
        else {
            If.branchId(1);
            Row.create();
            Row.alignItems(this.mAlignItems);
            Row.width('100%');
            Row.layoutWeight(this.mLayoutWeight);
            Column.create();
            Column.width('100%');
            Column.alignItems(HorizontalAlign.Start);
            ForEach.create("13", this, ObservedObject.GetRawObject(this.mComponents), (componentName) => {
                let earlierCreatedChild_12 = this.findChildById("12");
                if (earlierCreatedChild_12 == undefined) {
                    View.create(new VerticalStatusBarItemLoadComponent("12", this, {
                        mComponentName: componentName
                    }));
                }
                else {
                    earlierCreatedChild_12.updateWithValueParams({
                        mComponentName: componentName
                    });
                    View.create(earlierCreatedChild_12);
                }
            }, (componentName) => componentName);
            ForEach.pop();
            Column.pop();
            Row.pop();
        }
        If.pop();
    }
}
class VerticalStatusBarItemLoadComponent extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.mComponentName = undefined;
        this.__mComponentHeight = new ObservedPropertySimple(0, this, "mComponentHeight");
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getVerticalStatusBarItemLoadComponentStyle(), this, "style");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mComponentName !== undefined) {
            this.mComponentName = params.mComponentName;
        }
        if (params.mComponentHeight !== undefined) {
            this.mComponentHeight = params.mComponentHeight;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
    }
    aboutToBeDeleted() {
        this.__mComponentHeight.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get mComponentHeight() {
        return this.__mComponentHeight.get();
    }
    set mComponentHeight(newValue) {
        this.__mComponentHeight.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG_VerticalStatusBarItemLoadComponent, `aboutToAppear, mComponentName: ${this.mComponentName}`);
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG_VerticalStatusBarItemLoadComponent, `aboutToDisAppear, mComponentName: ${this.mComponentName}`);
    }
    render() {
        Row.create();
        Row.height(this.mComponentHeight + 'px');
        Row.onAreaChange((e, e2) => {
            Log_1.default.showInfo(TAG_VerticalStatusBarItemLoadComponent, `onAreaChange, mComponentName: ${this.mComponentName} e: ${JSON.stringify(e)} e2: ${JSON.stringify(e2)}`);
            this.mComponentHeight = e2.width > 0 ? this.style.statusBarVerticalComponentHeight : 0;
            Log_1.default.showInfo(TAG_VerticalStatusBarItemLoadComponent, `onAreaChange, mComponentName: ${this.mComponentName} mComponentHeight: ${this.mComponentHeight}`);
        });
        let earlierCreatedChild_14 = this.findChildById("14");
        if (earlierCreatedChild_14 == undefined) {
            View.create(new StatusBarItemLoadComponent("14", this, {
                mComponentName: this.mComponentName
            }));
        }
        else {
            earlierCreatedChild_14.updateWithValueParams({
                mComponentName: this.mComponentName
            });
            if (!earlierCreatedChild_14.needsUpdate()) {
                earlierCreatedChild_14.markStatic();
            }
            View.create(earlierCreatedChild_14);
        }
        Row.pop();
    }
}
class StatusBarItemLoadComponent extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.mComponentName = undefined;
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mComponentName !== undefined) {
            this.mComponentName = params.mComponentName;
        }
    }
    aboutToBeDeleted() {
        SubscriberManager.Get().delete(this.id());
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG_StatusBarItemLoadComponent, `aboutToAppear, mComponentName: ${this.mComponentName} `);
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG_StatusBarGroup, `aboutToDisAppear, mComponentName: ${this.mComponentName} `);
    }
    render() {
        Row.create();
        Row.height('100%');
        Row.onAreaChange((e, e2) => {
            StatusBarVM_1.default.updateComponentArea(this.mComponentName, e2);
        });
        If.create();
        if (this.mComponentName == Constants_1.FASlotName.EMPTY) {
            If.branchId(0);
            let earlierCreatedChild_15 = this.findChildById("15");
            if (earlierCreatedChild_15 == undefined) {
                View.create(new StatusBarEmptyIcon("15", this, {}));
            }
            else {
                earlierCreatedChild_15.updateWithValueParams({});
                View.create(earlierCreatedChild_15);
            }
        }
        else if (this.mComponentName == Constants_1.FASlotName.WIFI) {
            If.branchId(1);
            let earlierCreatedChild_16 = this.findChildById("16");
            if (earlierCreatedChild_16 == undefined) {
                View.create(new wifiIcon_1.default("16", this, {}));
            }
            else {
                earlierCreatedChild_16.updateWithValueParams({});
                View.create(earlierCreatedChild_16);
            }
        }
        else if (this.mComponentName == Constants_1.FASlotName.BLUETOOTH) {
            If.branchId(2);
            let earlierCreatedChild_17 = this.findChildById("17");
            if (earlierCreatedChild_17 == undefined) {
                View.create(new StatusBarIconItemBluetoothComponent_1.default("17", this, {}));
            }
            else {
                earlierCreatedChild_17.updateWithValueParams({});
                View.create(earlierCreatedChild_17);
            }
        }
        else if (this.mComponentName == Constants_1.FASlotName.SIGNAL) {
            If.branchId(3);
            let earlierCreatedChild_18 = this.findChildById("18");
            if (earlierCreatedChild_18 == undefined) {
                View.create(new signalIcon_1.default("18", this, {}));
            }
            else {
                earlierCreatedChild_18.updateWithValueParams({});
                View.create(earlierCreatedChild_18);
            }
        }
        else if (this.mComponentName == Constants_1.FASlotName.CLOCK) {
            If.branchId(4);
            let earlierCreatedChild_19 = this.findChildById("19");
            if (earlierCreatedChild_19 == undefined) {
                View.create(new clockIcon_1.default("19", this, {}));
            }
            else {
                earlierCreatedChild_19.updateWithValueParams({});
                View.create(earlierCreatedChild_19);
            }
        }
        else if (this.mComponentName == Constants_1.FASlotName.BATTERY) {
            If.branchId(5);
            let earlierCreatedChild_20 = this.findChildById("20");
            if (earlierCreatedChild_20 == undefined) {
                View.create(new batteryIcon_1.default("20", this, {}));
            }
            else {
                earlierCreatedChild_20.updateWithValueParams({});
                View.create(earlierCreatedChild_20);
            }
        }
        else if (this.mComponentName == Constants_1.FASlotName.CAPSULE) {
            If.branchId(6);
            let earlierCreatedChild_21 = this.findChildById("21");
            if (earlierCreatedChild_21 == undefined) {
                View.create(new CapsuleIcon_1.default("21", this, {}));
            }
            else {
                earlierCreatedChild_21.updateWithValueParams({});
                View.create(earlierCreatedChild_21);
            }
        }
        else if (this.mComponentName == Constants_1.FASlotName.NOTIFICATION) {
            If.branchId(7);
            let earlierCreatedChild_22 = this.findChildById("22");
            if (earlierCreatedChild_22 == undefined) {
                View.create(new StatusBarNotificationIcon("22", this, {}));
            }
            else {
                earlierCreatedChild_22.updateWithValueParams({});
                View.create(earlierCreatedChild_22);
            }
        }
        else if (this.mComponentName == Constants_1.FASlotName.LOCATION) {
            If.branchId(8);
            let earlierCreatedChild_23 = this.findChildById("23");
            if (earlierCreatedChild_23 == undefined) {
                View.create(new StatusBarIconItemLocationComponent_1.default("23", this, {}));
            }
            else {
                earlierCreatedChild_23.updateWithValueParams({});
                View.create(earlierCreatedChild_23);
            }
        }
        else if (this.mComponentName == Constants_1.FASlotName.RING_MODE) {
            If.branchId(9);
            let earlierCreatedChild_24 = this.findChildById("24");
            if (earlierCreatedChild_24 == undefined) {
                View.create(new StatusBarIconItemRingModeComponent_1.default("24", this, {}));
            }
            else {
                earlierCreatedChild_24.updateWithValueParams({});
                View.create(earlierCreatedChild_24);
            }
        }
        else {
            If.branchId(10);
            let earlierCreatedChild_25 = this.findChildById("25");
            if (earlierCreatedChild_25 == undefined) {
                View.create(new IconItemComponent_1.default("25", this, {
                    keyId: this.mComponentName
                }));
            }
            else {
                earlierCreatedChild_25.updateWithValueParams({
                    keyId: this.mComponentName
                });
                View.create(earlierCreatedChild_25);
            }
        }
        If.pop();
        Row.pop();
    }
}
class StatusBarEmptyIcon extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__mStatusBarEmptyWidth = AppStorage.GetOrCreate().setAndLink("StatusBarEmptyWidth", 0, this);
        this.__mTintContentInfo = new ObservedPropertyObject(StatusBarVM_1.default.getEmptyTintContentInfo(), this, "mTintContentInfo");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
    }
    aboutToBeDeleted() {
        this.__mStatusBarEmptyWidth.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get mStatusBarEmptyWidth() {
        return this.__mStatusBarEmptyWidth.get();
    }
    set mStatusBarEmptyWidth(newValue) {
        this.__mStatusBarEmptyWidth.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG_StatusBarEmptyIcon, `aboutToAppear Start`);
        Log_1.default.showInfo(TAG_StatusBarEmptyIcon, `aboutToAppear, mStatusBarEmptyWidth: ${this.mStatusBarEmptyWidth} `);
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG_StatusBarEmptyIcon, `aboutToDisAppear`);
    }
    render() {
        Row.create();
        Row.width(ObservedObject.GetRawObject(this.mStatusBarEmptyWidth));
        Row.height('100%');
        Row.pop();
    }
}
class StatusBarNotificationIcon extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__notificationList = AppStorage.GetOrCreate().setAndLink("notificationList", [], this);
        this.__StatusCoefficient = AppStorage.GetOrCreate().setAndLink("StatusCoefficient", 1.0, this);
        this.__mTintContentInfo = new ObservedPropertyObject(StatusBarVM_1.default.getNotificationTintContentInfo(), this, "mTintContentInfo");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getStatusBarNotificationIconStyle(), this, "style");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
    }
    aboutToBeDeleted() {
        this.__notificationList.aboutToBeDeleted();
        this.__StatusCoefficient.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get notificationList() {
        return this.__notificationList.get();
    }
    set notificationList(newValue) {
        this.__notificationList.set(newValue);
    }
    get StatusCoefficient() {
        return this.__StatusCoefficient.get();
    }
    set StatusCoefficient(newValue) {
        this.__StatusCoefficient.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG_StatusBarNotificationIcon, `aboutToAppear Start`);
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG_StatusBarNotificationIcon, `aboutToDisAppear`);
    }
    render() {
        Row.create();
        Row.height('100%');
        If.create();
        if (this.notificationList.length > 0) {
            If.branchId(0);
            Row.create();
            Row.height(1);
            Row.width(this.styleCommon.statusBarMarginLeftRight);
            Row.pop();
        }
        If.pop();
        If.create();
        if (this.notificationList.length > 3) {
            If.branchId(0);
            ForEach.create("26", this, ObservedObject.GetRawObject(this.notificationList.slice(0, 3)), (item) => {
                Image.create(item[0].smallIcon);
                Image.objectFit(ImageFit.ScaleDown);
                Image.height(this.style.iconHeight);
                Image.width(this.style.iconWidth);
                Image.margin({ right: this.style.iconSpace });
                Image.fillColor(this.mTintContentInfo.contentColor);
            });
            ForEach.pop();
            Row.create();
            Text.create('...');
            Text.fontSize(this.styleCommon.statusBarFontSize);
            Text.fontColor(this.mTintContentInfo.contentColor);
            Text.pop();
            Row.pop();
        }
        else {
            If.branchId(1);
            ForEach.create("27", this, ObservedObject.GetRawObject(this.notificationList.map((item, index1) => {
                return { i: index1, data: item };
            })), (item) => {
                If.create();
                if (item.i > 0) {
                    If.branchId(0);
                    Row.create();
                    Row.height(1);
                    Row.width(this.style.iconSpace);
                    Row.pop();
                }
                If.pop();
                Image.create(item.data[0].smallIcon);
                Image.objectFit(ImageFit.ScaleDown);
                Image.height(this.style.iconHeight);
                Image.width(this.style.iconWidth);
                Image.fillColor(this.mTintContentInfo.contentColor);
            });
            ForEach.pop();
        }
        If.pop();
        If.create();
        if (this.notificationList.length > 0) {
            If.branchId(0);
            Row.create();
            Row.height(1);
            Row.width(this.styleCommon.statusBarMarginLeftRight);
            Row.pop();
        }
        If.pop();
        Row.pop();
    }
}


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\StatusBarVM.ts":
/*!***************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\statusbarcomponent\src\main\ets\com\ohos\viewmodel\StatusBarVM.ts ***!
  \***************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.StatusBarVM = exports.StatusBarEmptyWidthKey = exports.StatusBarLayoutKey = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const WindowManager_1 = __importStar(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/WindowManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\WindowManager.ts"));
const TintStateManager_1 = __importStar(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts"));
const Constants_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const Constants_2 = __webpack_require__(/*! ../common/Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const StatusBarService_1 = __importDefault(__webpack_require__(/*! ../model/StatusBarService */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\model\\StatusBarService.ts"));
exports.StatusBarLayoutKey = "StatusBarLayout";
exports.StatusBarEmptyWidthKey = "StatusBarEmptyWidth";
const TAG = 'StatusBarVM';
class StatusBarVM {
    constructor() {
        this.mIsStart = false;
        this.mStatusBarLayout = [[], [], []];
        this.mUseCount = 0;
        this.mStatusBarEnable = true;
        this.mStatusBarData = Object.assign({}, new Constants_2.StatusBarData());
        this.mComponentAreaMap = new Map();
        this.mComponentGroupContentDatas = [
            new Constants_2.StatusBarComponentGroupContentData(), new Constants_2.StatusBarComponentGroupContentData(), new Constants_2.StatusBarComponentGroupContentData()
        ];
        this.mEmptyTintContentInfo = TintStateManager_1.getOrCreateTintContentInfo(Constants_1.FASlotName.EMPTY);
        this.mNotificationTintContentInfo = TintStateManager_1.getOrCreateTintContentInfo(Constants_1.FASlotName.NOTIFICATION);
        this.mUseInWindowName = WindowManager_1.WindowType.STATUS_BAR;
        Log_1.default.showInfo(TAG, `constructor`);
        this.mStatusBarData = AppStorage.SetAndLink(TAG + '_StatusBarData', this.mStatusBarData).get();
        StatusBarService_1.default.setStatusBarData(this.mStatusBarData);
        this.mStatusBarLayout = AppStorage.SetAndLink(exports.StatusBarLayoutKey, this.mStatusBarLayout).get();
        this.mStatusBarEmptyWidth = AppStorage.SetAndLink(exports.StatusBarEmptyWidthKey, 0);
        let defaultBackgroundDatas = [];
        defaultBackgroundDatas.push(new Constants_2.StatusBarBackgroundData());
        defaultBackgroundDatas.push(new Constants_2.StatusBarBackgroundData());
        defaultBackgroundDatas.push(new Constants_2.StatusBarBackgroundData());
        if (this.mStatusBarData.showHorizontal) {
            defaultBackgroundDatas[0].width = this.mStatusBarData.realWidth;
        }
        else {
            defaultBackgroundDatas[0].width = this.mStatusBarData.realHeight;
        }
        this.mBackgroundDatas = AppStorage.SetAndLink(TAG + '_BackgroundDatas', defaultBackgroundDatas).get();
        StatusBarService_1.default.registerListener(this);
    }
    install() {
        Log_1.default.showInfo(TAG, `install, useCount: ${this.mUseCount}`);
        if (!this.mUseCount) {
            TintStateManager_1.default.getInstance().registerListener('status', this);
        }
        this.mUseCount++;
    }
    uninstall() {
        Log_1.default.showInfo(TAG, `uninstall, useCount: ${this.mUseCount}`);
        this.mUseCount--;
        if (this.mUseCount) {
            TintStateManager_1.default.getInstance().unregisterListener('status');
        }
    }
    initViewModel(config) {
        if (this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `initViewModel, config: ${JSON.stringify(config)}`);
        this.mIsStart = true;
        this.install();
        StatusBarService_1.default.startService(config);
    }
    setStatusBarLayout(layout) {
        Log_1.default.showInfo(TAG, `setStatusBarLayout, layout: ${JSON.stringify(layout)}`);
        for (let i = 0; i < layout.length; i++) {
            if (JSON.stringify(layout[i]) != JSON.stringify(this.mStatusBarLayout[i])) {
                this.mStatusBarLayout[i] = layout[i];
            }
        }
    }
    setStatusBarEmptyWidth(width) {
        Log_1.default.showInfo(TAG, `setStatusBarEmptyWidth, width: ${width}`);
        this.mStatusBarEmptyWidth.set(width);
    }
    setItemData(id, itemData) {
        Log_1.default.showInfo(TAG, `setItemData, id: ${id} itemData: ${JSON.stringify(itemData)}`);
        let storageKey = 'StatusBar_' + id;
        if (itemData) {
            AppStorage.SetOrCreate(storageKey, itemData);
        }
        else {
            let deleteRs = AppStorage.Delete(storageKey);
            Log_1.default.showInfo(TAG, `setItemData, AppStorage.Delete rs: ${deleteRs} `);
        }
    }
    onTintStateChange(tintState) {
        Log_1.default.showInfo(TAG, `onTintStateChange, tintState: ${JSON.stringify(tintState)}`);
        if (typeof (tintState.isEnable) == 'boolean') {
            this.setStatusBarEnable(tintState.isEnable);
        }
        if (tintState.backgroundColor) {
            this.changeBackground(tintState);
        }
        if (tintState.contentColor) {
            this.changeContent(tintState);
        }
    }
    setStatusBarEnable(isEnable) {
        Log_1.default.showInfo(TAG, `setStatusBarEnable, isEnable ${isEnable}`);
        if (this.mStatusBarEnable == isEnable) {
            return;
        }
        this.mStatusBarEnable = isEnable;
        this.mStatusBarEnable ? WindowManager_1.default.showWindow(WindowManager_1.WindowType.STATUS_BAR) : WindowManager_1.default.hideWindow(WindowManager_1.WindowType.STATUS_BAR);
    }
    changeBackground(tintState) {
        Log_1.default.showInfo(TAG, `changeBackground, backgroundColor: ${tintState.backgroundColor} region: ${JSON.stringify(tintState.region)}`);
        let data = new Constants_2.StatusBarBackgroundData();
        data.backgroundColor = tintState.backgroundColor;
        if (this.mStatusBarData.showHorizontal) {
            if (!tintState.region) {
                data.width = this.mStatusBarData.realWidth;
                this.mBackgroundDatas[0] = data;
                this.mBackgroundDatas[1] = new Constants_2.StatusBarBackgroundData();
                this.mBackgroundDatas[2] = new Constants_2.StatusBarBackgroundData();
            }
            else {
                data.width = tintState.region.width;
                if (tintState.region.left == this.mStatusBarData.left) {
                    this.mBackgroundDatas[0] = data;
                }
                else if ((tintState.region.left + tintState.region.width) == (this.mStatusBarData.left + this.mStatusBarData.realWidth)) {
                    this.mBackgroundDatas[2] = data;
                }
                else {
                    this.mBackgroundDatas[1] = data;
                }
            }
        }
        else {
            if (!tintState.region) {
                data.width = this.mStatusBarData.realHeight;
                this.mBackgroundDatas[0] = data;
                this.mBackgroundDatas[1] = new Constants_2.StatusBarBackgroundData();
                this.mBackgroundDatas[2] = new Constants_2.StatusBarBackgroundData();
            }
            else {
                data.width = tintState.region.height;
                if (tintState.region.top == this.mStatusBarData.top) {
                    this.mBackgroundDatas[0] = data;
                }
                else if ((tintState.region.top + tintState.region.height) == (this.mStatusBarData.top + this.mStatusBarData.realHeight)) {
                    this.mBackgroundDatas[2] = data;
                }
                else {
                    this.mBackgroundDatas[1] = data;
                }
            }
        }
        Log_1.default.showInfo(TAG, `changeBackground, data: ${JSON.stringify(data)}`);
    }
    changeContent(tintState) {
        Log_1.default.showInfo(TAG, `changeContent, contentColor: ${tintState.contentColor} region: ${JSON.stringify(tintState.region)}`);
        let data = new Constants_2.StatusBarComponentGroupContentData();
        data.contentColor = tintState.contentColor;
        if (this.mStatusBarData.showHorizontal) {
            if (!tintState.region) {
                data.width = this.mStatusBarData.realWidth;
                this.mComponentGroupContentDatas[0] = data;
                this.mComponentGroupContentDatas[1] = new Constants_2.StatusBarComponentGroupContentData();
                this.mComponentGroupContentDatas[2] = new Constants_2.StatusBarComponentGroupContentData();
            }
            else {
                data.width = tintState.region.width;
                if (tintState.region.left == this.mStatusBarData.left) {
                    this.mComponentGroupContentDatas[0] = data;
                }
                else if ((tintState.region.left + tintState.region.width) == (this.mStatusBarData.left + this.mStatusBarData.realWidth)) {
                    this.mComponentGroupContentDatas[2] = data;
                }
                else {
                    this.mComponentGroupContentDatas[1] = data;
                }
            }
        }
        else {
            if (!tintState.region) {
                data.width = this.mStatusBarData.realHeight;
                this.mComponentGroupContentDatas[0] = data;
                this.mComponentGroupContentDatas[1] = new Constants_2.StatusBarComponentGroupContentData();
                this.mComponentGroupContentDatas[2] = new Constants_2.StatusBarComponentGroupContentData();
            }
            else {
                data.width = tintState.region.height;
                if (tintState.region.top == this.mStatusBarData.top) {
                    this.mComponentGroupContentDatas[0] = data;
                }
                else if ((tintState.region.top + tintState.region.height) == (this.mStatusBarData.top + this.mStatusBarData.realHeight)) {
                    this.mComponentGroupContentDatas[2] = data;
                }
                else {
                    this.mComponentGroupContentDatas[1] = data;
                }
            }
        }
        Log_1.default.showInfo(TAG, `changeContent, data: ${JSON.stringify(data)}`);
        this.mComponentAreaMap.forEach((value, key) => {
            this.changeComponentContent(key, value);
        });
    }
    changeComponentContent(id, area) {
        Log_1.default.showInfo(TAG, `changeComponentContent, id ${id} area: ${JSON.stringify(area)}`);
        if (this.mUseInWindowName != WindowManager_1.WindowType.STATUS_BAR) {
            this.setComponentContent(id, '#FFFFFFFF');
            return;
        }
        if ((this.mStatusBarData.showHorizontal && area.width == 0) || (!this.mStatusBarData.showHorizontal && area.height == 0)) {
            this.setComponentContent(id, '#FFFFFFFF');
            return;
        }
        let startPos = this.mStatusBarData.showHorizontal ? this.mStatusBarData.left : this.mStatusBarData.top;
        for (let group of this.mComponentGroupContentDatas) {
            if (group.width == 0) {
                continue;
            }
            let endPos = group.width + startPos;
            let componentStartPos;
            let componentEndPos;
            if (this.mStatusBarData.showHorizontal) {
                componentStartPos = area.left;
                componentEndPos = area.left + area.width;
            }
            else {
                componentStartPos = area.top;
                componentEndPos = area.top + area.height;
            }
            if (!(componentEndPos <= startPos) && !(componentStartPos >= endPos)) {
                this.setComponentContent(id, group.contentColor);
                break;
            }
            startPos = endPos;
        }
    }
    setComponentContent(id, contentColor) {
        Log_1.default.showInfo(TAG, `setComponentContent, id ${id} contentColor: ${contentColor}`);
        TintStateManager_1.getOrCreateTintContentInfo(id).contentColor = contentColor;
    }
    updateComponentArea(id, area) {
        Log_1.default.showInfo(TAG, `updateComponentArea, id ${id} area: ${JSON.stringify(area)}`);
        let areaInfo = {
            left: vp2px(area.globalPosition.x),
            top: vp2px(area.globalPosition.y),
            width: vp2px(area.width),
            height: vp2px(area.height)
        };
        this.mComponentAreaMap.set(id, areaInfo);
        this.changeComponentContent(id, areaInfo);
    }
    setUseInWindowName(name) {
        Log_1.default.showInfo(TAG, `setUseInWindowName, name ${name}`);
        this.mUseInWindowName = name;
        this.mComponentAreaMap.forEach((value, key) => {
            this.changeComponentContent(key, value);
        });
    }
    getStatusBarData() {
        return this.mStatusBarData;
    }
    updateStatusBarData(data) {
        Log_1.default.showInfo(TAG, `updateStatusBarData, data: ${JSON.stringify(data)}`);
        for (let key in data) {
            this.mStatusBarData[key] = data[key];
        }
    }
    getEmptyTintContentInfo() {
        return this.mEmptyTintContentInfo;
    }
    getNotificationTintContentInfo() {
        return this.mNotificationTintContentInfo;
    }
    getPluginTintContentInfo(id) {
        return TintStateManager_1.getOrCreateTintContentInfo(id);
    }
    getBackgroundDatas() {
        return this.mBackgroundDatas;
    }
}
exports.StatusBarVM = StatusBarVM;
let sStatusBarVM = SingleInstanceHelper_1.default(StatusBarVM, TAG);
exports["default"] = sStatusBarVM;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\WifiModel.ts":
/*!*********************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\wificomponent\src\main\ets\default\WifiModel.ts ***!
  \*********************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.WifiModel = void 0;
var wifi = globalThis.requireNapi('wifi') || (isSystemplugin('wifi', 'ohos') ? globalThis.ohosplugin.wifi : isSystemplugin('wifi', 'system') ? globalThis.systemplugin.wifi : undefined);
const constants_1 = __importStar(__webpack_require__(/*! ./common/constants */ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\common\\constants.ts"));
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const TAG = 'WifiComponent-WifiModel';
var mWifiInfo;
var mWifiStatus;
var mWifiOpenStatus;
var mWifiName;
class WifiModel {
    constructor() {
        this.mIsStart = false;
        this.mListener = null;
    }
    initWifiModel() {
        if (this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `initWifiModel`);
        this.mIsStart = true;
        mWifiInfo = AppStorage.SetAndLink("wifiInfo", constants_1.default.DEFAULT_WIFI_INFO);
        mWifiStatus = AppStorage.SetAndLink("wifiStatus", constants_1.default.DEFAULT_WIFI_STATUS);
        mWifiName = AppStorage.SetAndLink("wifiName", constants_1.default.DEFAULT_WIFI_NAME);
        mWifiOpenStatus = AppStorage.SetAndLink("wifiOpenStatus", constants_1.default.DEFAULT_WIFI_OPEN_STATUS);
        this.getWifiInfo();
        wifi.on('wifiStateChange', this.onWifiStateChange.bind(this));
        wifi.on('wifiConnectionChange', this.onWifiConnectionChange.bind(this));
        wifi.on('wifiRssiChange', this.onWifiRssiChange.bind(this));
    }
    uninitWifiModel() {
        if (!this.mIsStart) {
            return;
        }
        Log_1.default.showInfo(TAG, `uninitWifiModel`);
        this.mIsStart = false;
        this.mListener.off('wifiRssiChange', (data) => {
            Log_1.default.showInfo(TAG, `uninitWifiModel->wifiRssiChange, data: ${JSON.stringify(data)}`);
        });
        this.mListener.off('wifiConnectionChange', (data) => {
            Log_1.default.showInfo(TAG, `uninitWifiModel->wifiConnectionChange, data: ${JSON.stringify(data)}`);
        });
        this.mListener.off('wifiStateChange', (data) => {
            Log_1.default.showInfo(TAG, `uninitWifiModel->wifiStateChange, data: ${JSON.stringify(data)}`);
        });
        this.mListener = null;
        mWifiOpenStatus.set(constants_1.default.DEFAULT_WIFI_OPEN_STATUS);
        this.setDisconnectedStatus();
    }
    onWifiStateChange(data) {
        Log_1.default.showInfo(TAG, `onWifiStateChange, data: ${JSON.stringify(data)}`);
        let isWifiInactive = data == constants_1.WifiState.STATE_OFF;
        mWifiOpenStatus.set(!isWifiInactive);
        if (!isWifiInactive) {
            this.getWifiConnectInfo();
        }
        else {
            this.setDisconnectedStatus();
        }
    }
    onWifiConnectionChange(data) {
        Log_1.default.showInfo(TAG, `onWifiConnectionChange, data: ${JSON.stringify(data)}`);
        if (data == constants_1.WifiConnectionState.CONNECTED) {
            this.getLinkedInfo();
        }
        else {
            this.setDisconnectedStatus();
        }
    }
    onWifiRssiChange(data) {
        Log_1.default.showInfo(TAG, `onWifiRssiChange, data: ${JSON.stringify(data)}`);
        this.getLinkedInfo();
    }
    getWifiInfo() {
        Log_1.default.showInfo(TAG, `getWifiInfo`);
        let isWifiActive = wifi.isWifiActive();
        Log_1.default.showInfo(TAG, `getWifiInfo, isWifiActive: ${isWifiActive}`);
        mWifiOpenStatus.set(isWifiActive);
        if (isWifiActive) {
            this.getWifiConnectInfo();
        }
        else {
            this.setDisconnectedStatus();
        }
    }
    getWifiConnectInfo() {
        Log_1.default.showInfo(TAG, `getWifiConnectInfo`);
        let isConnected = wifi.isConnected();
        Log_1.default.showInfo(TAG, `getWifiConnectInfo, isConnected: ${isConnected}`);
        if (isConnected) {
            mWifiStatus.set(true);
            this.getLinkedInfo();
        }
        else {
            this.setDisconnectedStatus();
        }
    }
    getLinkedInfo() {
        Log_1.default.showInfo(TAG, `getLinkedInfo`);
        wifi.getLinkedInfo((err, data) => {
            if (wifi.isConnected()) {
                mWifiStatus.set(true);
                mWifiName.set(data.ssid);
                let signalLevel = wifi.getSignalLevel(data.rssi, data.band);
                Log_1.default.showInfo(TAG, `getLinkedInfo, signalLevel: ${signalLevel}`);
                mWifiInfo.set(signalLevel);
            }
            else {
                this.setDisconnectedStatus();
            }
        });
    }
    setDisconnectedStatus() {
        Log_1.default.showInfo(TAG, `setDisconnectedStatus`);
        mWifiStatus.set(constants_1.default.DEFAULT_WIFI_STATUS);
        mWifiInfo.set(constants_1.default.DEFAULT_WIFI_INFO);
        mWifiName.set(constants_1.default.DEFAULT_WIFI_NAME);
    }
    enableWifi() {
        Log_1.default.showInfo(TAG, 'enableWifi');
        let result = wifi.enableWifi();
        Log_1.default.showInfo(TAG, `enableWifi, result: ${result}`);
    }
    disableWifi() {
        Log_1.default.showInfo(TAG, 'disableWifi');
        let result = wifi.disableWifi();
        Log_1.default.showInfo(TAG, `disableWifi, result: ${result}`);
    }
}
exports.WifiModel = WifiModel;
let mWifiModel = new WifiModel();
exports["default"] = mWifiModel;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\common\\Constants.ts":
/*!****************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\wificomponent\src\main\ets\default\common\Constants.ts ***!
  \****************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.WifiConnectionState = exports.WifiState = void 0;
class constants {
}
exports["default"] = constants;
constants.DEFAULT_WIFI_OPEN_STATUS = false;
constants.DEFAULT_WIFI_NAME = 'WLAN';
constants.DEFAULT_WIFI_INFO = 0;
constants.DEFAULT_WIFI_STATUS = false;
constants.WIFI_SIGNAL_NO = 0;
constants.WIFI_SIGNAL_LOW = 1;
constants.WIFI_SIGNAL_MID = 2;
constants.WIFI_SIGNAL_HIGH = 3;
constants.WIFI_SIGNAL_FULL = 4;
var WifiState;
(function (WifiState) {
    WifiState[WifiState["STATE_OFF"] = 0] = "STATE_OFF";
    WifiState[WifiState["STATE_ON"] = 1] = "STATE_ON";
    WifiState[WifiState["STATE_TURNING_ON"] = 2] = "STATE_TURNING_ON";
    WifiState[WifiState["STATE_TURNING_OFF"] = 3] = "STATE_TURNING_OFF";
})(WifiState = exports.WifiState || (exports.WifiState = {}));
var WifiConnectionState;
(function (WifiConnectionState) {
    WifiConnectionState[WifiConnectionState["DISCONNECTED"] = 0] = "DISCONNECTED";
    WifiConnectionState[WifiConnectionState["CONNECTED"] = 1] = "CONNECTED";
})(WifiConnectionState = exports.WifiConnectionState || (exports.WifiConnectionState = {}));


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts":
/*!*************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\wificomponent\src\main\ets\default\common\StyleConfiguration.ts ***!
  \*************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const StyleManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
__webpack_require__(/*! ./Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\common\\Constants.ts");
const TAG = 'wifi-StyleConfiguration';
class StyleConfiguration {
    static getStartsBarWifiComponentStyle() {
        const key = TAG + "-startsBarWifi";
        return StyleManager_1.default.getStyle(key, () => {
            return {
                statusBarWifiWidth: { "id": 201326643, "type": 10002, params: [] },
                statusBarWifiHeight: { "id": 201326642, "type": 10002, params: [] }
            };
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\common\\constants.ts":
/*!****************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\wificomponent\src\main\ets\default\common\constants.ts ***!
  \****************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.WifiConnectionState = exports.WifiState = void 0;
class constants {
}
exports["default"] = constants;
constants.DEFAULT_WIFI_OPEN_STATUS = false;
constants.DEFAULT_WIFI_NAME = 'WLAN';
constants.DEFAULT_WIFI_INFO = 0;
constants.DEFAULT_WIFI_STATUS = false;
constants.WIFI_SIGNAL_NO = 0;
constants.WIFI_SIGNAL_LOW = 1;
constants.WIFI_SIGNAL_MID = 2;
constants.WIFI_SIGNAL_HIGH = 3;
constants.WIFI_SIGNAL_FULL = 4;
var WifiState;
(function (WifiState) {
    WifiState[WifiState["STATE_OFF"] = 0] = "STATE_OFF";
    WifiState[WifiState["STATE_ON"] = 1] = "STATE_ON";
    WifiState[WifiState["STATE_TURNING_ON"] = 2] = "STATE_TURNING_ON";
    WifiState[WifiState["STATE_TURNING_OFF"] = 3] = "STATE_TURNING_OFF";
})(WifiState = exports.WifiState || (exports.WifiState = {}));
var WifiConnectionState;
(function (WifiConnectionState) {
    WifiConnectionState[WifiConnectionState["DISCONNECTED"] = 0] = "DISCONNECTED";
    WifiConnectionState[WifiConnectionState["CONNECTED"] = 1] = "CONNECTED";
})(WifiConnectionState = exports.WifiConnectionState || (exports.WifiConnectionState = {}));


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\pages\\wifiIcon.ets":
/*!***************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\wificomponent\src\main\ets\default\pages\wifiIcon.ets ***!
  \***************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const constants_1 = __importDefault(__webpack_require__(/*! ../common/constants */ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\common\\constants.ts"));
const WifiModel_1 = __importDefault(__webpack_require__(/*! ../WifiModel */ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\WifiModel.ts"));
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const StyleConfiguration_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleConfiguration.ts"));
const StyleConfiguration_2 = __importDefault(__webpack_require__(/*! ../common/StyleConfiguration */ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\common\\StyleConfiguration.ts"));
const WifiVM_1 = __importDefault(__webpack_require__(/*! ../viewmodel/WifiVM */ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\viewmodel\\WifiVM.ts"));
const TAG = 'WifiComponent-WifiIcon';
class WifiIcon extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.__wifiInfo = AppStorage.GetOrCreate().setAndLink("wifiInfo", constants_1.default.DEFAULT_WIFI_INFO, this);
        this.__wifiStatus = AppStorage.GetOrCreate().setAndLink("wifiStatus", constants_1.default.DEFAULT_WIFI_STATUS, this);
        this.__mTintContentInfo = new ObservedPropertyObject(WifiVM_1.default.getTintContentInfo(), this, "mTintContentInfo");
        this.__styleCommon = new ObservedPropertyObject(StyleConfiguration_1.default.getCommonStyle(), this, "styleCommon");
        this.__style = new ObservedPropertyObject(StyleConfiguration_2.default.getStartsBarWifiComponentStyle(), this, "style");
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.mTintContentInfo !== undefined) {
            this.mTintContentInfo = params.mTintContentInfo;
        }
        if (params.styleCommon !== undefined) {
            this.styleCommon = params.styleCommon;
        }
        if (params.style !== undefined) {
            this.style = params.style;
        }
    }
    aboutToBeDeleted() {
        this.__wifiInfo.aboutToBeDeleted();
        this.__wifiStatus.aboutToBeDeleted();
        this.__mTintContentInfo.aboutToBeDeleted();
        this.__styleCommon.aboutToBeDeleted();
        this.__style.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get wifiInfo() {
        return this.__wifiInfo.get();
    }
    set wifiInfo(newValue) {
        this.__wifiInfo.set(newValue);
    }
    get wifiStatus() {
        return this.__wifiStatus.get();
    }
    set wifiStatus(newValue) {
        this.__wifiStatus.set(newValue);
    }
    get mTintContentInfo() {
        return this.__mTintContentInfo.get();
    }
    set mTintContentInfo(newValue) {
        this.__mTintContentInfo.set(newValue);
    }
    get styleCommon() {
        return this.__styleCommon.get();
    }
    set styleCommon(newValue) {
        this.__styleCommon.set(newValue);
    }
    get style() {
        return this.__style.get();
    }
    set style(newValue) {
        this.__style.set(newValue);
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, `aboutToAppear`);
        WifiModel_1.default.initWifiModel();
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, `aboutToDisappear`);
    }
    render() {
        Row.create();
        Row.height('100%');
        If.create();
        if (this.wifiStatus) {
            If.branchId(0);
            Row.create();
            Row.width(this.styleCommon.statusBarMarginLeftRight);
            Row.height('100%');
            Row.pop();
            Image.create(this.getImage(this.wifiInfo));
            Image.objectFit(ImageFit.Contain);
            Image.width(this.style.statusBarWifiWidth);
            Image.height(this.style.statusBarWifiHeight);
            Image.fillColor(this.mTintContentInfo.contentColor);
            Row.create();
            Row.width(this.styleCommon.statusBarMarginLeftRight);
            Row.height('100%');
            Row.pop();
        }
        If.pop();
        Row.pop();
    }
    getImage(wifiInfo) {
        Log_1.default.showInfo(TAG, `getImage, wifiInfo: ${JSON.stringify(wifiInfo)}`);
        let wifiImage;
        switch (wifiInfo) {
            case constants_1.default.WIFI_SIGNAL_NO:
                wifiImage = { "id": 201326662, "type": 20000, params: [] };
                break;
            case constants_1.default.WIFI_SIGNAL_LOW:
                wifiImage = { "id": 201326657, "type": 20000, params: [] };
                break;
            case constants_1.default.WIFI_SIGNAL_MID:
                wifiImage = { "id": 201326658, "type": 20000, params: [] };
                break;
            case constants_1.default.WIFI_SIGNAL_HIGH:
                wifiImage = { "id": 201326659, "type": 20000, params: [] };
                break;
            case constants_1.default.WIFI_SIGNAL_FULL:
                wifiImage = { "id": 201326661, "type": 20000, params: [] };
                break;
            default:
                wifiImage = { "id": 201326662, "type": 20000, params: [] };
                break;
        }
        return wifiImage;
    }
}
exports["default"] = WifiIcon;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\features\\wificomponent\\src\\main\\ets\\default\\viewmodel\\WifiVM.ts":
/*!****************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\features\wificomponent\src\main\ets\default\viewmodel\WifiVM.ts ***!
  \****************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.WifiVM = void 0;
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const Constants_1 = __webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Constants.ts");
const TintStateManager_1 = __webpack_require__(/*! ../../../../../../../common/src/main/ets/default/TintStateManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\TintStateManager.ts");
const SingleInstanceHelper_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/SingleInstanceHelper */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\SingleInstanceHelper.ts"));
const TAG = 'WifiVM';
class WifiVM {
    constructor() {
        this.mTintContentInfo = TintStateManager_1.getOrCreateTintContentInfo(Constants_1.FASlotName.WIFI);
        Log_1.default.showInfo(TAG, `constructor`);
    }
    getTintContentInfo() {
        return this.mTintContentInfo;
    }
}
exports.WifiVM = WifiVM;
let sWifiVM = SingleInstanceHelper_1.default(WifiVM, TAG);
exports["default"] = sWifiVM;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\product\\phone\\statusbar\\src\\main\\ets\\pages\\common\\StatusbarConfig.ts":
/*!*********************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\product\phone\statusbar\src\main\ets\pages\common\StatusbarConfig.ts ***!
  \*********************************************************************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const constants_1 = __webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/constants */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\constants.ts");
const StatusbarConfig = {
    LayoutGroups: [
        {
            id: 1,
            Components: [
                constants_1.FASlotName.SIGNAL,
                constants_1.FASlotName.WIFI,
                constants_1.FASlotName.CAPSULE,
                constants_1.FASlotName.NOTIFICATION,
            ],
        },
        {
            id: 2,
            Components: [],
        },
        {
            id: 3,
            Components: [
                "testid",
                constants_1.FASlotName.LOCATION,
                constants_1.FASlotName.BLUETOOTH,
                constants_1.FASlotName.RING_MODE,
                constants_1.FASlotName.BATTERY,
                constants_1.FASlotName.CLOCK,
            ],
        },
    ],
    LocalSlots: [
        constants_1.FASlotName.BATTERY,
        constants_1.FASlotName.BLUETOOTH,
        constants_1.FASlotName.CAPSULE,
        constants_1.FASlotName.CLOCK,
        constants_1.FASlotName.LOCATION,
        constants_1.FASlotName.NOTIFICATION,
        constants_1.FASlotName.RING_MODE,
        constants_1.FASlotName.SIGNAL,
        constants_1.FASlotName.WIFI,
    ],
    MetaSlots: [
        {
            id: "testid",
            bundleName: "com.example.test_app_id",
            abilityName: "com.example.test_app_id.MainAbility",
        },
    ],
    emptyPosition: {
        x1: 0,
        y1: 0,
        x2: 0,
        y2: 0,
    },
    dropdownRanges: {
        notification: {
            startPosition: 0,
            endPosition: 0.5
        },
        control: {
            startPosition: 0.5,
            endPosition: 1
        },
    }
};
exports["default"] = StatusbarConfig;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\product\\phone\\statusbar\\src\\main\\ets\\pages\\common\\StyleManager.ts":
/*!******************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\product\phone\statusbar\src\main\ets\pages\common\StyleManager.ts ***!
  \******************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\log.ts"));
const abilitymanager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/abilitymanager/abilitymanager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\abilitymanager\\abilitymanager.ts"));
__webpack_require__(/*! ./styleconfiguration */ "D:\\code\\release\\my\\applications_systemui\\product\\phone\\statusbar\\src\\main\\ets\\pages\\common\\styleconfiguration.ts");
const TAG = 'StatusBar-StyleManager';
class StyleManager {
    static setStyle() {
        log_1.default.showInfo(TAG, `setStyle`);
        let config = abilitymanager_1.default.getAbilityData(abilitymanager_1.default.ABILITY_NAME_STATUS_BAR, 'config');
        StyleManager.maxWidth = config.maxWidth;
        // xxx
        {
        }
    }
    static number2px(n) {
        return n.toString() + 'px';
    }
    static calcScaleSize(n) {
        return n * StyleManager.maxWidth / StyleManager.STANDARD_DISPLAY_WIDTH;
    }
    static calcScaleSizePx(n) {
        return StyleManager.number2px(StyleManager.calcScaleSize(n));
    }
}
exports["default"] = StyleManager;
StyleManager.STANDARD_DISPLAY_WIDTH = 720;
StyleManager.STANDARD_DISPLAY_HEIGHT = 1280;
StyleManager.maxWidth = StyleManager.STANDARD_DISPLAY_WIDTH;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\product\\phone\\statusbar\\src\\main\\ets\\pages\\common\\constants.ts":
/*!***************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\product\phone\statusbar\src\main\ets\pages\common\constants.ts ***!
  \***************************************************************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", ({ value: true }));
class Constants {
}
exports["default"] = Constants;
Constants.TOUCHTYPE_DOWN = 0;
Constants.TOUCHTYPE_UP = 1;
Constants.TOUCHTYPE_MOVE = 2;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\product\\phone\\statusbar\\src\\main\\ets\\pages\\common\\styleconfiguration.ts":
/*!************************************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\product\phone\statusbar\src\main\ets\pages\common\styleconfiguration.ts ***!
  \************************************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const stylemanager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../../common/src/main/ets/default/stylemanager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\stylemanager.ts"));
const TAG = 'StatusBar-StyleConfiguration';
class StyleConfiguration {
    static getIndexStyle() {
        const key = TAG + "-Index";
        return stylemanager_1.default.getStyle(key, () => {
            return {};
        });
    }
}
exports["default"] = StyleConfiguration;


/***/ }),

/***/ "D:\\code\\release\\my\\applications_systemui\\product\\phone\\statusbar\\src\\main\\ets\\pages\\index.ets?entry":
/*!***********************************************************************************************************!*\
  !*** D:\code\release\my\applications_systemui\product\phone\statusbar\src\main\ets\pages\index.ets?entry ***!
  \***********************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
/*
 * Copyright (c) 2021-2022 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Log_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/Log */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\Log.ts"));
const WindowManager_1 = __importStar(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/WindowManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\WindowManager.ts"));
const EventManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/event/EventManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventManager.ts"));
const EventUtil_1 = __webpack_require__(/*! ../../../../../../../common/src/main/ets/default/event/EventUtil */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\event\\EventUtil.ts");
const StyleManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\StyleManager.ts"));
const HeightConfigUtils_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/heightcofigUtils/HeightConfigUtils */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\heightcofigUtils\\HeightConfigUtils.ts"));
const StatusBarComponent_1 = __importDefault(__webpack_require__(/*! ../../../../../../../features/statusbarcomponent/src/main/ets/com/ohos/pages/StatusBarComponent */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\pages\\StatusBarComponent.ets"));
const StatusBarVM_1 = __importDefault(__webpack_require__(/*! ../../../../../../../features/statusbarcomponent/src/main/ets/com/ohos/viewmodel/StatusBarVM */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\viewmodel\\StatusBarVM.ts"));
const Constants_1 = __webpack_require__(/*! ../../../../../../../features/statusbarcomponent/src/main/ets/com/ohos/common/Constants */ "D:\\code\\release\\my\\applications_systemui\\features\\statusbarcomponent\\src\\main\\ets\\com\\ohos\\common\\Constants.ts");
const constants_1 = __importDefault(__webpack_require__(/*! ./common/constants */ "D:\\code\\release\\my\\applications_systemui\\product\\phone\\statusbar\\src\\main\\ets\\pages\\common\\constants.ts"));
const StyleManager_2 = __importDefault(__webpack_require__(/*! ./common/StyleManager */ "D:\\code\\release\\my\\applications_systemui\\product\\phone\\statusbar\\src\\main\\ets\\pages\\common\\StyleManager.ts"));
const StatusbarConfig_1 = __importDefault(__webpack_require__(/*! ./common/StatusbarConfig */ "D:\\code\\release\\my\\applications_systemui\\product\\phone\\statusbar\\src\\main\\ets\\pages\\common\\StatusbarConfig.ts"));
const abilityManager_1 = __importDefault(__webpack_require__(/*! ../../../../../../../common/src/main/ets/default/abilitymanager/abilityManager */ "D:\\code\\release\\my\\applications_systemui\\common\\src\\main\\ets\\default\\abilitymanager\\abilityManager.ts"));
const TAG = 'StatusBar-Index';
const SLIDING_STATUS_BAR_DISTANCE = 30;
let mHeightConfigUtils;
class Index extends View {
    constructor(compilerAssignedUniqueChildId, parent, params) {
        super(compilerAssignedUniqueChildId, parent);
        this.startX = 0;
        this.startY = 0;
        this.__moveX = new ObservedPropertySimple(0, this, "moveX");
        this.__moveY = new ObservedPropertySimple(0, this, "moveY");
        this.__mStatusBarData = new ObservedPropertyObject(new Constants_1.StatusBarData(), this, "mStatusBarData");
        this.__StatusMinH = AppStorage.GetOrCreate().setAndLink("StatusMinH", 24, this);
        this.__StatusCoefficient = AppStorage.GetOrCreate().setAndLink("StatusCoefficient", 1.0, this);
        this.mClearCallback = undefined;
        this.updateWithValueParams(params);
    }
    updateWithValueParams(params) {
        if (params.startX !== undefined) {
            this.startX = params.startX;
        }
        if (params.startY !== undefined) {
            this.startY = params.startY;
        }
        if (params.moveX !== undefined) {
            this.moveX = params.moveX;
        }
        if (params.moveY !== undefined) {
            this.moveY = params.moveY;
        }
        if (params.mStatusBarData !== undefined) {
            this.mStatusBarData = params.mStatusBarData;
        }
        if (params.mClearCallback !== undefined) {
            this.mClearCallback = params.mClearCallback;
        }
    }
    aboutToBeDeleted() {
        this.__moveX.aboutToBeDeleted();
        this.__moveY.aboutToBeDeleted();
        this.__mStatusBarData.aboutToBeDeleted();
        this.__StatusMinH.aboutToBeDeleted();
        this.__StatusCoefficient.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id());
    }
    get moveX() {
        return this.__moveX.get();
    }
    set moveX(newValue) {
        this.__moveX.set(newValue);
    }
    get moveY() {
        return this.__moveY.get();
    }
    set moveY(newValue) {
        this.__moveY.set(newValue);
    }
    get mStatusBarData() {
        return this.__mStatusBarData.get();
    }
    set mStatusBarData(newValue) {
        this.__mStatusBarData.set(newValue);
    }
    get StatusMinH() {
        return this.__StatusMinH.get();
    }
    set StatusMinH(newValue) {
        this.__StatusMinH.set(newValue);
    }
    get StatusCoefficient() {
        return this.__StatusCoefficient.get();
    }
    set StatusCoefficient(newValue) {
        this.__StatusCoefficient.set(newValue);
    }
    onBackPress() {
        return true;
    }
    aboutToAppear() {
        Log_1.default.showInfo(TAG, `aboutToAppear, start`);
        let configInfo = abilityManager_1.default.getAbilityData(abilityManager_1.default.ABILITY_NAME_STATUS_BAR, 'config');
        let statusBarData = new Constants_1.StatusBarData();
        statusBarData.displayWidth = configInfo.maxWidth;
        statusBarData.displayHeight = configInfo.maxHeight;
        statusBarData.showHorizontal = configInfo.showHorizontal;
        statusBarData.ableToMaximize = configInfo.ableToMaximize;
        statusBarData.realWidth = configInfo.realWidth;
        statusBarData.realHeight = configInfo.realHeight;
        statusBarData.left = configInfo.xCoordinate;
        statusBarData.top = configInfo.yCoordinate;
        StatusBarVM_1.default.updateStatusBarData(statusBarData);
        this.mStatusBarData = StatusBarVM_1.default.getStatusBarData();
        setAppBgColor('#00000000');
        StyleManager_1.default.setAbilityPageName(TAG);
        StyleManager_2.default.setStyle();
        this.mClearCallback = EventManager_1.default.subscribe(WindowManager_1.WINDOW_SHOW_HIDE_EVENT, (args) => this.onWindowShowHideEvent(args));
        mHeightConfigUtils = new HeightConfigUtils_1.default();
        let StatusMinH;
        let StatusCoefficient;
        StatusMinH = AppStorage.SetAndLink("StatusMinH", 24);
        StatusCoefficient = AppStorage.SetAndLink("StatusCoefficient", 1.0);
        StatusMinH.set(mHeightConfigUtils.getStatusMinH());
        StatusCoefficient.set(mHeightConfigUtils.getStatusCoefficient());
        let signalObserved = AppStorage.SetAndLink("signalObserved", false);
        signalObserved.set(false);
        Log_1.default.showInfo(TAG, `aboutToAppear, end`);
    }
    aboutToDisappear() {
        Log_1.default.showInfo(TAG, `aboutToDisappear`);
        this.mClearCallback && this.mClearCallback();
        this.mClearCallback = undefined;
    }
    render() {
        Flex.create({ direction: FlexDirection.Column, alignItems: ItemAlign.Center, justifyContent: FlexAlign.Center });
        Flex.width('100%');
        Flex.height('100%');
        Flex.constraintSize({ minHeight: this.StatusMinH + 'px' });
        Flex.padding(this.mStatusBarData.showHorizontal ?
            { left: { "id": 125829724, "type": 10002, params: [] }, right: { "id": 125829726, "type": 10002, params: [] } } : { left: '0' });
        Flex.onAreaChange((e, e2) => {
            Log_1.default.showInfo(TAG, `onAreaChange, e: ${JSON.stringify(e)} e2: ${JSON.stringify(e2)}`);
        });
        Flex.create({ direction: FlexDirection.Row, alignItems: ItemAlign.Center, justifyContent: FlexAlign.Center });
        Flex.width('100%');
        Flex.height('100%');
        Flex.onTouch(this.touchEvent.bind(this));
        let earlierCreatedChild_2 = this.findChildById("2");
        if (earlierCreatedChild_2 == undefined) {
            View.create(new StatusBarComponent_1.default("2", this, {
                mStatusBarComponentConfig: StatusbarConfig_1.default,
            }));
        }
        else {
            earlierCreatedChild_2.updateWithValueParams({
                mStatusBarComponentConfig: StatusbarConfig_1.default
            });
            View.create(earlierCreatedChild_2);
        }
        Flex.pop();
        Flex.pop();
    }
    touchEvent(event) {
        Log_1.default.showInfo(TAG, 'touchEvent================' + event.touches);
        if (event.type == constants_1.default.TOUCHTYPE_DOWN) { //down
            this.startX = event.touches[0].screenX;
            this.startY = event.touches[0].screenY;
            Log_1.default.showInfo(TAG, `touchStart=======startX: ${this.startX}, startY: ${this.startY}`);
        }
        else if (event.type == constants_1.default.TOUCHTYPE_MOVE) { //move
            this.moveX = event.touches[0].screenX - this.startX;
            this.moveY = event.touches[0].screenY - this.startY;
        }
        else if (event.type == constants_1.default.TOUCHTYPE_UP) { //up
            Log_1.default.showInfo(TAG, `touchEnd, moveX: ${this.moveX}, moveY: ${this.moveY}`);
            if (this.moveY > SLIDING_STATUS_BAR_DISTANCE) {
                this.onDropdown();
                this.moveY = 0;
            }
        }
    }
    onDropdown() {
        Log_1.default.showInfo(TAG, `onDropdown`);
        if (!this.mStatusBarData.showHorizontal || !this.mStatusBarData.ableToMaximize) {
            return;
        }
        let dropdownArea = null;
        if (this.checkDropdownShowStatus(StatusbarConfig_1.default.dropdownRanges.notification)) {
            dropdownArea = 'left';
        }
        else if (this.checkDropdownShowStatus(StatusbarConfig_1.default.dropdownRanges.control)) {
            dropdownArea = 'right';
        }
        if (dropdownArea) {
            EventManager_1.default.publish(EventUtil_1.obtainLocalEvent('DropdownEvent', {
                dropdownArea: dropdownArea
            }));
        }
    }
    checkDropdownShowStatus(range) {
        let rangeStartX = this.mStatusBarData.realWidth * range.startPosition + this.mStatusBarData.left;
        let rangeEndX = this.mStatusBarData.realWidth * range.endPosition + this.mStatusBarData.left;
        return (vp2px(this.startX) >= rangeStartX) && (vp2px(this.startX) <= rangeEndX);
    }
    onWindowShowHideEvent(args) {
        Log_1.default.showInfo(TAG, `onWindowShowHideEvent, args: ${JSON.stringify(args)}`);
        if (args.windowName == WindowManager_1.WindowType.DROPDOWN_PANEL) {
            if (args.isShow) {
                WindowManager_1.default.hideWindow(WindowManager_1.WindowType.STATUS_BAR);
            }
            else {
                StatusBarVM_1.default.setUseInWindowName(WindowManager_1.WindowType.STATUS_BAR);
                WindowManager_1.default.showWindow(WindowManager_1.WindowType.STATUS_BAR);
            }
        }
    }
}
loadDocument(new Index("1", undefined, {}));


/***/ }),

/***/ "../../api/ability/dataAbilityHelper.d.ts":
/*!************************************************!*\
  !*** ../../api/ability/dataAbilityHelper.d.ts ***!
  \************************************************/
/***/ (() => {



/***/ }),

/***/ "../../api/application/ServiceExtensionContext.d.ts":
/*!**********************************************************!*\
  !*** ../../api/application/ServiceExtensionContext.d.ts ***!
  \**********************************************************/
/***/ (() => {



/***/ }),

/***/ "../../api/commonEvent/commonEventData.d.ts":
/*!**************************************************!*\
  !*** ../../api/commonEvent/commonEventData.d.ts ***!
  \**************************************************/
/***/ (() => {



/***/ }),

/***/ "../../api/commonEvent/commonEventSubscriber.d.ts":
/*!********************************************************!*\
  !*** ../../api/commonEvent/commonEventSubscriber.d.ts ***!
  \********************************************************/
/***/ (() => {



/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		var commonCachedModule = globalThis["__common_module_cache__"] ? globalThis["__common_module_cache__"][moduleId]: null;
/******/ 		if (commonCachedModule) { return commonCachedModule.exports; }
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		if (globalThis["__common_module_cache__"] && moduleId.indexOf("?name=") < 0 && Object.keys(globalThis["__common_module_cache__"]).indexOf(moduleId) >= 0) {
/******/ 		  globalThis["__common_module_cache__"][moduleId] = module;
/******/ 		}
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("D:\\code\\release\\my\\applications_systemui\\product\\phone\\statusbar\\src\\main\\ets\\pages\\index.ets?entry");
/******/ 	
/******/ })()
;
//# sourceMappingURL=index.js.map